'****************Listrik01 LCD Display Steuerung Version 03 *****************

'ACHTUNG: AVRISP mkII Device clock darf nicht grer 500.000 KHz sein sonst wird die CPU nicht erkannt!!

$hwstack = 256
$swstack = 256
$framesize = 128
$regfile = "m2561def.dat"                                   'ATMEGA2561 CPU
const F_CPU = 16000000
$crystal = F_CPU

'( Siehe http://eleccelerator.com/fusecalc/fusecalc.php?chip=atmega2561
Fuse Bits:
BODLEVEL = Disabled
OCDEN = Disabled
JTAGEN = Disabled
Spien = Enabled
WDTON = Disabled
EESAVE = Enabled
BOOTSZ = 4096W_1F000
BOOTRST = Disabled
CKDIV8 = Disabled
CKOUT = Disabled
Sut_cksel = Ext.Crystal:Osc_8.0- MHz,Startuptime 16KCK+65ms

Lockbits:
All disabled

LockBit , FuseBitLow , FuseBitHigh , FuseBitExtended
')
'$prog &HFF , &HFF , &HD1 , &HFF
'( ************ Display3000, D074 Modul mit Folientastatur ************
   ---------------------
 |                     |
 |  ----------------   |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |1|    |2|      |  |  1 = Pmotlinks
 |  |---------------|  |  2 = Zyklusdauer
 |                     |
 |          Up         | Taster
 |                     |  Up   : Edit: Zeile Aufwrts bzw. Digit inkrementieren
 |       Le Ent Rt     |  Dn   : Edit: Zeile Abwrts bzw. Digit dekrementieren
 |                     |  Le   : Blttern Rckwrts bzw. zeichen links
 |          Dn         |  Rt   : Blttern Vorwrts bzw. zeichen rechts
 |  Shift         Esc  |  Ent  : Edit : EditState bzw. Werte bernehmen
 |                     |  C    : (Cancel) Editieren abbrechen
 -----------------------  Shift:
                              (Modus = 0) ==> Reset Tageskilometerzhler
                              (Modus = 3) ==> Elektrische Nulllage speichern
                                              Vorher muss der Geber-Null
                                              ungefhr richtig eingestellt sein
                              (Modus = 4) ==> Min-Maxwerte nullen
                              (Modus = 6) ==> Werte in EEPROM schreiben
                              (Modus = 7) ==> Werte in EEPROM schreiben

************ Display3000, D074 Modul mit Folientastatur ************

####################### Lcd -routines ######################################

Definition Of Used Ports And Pull Up Resistors.
We are using Port B for the SPI -communication to the LCD Display.

****** SPCR SPI CONTROL REGISTER ******
Max Frequenz erlaubt : viele MHz
Beispiel: 16MHz / 64 = 128 ==> 125KHz
Bit: 2    1    0
   SPI2X SPR1 SPR0 SCK Frequency
     0    0    0 Fosc /4
     0    0    1 fosc /16
     0    1    0 fosc /64
     0    1    1 fosc /128
     1    0    0 fosc/2   ==> doubles the clock rate
     1    0    1 fosc/8   ==> doubles the clock rate
     1    1    0 fosc/32  ==> doubles the clock rate
     1 1 1 fosc / 64 ==> doubles the clock rate

Bit2 = CPHA  CPHA: Clock Phase
Bit3 = CPOL  CPOL: Clock Polarity ==> 0 Rising Falling 1 Falling Rising

Bit4 = Mstr  Mstr : Master / Slave Select this Bit selects master Spi mode when
                  written to "1" , and slave Spi mode when written "0".
Bit5 = DORD  DORD: Data order when the DORD bit is "1", the LSB of the data word
                 is transmitted first.
Bit6 = SPE  SPE: SPI Enable
Bit7 = SPIE  SPIE: SPI Interrupt Enable

Bit      7654_3210
         |||| |||x Clockrate
         |||| ||x  Clockrate
         |||| |x   Phase = 0
         |||| x    Polarity = 0 Rising Falling (low), 1 Falling Rising(High)
         |||x      Master = Yes ==> 1
         ||x       Data Order ==> 0 Msb first, 1 LSB first
         |x        SPI Enable ==> 1
         x         Interrupt = Off ==> 0

****** SPSR SPI Status Register ******
0 = SPI2X
')

'A.0 = Input not used
'A.1 = Input not used
'A.2 = Input not used
'A.3 = Input not used
'A.4 = Input not used
'A.5 = Input not used
'A.6 = Input not used
'A.7 = Input not used
Ddra = &B0000_0000
Porta = &B1111_1111

'B.0 = CS for SD-Card
'B.1 = Output for SCK
'B.2 = Output for MOSI
'B.3 = Input for MISO
'B.4 = Output for LCD
'B.5 = Output for LCD
'B.6 = Output for LCD
'B.7 is for display lighting....
Ddrb = &B1111_0111
Portb = &B1000_1000

'C.0 = not used
'C.1 = not used
'C.2 = Input for Keypad
'C.3 = Input for Keypad
'C.4 = Input for Keypad
'C.5 = Input for Keypad
'C.6 = Input for Keypad
'C.7 = Input for Keypad
Ddrc = &B0000_0000
Portc = &B1111_1111

'D.0 Output for I2C
'D.1 Output for I2C
'D.2 Input for RX1
'D.3 Output for TX1
'D.4 Input not used
'D.5 Input not used
'D.6 Input not used
'D.7 Input not used
Ddrd = &B0000_1000
Portd = &B1111_0111

'E.0 = Input for RX0
'E.1 = Output for TX0
'E.2 = Input not used
'E.3 = Input not used
'E.4 = Input not used
'E.5 = Input not used
'E.6 = Input not used
'E.7 = Input for Keypad
Ddre = &B0000_0010
Porte = &B1111_1101

'F.0 = Input not used
'F.1 = Input not used
'F.2 = Input not used
'F.3 = Input not used
'F.4 = Input not used
'F.5 = Output for SD-Card
'F.6 = Input not used
'F.7 = Output for SD-Card
Ddrf = &B1010_0000
Portf = &B0101_1111                                                           'all pull-up-Resistors turned on

'G.0 = Input not used
'G.1 = Input not used
'G.2 = Input not used
'G.3 = Input not used
'G.4 = Input not used
'G.5 = Input not used
'G.6 = Input not used
'G.7 = Input not used
Ddrg = &B0000_0000
Portg = &B1111_1111                                                           'all pull-up-Resistors turned on

Btn_Up Alias PinC.3
Btn_Dn Alias PINC.4
Btn_Le Alias PinC.2
Btn_Rt Alias PinC.6
Btn_Ent Alias PinC.5
Btn_Esc Alias PinC.7

Btn_Shift Alias PinE.7
SD_Tristate Alias PORTF.7

'#############################################################################

Declare Sub Activate_Display_Bus
Declare Sub Activate_SD_Bus

Declare Sub Reset_Minmax
declare Sub DrawPageStatics(Byval PageNum as Byte)

Declare Sub DisplayLine(Byval Txt As String * 22 , Byval X As Byte , _
                        Byval Y As Byte , Byval Txtcolor As Word , _
                        Byval Bgrcolor As Word)

Declare Sub DisplayStatusLine(Byval Txt As String * 22 , Byval X As Byte , _
                              Byval Y As Byte , Byval Txtcolor As Word , _
                              Byval Bgrcolor As Word)

Declare Sub DisplayEditLine(Byval ConstStr as String * 22 , _Var as Single , _
                            Byval EdtZl as Byte , Byval Xc as Byte , _
                            Byval Y as Byte)
Declare Sub GetEEpromData
Declare Sub PutEEpromData
Declare Sub Datenempfang

Const Titel = "Tacho 2.0  Page:"

$include "..\..\Listrik01_Common_Vars.bas"

const KeyboardTest = 0

'**** Sendepuffer ****
Const TxBuffMax = 60
Dim TxData(TxBuffMax) as Byte                                                 'Parameter an Main
'**** Sendepuffer ****

'**** Empfangspuffer ****
Dim Ep0 As Byte                                                               'CR
Dim Ep1 As Byte                                                               'Adresse
Dim Ep2 As Byte                                                               'Richtung
Dim Ep3 As Byte                                                               'PWM
Dim Ep4 As Byte                                                               'RxSubParIndex
Dim Ep5 As Byte                                                               'RxSubParData
Dim Ep6 As Byte                                                               'RxSubParData
Dim Ep7 As Byte                                                               'RxSubParData
Dim Ep8 As Byte                                                               'RxSubParData
Dim Ep9 As Byte                                                               'BCC
Dim Ep10 As Byte                                                              'CR

'**** Empfangspuffer ****

Dim Mit_Acc_Nick As Long                                                      'Nick
Dim Mit_AccNick As Long
Dim Mit_AccNick1 As Byte At Mit_AccNick + 0 Overlay
Dim Mit_AccNick2 As Byte At Mit_AccNick + 1 Overlay
Dim Mit_AccNick3 As Byte At Mit_AccNick + 2 Overlay
Dim Mit_AccNick4 As Byte At Mit_AccNick + 3 Overlay

Dim Nick_Offset As Long
Dim NickOffset As Long
Dim NickOffset1 As Byte At NickOffset + 0 Overlay
Dim NickOffset2 As Byte At NickOffset + 1 Overlay
Dim NickOffset3 As Byte At NickOffset + 2 Overlay
Dim NickOffset4 As Byte At NickOffset + 3 Overlay

Dim Null_Nick As Long
Dim NullNick As Long
Dim NullNick1 As Byte At NullNick + 0 Overlay
Dim NullNick2 As Byte At NullNick + 1 Overlay
Dim NullNick3 As Byte At NullNick + 2 Overlay
Dim NullNick4 As Byte At NullNick + 3 Overlay

Dim ADC_Nick As Integer
Dim ADC_Nick1 As Byte At ADC_Nick + 0 Overlay
Dim ADC_Nick2 As Byte At ADC_Nick + 1 Overlay

Dim Sw As Single
Dim Sw1 As Byte At Sw + 0 Overlay
Dim Sw2 As Byte At Sw + 1 Overlay
Dim Sw3 As Byte At Sw + 2 Overlay
Dim Sw4 As Byte At Sw + 3 Overlay

$include "..\..\Msg_Display2MainCtrl_COM.bas"

Dim ErrorWord As Word
Dim ErrorWord1 As Byte At ErrorWord + 0 Overlay
Dim ErrorWord2 As Byte At ErrorWord + 1 Overlay

Dim UpdateCtr as Byte

'Gespiegelte Daten vom Motorcontroller
Dim StromRegPfaktor as Integer
Dim StromRegIfaktor as Integer
Dim StromGrenze as Word

Dim Sensor_OK_count as Byte

Dim Rueck_O_nick_u as Long
Dim Rueck_Onicku as Long
Dim Rueck_Onicku1 as Byte at Rueck_Onicku + 0 overlay
Dim Rueck_Onicku2 as Byte at Rueck_Onicku + 1 overlay
Dim Rueck_Onicku3 as Byte at Rueck_Onicku + 2 overlay
Dim Rueck_Onicku4 as Byte at Rueck_Onicku + 3 overlay

Dim Rueck_O_nick_o as Long
Dim Rueck_Onicko as Long
Dim Rueck_Onicko1 as Byte at Rueck_Onicko + 0 overlay
Dim Rueck_Onicko2 as Byte at Rueck_Onicko + 1 overlay
Dim Rueck_Onicko3 as Byte at Rueck_Onicko + 2 overlay
Dim Rueck_Onicko4 as Byte at Rueck_Onicko + 3 overlay

Dim Rueck_O_nick_oo as Long
Dim Rueck_Onickoo as Long
Dim Rueck_Onickoo1 as Byte at Rueck_Onickoo + 0 overlay
Dim Rueck_Onickoo2 as Byte at Rueck_Onickoo + 1 overlay
Dim Rueck_Onickoo3 as Byte at Rueck_Onickoo + 2 overlay
Dim Rueck_Onickoo4 as Byte at Rueck_Onickoo + 3 overlay

Dim RueckRegelstrategie as Byte

Dim RueckPWMmax as Byte

Dim RueckStromgrenze as Word
Dim RueckStromgrenze1 as Byte at RueckStromgrenze + 0 Overlay
Dim RueckStromgrenze2 as Byte at RueckStromgrenze + 1 Overlay

Dim RueckStromReg_Pfaktor as Single
Dim RueckStromReg_Pfaktor1 as Byte at RueckStromReg_Pfaktor + 0 Overlay
Dim RueckStromReg_Pfaktor2 as Byte at RueckStromReg_Pfaktor + 1 Overlay
Dim RueckStromReg_Pfaktor3 as Byte at RueckStromReg_Pfaktor + 2 Overlay
Dim RueckStromReg_Pfaktor4 as Byte at RueckStromReg_Pfaktor + 3 Overlay

Dim RueckStromReg_Ifaktor as Single
Dim RueckStromReg_Ifaktor1 as Byte at RueckStromReg_Ifaktor + 0 Overlay
Dim RueckStromReg_Ifaktor2 as Byte at RueckStromReg_Ifaktor + 1 Overlay
Dim RueckStromReg_Ifaktor3 as Byte at RueckStromReg_Ifaktor + 2 Overlay
Dim RueckStromReg_Ifaktor4 as Byte at RueckStromReg_Ifaktor + 3 Overlay

Dim RueckOffset_Nick as Long
Dim RueckOffsetNick as Long
Dim RueckOffsetNick1 as Byte at RueckOffsetNick + 0 overlay
Dim RueckOffsetNick2 as Byte at RueckOffsetNick + 1 overlay
Dim RueckOffsetNick3 as Byte at RueckOffsetNick + 2 overlay
Dim RueckOffsetNick4 as Byte at RueckOffsetNick + 3 overlay

Dim RueckIstRichtung as Byte

Dim RueckLoopCount as Word
Dim RueckLoopCount1 as Byte at RueckLoopCount + 0 Overlay
Dim RueckLoopCount2 as Byte at RueckLoopCount + 1 Overlay

Dim RueckAusgabeTicks_L as Integer                                            'Anzahl Kommutierungen je 10mS, linker Motor
Dim RueckAusgabeTicks_L1 as Byte at RueckAusgabeTicks_L + 0 Overlay
Dim RueckAusgabeTicks_L2 as Byte at RueckAusgabeTicks_L + 1 Overlay

Dim Gyro_nick As Long
Dim K_sum As Single
Dim K_summax As Single
Dim K_summin As Single

Dim Bdummy As Byte
Dim Bdummy1 As Byte
Dim Bdummy2 As Byte
Dim Bdummy3 As Byte
Dim B_dummy as Byte                                                           'nur fr COM In
Dim Singdummy As Single

Dim Ldummy As Long

Dim Idummy As Integer
Dim Idummy1 As Integer

Dim KmhMax As Integer
Dim KmhMin As Integer

'Strombegrenzungsregler
Dim IBattMax as Byte                                                          'Batteriestrom in A. Beispiel: 22 fr 22A

'Strommessung/Anzeige
Dim IBatt as Long                                                             'mA
Dim IBatt1 As Byte at IBatt + 0 Overlay
Dim IBatt2 As Byte at IBatt + 1 Overlay
Dim IBatt3 As Byte at IBatt + 2 Overlay
Dim IBatt4 As Byte at IBatt + 3 Overlay
Dim I As Single                                                               'A
Dim Imax As Long                                                              'mA
Dim Imin As Long                                                              'mA

'Spannungsmessung/Anzeige
Dim UBatt As Long                                                             'mV
Dim UBatt1 As Byte at UBatt + 0 Overlay
Dim UBatt2 As Byte at UBatt + 1 Overlay
Dim UBatt3 As Byte at UBatt + 2 Overlay
Dim UBatt4 As Byte at UBatt + 3 Overlay
Dim Umax As Long                                                              'mV
Dim Umin As Long                                                              'mV
Dim U As Single                                                               'V

'Dim PWM_Links As Byte Siehe Variable "SollSpeed"

Dim PWM_Links_Max As Integer
Dim PWM_Links_Min As Integer
Dim Modus As Byte
Dim EditZeile As Byte

Dim Utext As String * 22 , Itext As String * 22 , Ltext As String * 22
Dim L1 As Byte
Dim L2 As Byte
Dim Text As String * 22
Dim Farbe As Word
Dim X1 As Byte
Dim Y1 As Byte
Dim X2 As Byte
Dim Y2 As Byte
Dim Startkilometer As Single
Dim Ta As Byte
Dim Tamax As Byte
Dim Ya As Byte
Dim Xa As Byte
Dim Lname As Long
Dim Dateiname As String * 12
Dim Dateilaenge As Long
Dim DateiAktuell As Byte
Dim Loopcount As Word
Dim Aloopcount As Word
Dim Logtext As String * 255
Dim Zeit As String * 8
Dim FussSchalter As Byte
Dim FussCount As Byte
Dim Dummybyte As Byte
Dim ErrorStr(17) As String * 22
Dim NotAusGrundStr(8) As String * 22
Dim Errorindex As Byte

Dim KK_Temp_Links as Integer
Dim KK_Temp_Links1 as Byte at KK_Temp_Links + 0 Overlay
Dim KK_Temp_Links2 as Byte at KK_Temp_Links + 1 Overlay

Dim Comerrorsmotlinks As Word
Dim ComerrorsMotlinks1 As Byte At ComerrorsMotlinks + 0 Overlay
Dim ComerrorsMotlinks2 As Byte At ComerrorsMotlinks + 1 Overlay

Dim Comerrorsdisplay As Word
Dim Comerrorsdisplay1 As Byte At Comerrorsdisplay + 0 Overlay
Dim Comerrorsdisplay2 As Byte At Comerrorsdisplay + 1 Overlay

Dim Akkuverbraucht As Integer
Dim Akkuverbraucht1 As Byte At Akkuverbraucht + 0 Overlay
Dim Akkuverbraucht2 As Byte At Akkuverbraucht + 1 Overlay

Dim Startup As Word
Dim Startup1 As Byte At Startup + 0 Overlay
Dim Startup2 As Byte At Startup + 1 Overlay

Dim FirstRun as Byte

Dim IactMain as Integer
Dim IactMain1 As Byte At IactMain + 0 Overlay
Dim IactMain2 As Byte At IactMain + 1 Overlay

Dim VLimit as Integer
Dim VLimit1 As Byte At VLimit + 0 Overlay
Dim VLimit2 As Byte At VLimit + 1 Overlay

Dim RueckVLimit as Integer
Dim RueckVLimit1 As Byte At RueckVLimit + 0 Overlay
Dim RueckVLimit2 As Byte At RueckVLimit + 1 Overlay

Dim Regelstrategie as Byte
Dim SollRichtung as Byte
Dim SollSpeed as Byte
Dim NotausGrund As Byte
Dim StartupStr(10) As String * 22

Dim Intstep As Word : Intstep = 10                                              '10 = step of 1.0
Dim Intstep1 As Byte At Intstep + 0 Overlay
Dim Intstep2 As Byte At Intstep + 1 Overlay

'***** EEprom *****
Dim Dummy As Eram Byte                                                        'offset &H00
Dim EStartkilometer As Eram Single
Dim ENick_Offset As Eram Long
Dim ESinus(12) As Eram Byte
Dim EIBattMax As Eram Byte                                                    '30 = 30A
Dim EP_faktor As Eram Single
Dim EI_faktor As Eram Single
Dim ED_faktor As Eram Single
Dim EMp_faktor As Eram Single
Dim EMv_faktor As Eram Single
Dim EMpl_faktor As Eram Single
Dim EMvl_faktor As Eram Single
Dim ERegelStrategie as Eram Byte
Dim EPWMmax as Eram Byte
Dim EStromReg_Pfaktor as Eram Single
Dim EStromReg_Ifaktor as Eram Single
Dim EStrom_Grenze as Eram Byte                                                '30 = 30A
Dim Evlimit As Eram Integer
'***** EEprom *****

'***** Edit Number *****
Dim EditStr as String * 22
Dim EditState as Byte                                                         '0 = Select Line , 1 = Sel / Mod Decimal
Dim EditSpalte as Byte
Dim EditChar as String * 1
'***** Edit Number *****

Dim TTempStr as string * 22
Dim OK_Str as String * 19
Dim Error_Str as String * 19

'                0000000001111111111   max 19 Zeichen. Nicht mehr Platz auf Page 0
'                1234567890123456789
OK_Str = "Alles OK"
Error_Str = "Fehler stehen an"

'                    0000000001111111111222   max 22 Zeichen
'                    1234567890123456789012
StartupStr(1) = "Start-Taste entlastet "
StartupStr(2) = "Kopplung z. Motorcontr"
StartupStr(3) = "Futaster entlastet   "
StartupStr(4) = "Antrieb ist AUS       "
StartupStr(5) = "Systemspannung in Tol."
StartupStr(6) = "Parameter OK          "
StartupStr(7) = "Sensoren in Mittellage"
StartupStr(8) = "Futaster belastet    "
StartupStr(9) = "Reset-Taste bettigt  "
StartupStr(10) = "Bitte aufsteigen      "

ErrorStr(1) = "Spannung ist < 24V"                                            'Errorword.0
ErrorStr(2) = "Spannung ist < 36V"                                            'Errorword.1
ErrorStr(3) = "Spannung ist < 48V"                                            'Errorword.2
ErrorStr(4) = "Warte Gyros Nullen"                                            'Errorword.3
ErrorStr(5) = "Warte auf Fuschal"                                            'Errorword.4
ErrorStr(6) = "Antrieb ist AUS"                                               'Errorword.5
ErrorStr(7) = "NOT AUS steht an"                                              'Errorword.6
ErrorStr(8) = "Rx Timeout MotCtrl"                                            'Errorword.7
ErrorStr(9) = "Mot.Hallst. fehlt"                                             'Errorword.8
ErrorStr(10) = "Mot.Strombeg.aktiv"                                           'Errorword.9
ErrorStr(11) = "Motor hat NOTAUS"                                             'Errorword.10
ErrorStr(12) = "Rx Timeout Display"                                           'Errorword.11
ErrorStr(13) = "Unfallschreiber  "                                            'Errorword.12
ErrorStr(14) = "Betriebsschreiber"                                            'Errorword.13
ErrorStr(15) = "not used 14      "                                            'Errorword.14
ErrorStr(16) = "not used 15      "                                            'Errorword.15

NotAusGrundStr(1) = "Fussch.zulange frei"                                     'Notausgrund.0
NotAusGrundStr(2) = "Ausregelzt zu. lang"                                     'Notausgrund.1
NotAusGrundStr(3) = "Zuweit n. vorne gek"                                     'Notausgrund.2
NotAusGrundStr(4) = "Zuweit n.hinten gek"                                     'Notausgrund.3
NotAusGrundStr(5) = "Halltest Fehler"                                         'Notausgrund.4
NotAusGrundStr(6) = "berstrom"                                               'Notausgrund.5
NotAusGrundStr(7) = "Rx Timeout Motor"                                        'Notausgrund.6

Modus = 255

$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Init21_Display3000.bas"
$Include "Config_mmc.bas"

Orientation = Portrait180
If SD_Tristate = 1 Then Activate_Display_Bus

#If KeyboardTest = 1
  do
    Text = "PinA: "
    Text = Text + Bin(PinA)
    LCD_Print Text , 0 , 20 , 1 , 1 , 1 , Black , White
    Text = "PinB: "
    Text = Text + Bin(Pinb)
    LCD_Print Text , 0 , 29 , 1 , 1 , 1 , Black , White
    Text = "PinC: "
    Text = Text + Bin(Pinc)
    LCD_Print Text , 0 , 38 , 1 , 1 , 1 , Black , White
    Text = "PinD: "
    Text = Text + Bin(Pind)
    LCD_Print Text , 0 , 47 , 1 , 1 , 1 , Black , White
    Text = "PinE: "
    Text = Text + Bin(Pine)
    LCD_Print Text , 0 , 56 , 1 , 1 , 1 , Black , White
    Text = "PinF: "
    Text = Text + Bin(Pinf)
    LCD_Print Text , 0 , 65 , 1 , 1 , 1 , Black , White
    Text = "PinG: "
    Text = Text + Bin(Ping)
    LCD_Print Text , 0 , 74 , 1 , 1 , 1 , Black , White
    waitms 300
  loop
#endif

' #############################################################################
' ### Set up time for PWM control (for display dimming)      ##################
' #############################################################################
'(
Config Timer1 = Pwm , Pwm = 8 , Compare C Pwm = Clear Up , _
                Compare C Pwm = Clear Down , Prescale = 64                    'Prescale of 256 might flicker with 8 Mhz modules
Pwm1c = 255                                                                   'starts with 255 = lights OFF
')

If SD_Tristate = 0 Then Activate_SD_Bus
Gbdriveerror = Driveinit()                                                    'Init MMC/SD Card

'brauchen manchmal mehere Versuche
If Gbdriveerror = 0 Then
 waitms 50
 Gbdriveerror = Driveinit()                                                   'Init MMC/SD Card
end if

If Gbdriveerror = 0 Then
 waitms 50
 Gbdriveerror = Driveinit()                                                   'Init MMC/SD Card
end if

If Gbdriveerror = 0 Then
 waitms 50
 Gbdriveerror = Driveinit()                                                   'Init MMC/SD Card
end if

If Gbdriveerror = 0 Then
  $Include "CONFIG_AVR-DOS.bas"

  Bdummy = InitFileSystem(1)                                                  'Partition 1

  Ldummy = Disksize() / 1024
  Utext = "Size: " + Str(Ldummy)
  Utext = Utext + "KB"

  Ldummy = Diskfree() / 1024
  Itext = "Free: " + Str(Ldummy)
  Itext = Itext + "KB"
End If

If SD_Tristate = 1 Then Activate_Display_Bus

'Font Size 1 = 5x8 Pixel
'Font Size 2 = 8x14 Pixel

Text = "Listrik01"                                                            'zentriert, gro
L1 = Len(Text) * 9                                                            'Font size 2
L1 = L1 / 2                                                                   'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 16 , 2 , 1 , 2 , Black , White

Text = "Walter Software"                                                      'zentriert, klein
L1 = Len(Text) * 6                                                            'Font size 1
L1 = L1 / 2                                                                   'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 50 , 1 , 1 , 1 , Black , White

Text = "Version 02"                                                           'zentriert, klein
L1 = Len(Text) * 6                                                            'Font size 1
L1 = L1 / 2                                                                   'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 70 , 1 , 1 , 1 , Black , White

If Gbdriveerror = 0 Then
  Call Lcd_print( " SD Card OK " , 1 , 90 , 2 , 1 , 2 , White , Green)
  Call Lcd_print(UText , 7 , 120 , 2 , 1 , 1 , Blue , White)
  Call Lcd_print(IText , 7 , 135 , 2 , 1 , 1 , Blue , White)
else
  UText = " SD Card Error " + Str(Gbdriveerror)
  UText = UText + " "
  Call Lcd_print(UText , 1 , 90 , 1 , 1 , 1 , White , Red)
end if

'Display dimming
'(
Call Lcd_print( "TFT Brightness:" , 0 , 140 , 1 , 1 , 1 , Blue , White)
 Call Lcd_print( "000%" , 50 , 160 , 2 , 1 , 1 , Blue , White)
 Waitms 300
 For Bdummy1 = 255 To 0 Step -5
  Pwm1c = Bdummy1
  Waitms 20
  Singdummy = Bdummy1 * 0.39
  Bdummy2 = Singdummy
  Bdummy2 = 100 - Bdummy2
  Text = Str(Bdummy2)
  Text = Format(Text , "000")
  Text = Text + "%"
  Call Lcd_print(Text , 50 , 160 , 2 , 1 , 1 , Blue , White)
Next
')

Call GetEEpromData

'Einige Werte vorbelegen um fehlerhafte Grafik zu vermeiden, falls keine
'serielle Verbindung besteht
Xa = 74
Ya = 130

$baud1 = 57600
Config Com2 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , _
              Databits = 8 , Clockpol = 0
OPEN "com2:" for binary as #1
On Urxc1 Datenempfang Save
Enable Urxc1

Call Reset_Minmax
Modus = 0

Enable Interrupts
Wait 2                                                                        '2 Seconds for Startup Display
Call Lcd_cls()

Call Drawpagestatics(Modus)
FirstRun = 1

Do
 Select Case EditState
  Case 0
   'normales Navigieren
   If Btn_Up = 0 Then                                                         'Zeile nach oben
     Waitms 3 : While Btn_Up = 0 : Wend
     If EditZeile > 1 Then
       Decr EditZeile
     Else
       Select Case Modus
         Case 4
           EditZeile = 9

         Case 5
           EditZeile = 5

         Case 6
           EditZeile = 12
       end select
     End If
   end if

   If Btn_Dn = 0 Then                                                         'Zeile nach unten
     Waitms 3 : While Btn_Dn = 0 : Wend
     If EditState = 0 then
      Select Case Modus
       Case 4
         If EditZeile < 9 Then
           Incr EditZeile
         Else
           EditZeile = 1
         End If
       Case 5
         If EditZeile < 5 Then
           Incr EditZeile
         Else
           EditZeile = 1
         End If
       Case 6
         If EditZeile < 12 Then
           Incr EditZeile
         Else
           EditZeile = 1
         End If
      end select
     end if
   End If

   If Btn_Ent = 0 Then                                                        'bernehmen
    Waitms 3 : While Btn_Ent = 0 : Wend
    EditSpalte = 1
    Select Case Modus
     Case 4
      Select Case Editzeile
        Case 0
          'invalid
        Case 1
         Utext = Fusing(P_faktor , "#.&&&&&")
         EditStr = Format(Utext , "00000000")

        Case 2
         Utext = Fusing(I_faktor , "#.&&&&&")
         EditStr = Format(Utext , "00000000")

        Case 3
         Utext = Fusing(D_faktor , "#.&&&&&")
         EditStr = Format(Utext , "00000000")

        Case 4
         EditStr = Fusing(Mp_faktor , "#.&&&&&&")

        Case 5
         EditStr = Fusing(Mv_faktor , "#.&&&&&&")

        Case 6
         EditStr = Fusing(Mpl_faktor , "#.&&&&&&")

        Case 7
         EditStr = Fusing(Mvl_faktor , "#.&&&&&&")

        Case 8
         Text = Str(Vlimit)
         EditStr = Format(Text , "000")

        Case 9
         Text = Str(Regelstrategie)
         EditStr = Format(Text , "0")
      end select

     Case 5
      Select Case Editzeile
        Case 0
          'invalid

        Case 1
         SingDummy = StromRegPfaktor
         EditStr = Fusing(SingDummy , "#.&&&&&&")

        Case 2
         SingDummy = StromRegIfaktor
         EditStr = Fusing(SingDummy , "#.&&&&&&")

        Case 3
         Text = Str(StromGrenze)
         EditStr = Format(Text , "00")

        Case 4
         Text = Str(PWMmax)
         EditStr = Format(Text , "000")

        Case 5
         Text = Str(IBattMax)                                                 'I-Batterie Max
         EditStr = Format(text , "00")                                        '1A Schritte
      end select

     Case 6
       Text = Str(Sinus(EditZeile))
       EditStr = Format(text , "000")

    end select
    If Editzeile > 0 then EditState = 1
   end if

   If Btn_Esc = 0 Then                                                        'abbrechen
     Waitms 3 : While Btn_Esc = 0 : Wend
     EditState = 0
     EditStr = ""                                                             ''
   end if

   If Btn_Rt = 0 Then                                                         'Blttern vorwrts
     Waitms 3 : While Btn_Rt = 0 : Wend                                       'Debounce Button
     Incr Modus
     EditZeile = 0
     If Gbdriveerror <> 0 then                                                'Logging nur wenn Antrieb luft
       If Modus >= 10 Then Modus = 0                                          'Skip modes 10 and 11
     elseif Antriebaus = 1 then
       If Modus >= 11 Then Modus = 0                                          'Skip mode 11
     Else
       If Modus > 11 Then Modus = 0
     End If

     If SD_Tristate = 1 Then Activate_Display_Bus
     Call Lcd_cls
     Call Drawpagestatics(Modus)
   End If

   If Btn_Le = 0 Then                                                         'Blttern rckwrts
     Waitms 3 : While Btn_Le = 0 : Wend                                       'Debounce Button
     If Modus > 0 Then
       Decr Modus
     Elseif Gbdriveerror <> 0 Then                                            'Logging nicht zulassen wenn DriveError
       Modus = 9                                                              'Skip modes 10 and 11
     Elseif Antriebaus = 1 Then
       Modus = 10
     Else
       Modus = 11
     End If
     EditZeile = 0
     If SD_Tristate = 1 Then Activate_Display_Bus
     Call Lcd_cls
     Call Drawpagestatics(Modus)
   End If

   'Min/Max Werte speichern
   If Modus <> 11 Then                                                        'Nur wenn nicht geloggt wird
     If UBatt <> 0 and Ta <> 0 Then                                           'Nur wenn auch schon eine Spannung und ein Ta bertragen wurden
      If UBatt > Umax Then Umax = UBatt
      If UBatt < Umin Then Umin = UBatt

      If IBatt > Imax Then Imax = IBatt
      If IBatt < Imin Then Imin = IBatt

      If Kmh > KmhMax Then KmhMax = Kmh
      If Kmh < KmhMin Then KmhMin = Kmh

      If Ta > Tamax Then Tamax = Ta

      If SollSpeed > PWM_Links_Max Then PWM_Links_Max = SollSpeed
      If SollSpeed < PWM_Links_Min Then PWM_Links_Min = SollSpeed
     End If
   End If

  Case 1
   'Wert editieren
   If Btn_Le = 0 Then                                                         'Zahl dekrementieren
     Waitms 3 : While Btn_Le = 0 : Wend
     If EditSpalte > 1 then Decr EditSpalte
   End If

   If Btn_Rt = 0 Then                                                         'Zahl inkrementieren
     Waitms 3 : While Btn_Rt = 0 : Wend
     If EditSpalte < len(EditStr) then Incr EditSpalte
   End If

   EditChar = Mid(EditStr , EditSpalte , 1)

   If Btn_Up = 0 Then
     Waitms 3 : While Btn_Up = 0 : Wend
     If EditChar = "+" then
       EditChar = "-"
     elseif EditChar = "-" then
       EditChar = "+"
     elseif EditChar = "e" or EditChar = "E" or EditChar = "*" or _
            EditChar = "." or EditChar = "," or EditChar = " " then
       'do nothing
     elseif EditChar < "9" then
      FirstRun = val(EditChar) + 1
      EditChar = Str(FirstRun)
     else
       EditChar = "0"
     end if
   end if

   If Btn_Dn = 0 Then
     Waitms 3 : While Btn_Dn = 0 : Wend
     EditChar = Mid(EditStr , EditSpalte , 1)
     If EditChar = "+" then
       EditChar = "-"
     elseif EditChar = "-" then
       EditChar = "+"
     elseif EditChar = "e" or EditChar = "E" or EditChar = "*" or _
            EditChar = "." or EditChar = "," or EditChar = " " then
       'do nothing
     elseif EditChar > "0" then
      FirstRun = val(EditChar) - 1
      EditChar = Str(FirstRun)
     else
       EditChar = "9"
     end if
   end if

   Mid(EditStr , EditSpalte , 1) = EditChar

   If Btn_Esc = 0 Then                                                        'abbrechen
     Waitms 3 : While Btn_Esc = 0 : Wend
     EditState = 0
   end if

   If Btn_Ent = 0 Then                                                        'bernehmen
     Waitms 3 : While Btn_Ent = 0 : Wend
     Select Case Modus
       Case 0 to 3
         'nothing to edit

       Case 4
         Select Case Editzeile
           Case 1
             P_faktor = val(EditStr)

           Case 2
             I_faktor = val(EditStr)

           Case 3
             D_faktor = val(EditStr)

           Case 4
             Mp_faktor = val(EditStr)

           Case 5
             Mv_faktor = val(EditStr)

           Case 6
             Mpl_faktor = val(EditStr)

           Case 7
             Mvl_faktor = val(EditStr)

           Case 8
             Vlimit = val(EditStr)

           Case 9
             Regelstrategie = val(EditStr)
         end select

       Case 5
         Select Case Editzeile
           Case 1
             StromRegPfaktor = val(EditStr)

           Case 2
             StromRegIfaktor = val(EditStr)

           Case 3
             StromGrenze = val(EditStr)

           Case 4
             PWMmax = val(EditStr)

           Case 5                                                             'I-Batterie Max
             IBattMax = val(EditStr)                                          '1A Schritte
         end select

       Case 6
         Sinus(Editzeile) = val(EditStr)

       Case 7 to 11
         'nothing to edit
     end select
     EditState = 0                                                            'end of edit mode
   end if
 end Select

 Select Case Modus
  Case 0                                                                      'Startup
    Bdummy3 = 0
    For Bdummy2 = 1 To 10
      Text = StartupStr(bdummy2)
      Bdummy1 = Bdummy2 * 9                                                   'Position der Textzeile festlegen
      Bdummy1 = Bdummy1 + 20                                                  'Titelzeile bercksichtigen
      If Startup.Bdummy3 > 0 Then
        Call DisplayLine(Text , 0 , Bdummy1 , Black , Green)
      Else
        Call DisplayLine(Text , 0 , Bdummy1 , Black , White)
      End If
      Incr Bdummy3
    Next

    'alle Bedingungen sind erfllt. Umschalten auf Hauptdisplay
    If FirstRun = 1 and Startup.9 = 1 Then
      Modus = 1
      FirstRun = 0
      Call Lcd_cls
      Call Drawpagestatics(Modus)
    End If

  Case 1                                                                      'Hauptdisplay
    If DateiAktuell = 1 Then
      If SD_Tristate = 0 Then Activate_SD_Bus
      Close #2
      DateiAktuell = 0
    End If
    If SD_Tristate = 1 Then Activate_Display_Bus                              'Standard Anzeige

    If Btn_Shift = 0 Then                                                     'Tageskilomerterzhler nullen
      Waitms 3 : While Btn_Shift = 0 : Wend
      Singdummy = Meter / 1000
      Singdummy = Singdummy + Kilometer
      Startkilometer = Singdummy
      EStartkilometer = Startkilometer
    End If

    'Spannung und Strom
    U = UBatt
    U = U / 1000                                                              '1mV Auflsung
    Utext = Fusing(U , "#.&") + "V"
    Utext = " " + Utext

    I = IBatt
    I = I / 1000                                                              '1mA Auflsung
    Itext = Fusing(I , "#.&") + "A "

    L1 = Len(Utext)
    L2 = Len(Itext)
    L1 = L1 + L2
    L2 = 22 - L1
    Ltext = String(l2 , 32)
    Text = Utext + Ltext
    Text = Text + Itext
    LCD_Print Text , 0 , 75 , 1 , 1 , 1 , Black , White

    'Akku in Prozent
    Singdummy = AkkuStand
    Singdummy = 100 - Singdummy                                               '%
    Idummy = Singdummy
    Text = Str(Idummy)                                                        '00...100%
    Text = "  " + Text + "%  "
    If Idummy > 66 Then
       Farbe = Green
     Elseif Idummy > 33 Then
       Farbe = Yellow
    Else
       Farbe = Red
    End If
    X2 = Singdummy * 1.14                                                     '124 - 8 - 1 - 1 = 114 / 100% = 1.14
    X2 = X2 + 10                                                              '10 wegen der "100 - Sdummy" weiter oben
    If X2 > 123 Then X2 = 123
    If X2 < 9 Then X2 = 9
    Lcd_box X2 , 85 , 123 , 94 , White                                        'Hintergrund lschen
    Lcd_box 9 , 85 , X2 , 94 , Farbe                                          'Balken zeichnen
    'Text mittig platzieren
    L1 = Len(Text)
    L1 = L1 * 5
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 98 , 1 , 1 , 1 , Black , White                      'unterm Balken

    'Kmh
    Singdummy = Kmh / 10
    Text = Fusing(Singdummy , "#.&") + "Kmh  "
    Text = "  " + Text
    'Text mittig platzieren
    L1 = Len(Text)
    L1 = L1 * 8
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 12 , 2 , 1 , 2 , Black , White

    'Km
    Singdummy = Meter / 1000
    Singdummy = Singdummy + Kilometer
    Text = Fusing(Singdummy , "#.&") + "km  "
    L1 = Len(Text) * 5
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 46 , 1 , 1 , 1 , Black , White

    'Tageskilometerzhler
    Singdummy = Singdummy - Startkilometer
    Text = Fusing(singdummy , "#.###")
    Text = Text + "km  "
    L1 = Len(Text) * 5
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 60 , 1 , 1 , 1 , Black , White

    'Motortemperaturen
    Text = "KK-Temp:" + Str(KK_Temp_Links)
    Text = Text + " Cels"
    LCD_Print Text , 25 , 115 , 1 , 1 , 1 , Black , White

    'Antrieb Status
    Text = "Status: "
    If AntriebAus = 1 Then
      Text = Text + "AUS"
    Else
      Text = Text + "RUN"
    end if
    LCD_Print Text , 25 , 124 , 1 , 1 , 1 , Black , White

    'Gyros in Nullposition
    If AntriebAus = 1 and Errorword.3 > 0 Then
      LCD_Print "Gyros in Nullpos." , 25 , 133 , 1 , 1 , 1 , White , Black
    else
      LCD_Print "" , 25 , 133 , 1 , 1 , 1 , Black , White
    end if

    If ErrorWord > 0 or NotausGrund > 0 then
      Call DisplayStatusLine(Error_Str , 20 , 156 , Black , White)            'OK
    else
      Call DisplayStatusLine(OK_Str , 20 , 156 , Black , White)               'OK
    end if

    '>>>>>>>>>>>> Fusszeile im Display >>>>>>>>>>>>
    '  00000000001111111111222
    '  01234567890123456789012
    '  xxx       xxx
    '   Ta     SollSpeed
    Text = Str(Ta) + "   "                                                    'Ticks
    LCD_Print Text , 0 , 168 , 1 , 1 , 1 , Black , White

    Text = Str(SollSpeed) + "   "                                             'PWM_Links
    LCD_Print Text , 45 , 168 , 1 , 1 , 1 , Black , White

    '>>>>>>>>>>>> Nick Balken <<<<<<<<<<<<<
    If Antriebaus = 1 Then
      '30 Grad ==> 0...300
      ' 5 Grad ==> 50
      '50 Counts / 29 Pixel = 1.7241 Counts per Pixel ==> gerundet = 2 ==> 5.8 Grad
      Ldummy = Nick_Offset - Null_Nick
      Ldummy = Ldummy \ 2
    Else
      '30 Grad ==> -300...+300
      '10 Grad ==> 100 ==> Full Scale
      'Balkenlnge = 29 Pixel
      '100 Counts / 29 Pixel = 3.4483 Counts per Pixel ==> Gerundet = 4 ==> 11,6 Grad
      Ldummy = Mit_Acc_Nick \ 4
    End If

    If Ldummy > 29 Then
      Ldummy = 29
    elseIf Ldummy < -29 Then
      Ldummy = -29
    end if
    Y1 = Ldummy                                                               'Type Cast Long ==> Byte
    Y1 = Y1 + 130                                                             'Mittenoffset
    LCD_Draw 9 , Ya , 18 , Ya , 0 , White
    LCD_Draw 9 , Y1 , 18 , Y1 , 0 , Black
    Ya = Y1

 Case 2                                                                       'Fehlermeldungen und Motor Notaus Kriterien
   Bdummy2 = 11
   For Idummy = 0 To 15                                                       'Errorword.0 ==> ErrorStr(1)
     If Errorword.Idummy > 0 Then
       IDummy1 = Idummy + 1
       Text = "E" + Str(Idummy) + ":"
       Text = Text + ErrorStr(Idummy1)
       Bdummy2 = Bdummy2 + 9                                                  'Grafikzeile
       If BDummy2 < 130 then Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
     End If
   Next

   For Idummy = 0 To 5
     If NotausGrund.Idummy > 0 Then
       IDummy1 = Idummy + 1
       Text = "N" + Str(Idummy) + ":"
       Text = Text + NotausGrundStr(Idummy1)
       Bdummy2 = Bdummy2 + 9                                                  'Grafikzeile
       If BDummy2 < 130 then Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
     end if
   Next

   While BDummy2 < 112                                                        'Clear lines
     Text = "                "
     Bdummy2 = Bdummy2 + 9                                                    'Grafikzeile
     Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
   wend

   Text = "ComErr2MotL:" + Str(ComErrorsMotLinks)
   Call DisplayLine(Text , 0 , 157 , Black , White)

   Text = "ComErr2Disp:" + Str(ComErrorsDisplay)
   Call DisplayLine(Text , 0 , 166 , Black , White)

 Case 3                                                                       'Detail Display
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   End If

   If SD_Tristate = 1 Then Activate_Display_Bus

   If Btn_Shift = 0 Then                                                      'Neigung Nullen
     Waitms 3 : While Btn_Shift = 0 : Wend
     If Antriebaus = 1 Then
       ENick_Offset = Null_Nick
       Nick_Offset = Null_Nick
     End If
   End If

   U = UBatt
   U = U / 1000                                                               '1mV Auflsung
   Text = "Spannung= " + Fusing(U , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 20 , Black , White)

   I = IBatt
   I = I / 1000                                                               '1mA Auflsung
   Text = "    Strom= " + Fusing(I , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 29 , Black , White)

   Singdummy = Kmh / 10
   Text = "   Geschw= " + Fusing(Singdummy , "#.&")
   Text = Text + "km/h"
   Call DisplayLine(Text , 0 , 38 , Black , White)

   Singdummy = Meter / 1000
   Singdummy = Singdummy + Kilometer
   Text = "   Gesamt= " + Fusing(Singdummy , "#.###")
   Text = Text + "km  "
   Call DisplayLine(Text , 0 , 47 , Black , White)

   Text = Str(SollSpeed)                                                      'PWM_Links
   Text = "PWM_Links= " + Text
   Call DisplayLine(Text , 0 , 56 , Black , White)

   Text = "Soll Richtg= " + Str(SollRichtung)                                 '0=Vorw. 1=Rckw. 2=Leerlauf
   Call DisplayLine(Text , 0 , 65 , Black , White)

   Text = "Soll Speed= " + Str(SollSpeed)                                     '0=Vorw. 1=Rckw. 2=Leerlauf
   Call DisplayLine(Text , 0 , 74 , Black , White)

   Text = "     Akku= " + Str(Akkustand)
   Text = Text + "%"
   Call DisplayLine(Text , 0 , 83 , Black , White)

   Singdummy = Akkuverbraucht / 10
   Text = "AkkuVerb(mAh)= " + Fusing(singdummy , "#.&")
   Call DisplayLine(Text , 0 , 92 , Black , White)

   Text = "     Nick= " + Str(Mit_Acc_Nick)
   Call DisplayLine(Text , 0 , 101 , Black , White)

   Text = "Null_Nick= " + Str(Null_Nick)
   Call DisplayLine(Text , 0 , 110 , Black , White)

   Text = "AusgabeTicks= " + Str(RueckAusgabeTicks_L)
   Call DisplayLine(Text , 0 , 119 , Black , White)

   Text = "LoopCount= " + Str(RueckLoopCount)
   Call DisplayLine(Text , 0 , 128 , Black , White)

   Text = "ADC_Nick= " + Str(ADC_Nick)
   Call DisplayLine(Text , 0 , 137 , Black , White)

   Text = "Sens OK Count= " + Str(Sensor_OK_count)
   Call DisplayLine(Text , 0 , 146 , Black , White)

   Text = Bin(HallTest)
   Text = "Ha xxxxDCBA= " + Text
   Call DisplayLine(Text , 0 , 155 , Black , White)

 Case 4                                                                       'Werte fr Hauptcontroller editieren
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   else
     If SD_Tristate = 1 Then Activate_Display_Bus
   End If

   Text = "P-Faktor  = "
   Call DisplayEditLine(Text , P_faktor , 1 , 0 , 20)

   Text = "I-Faktor  = "
   Call DisplayEditLine(Text , I_faktor , 2 , 0 , 29)

   Text = "D-Faktor  = "
   Call DisplayEditLine(Text , D_faktor , 3 , 0 , 38)

   Text = "MP-Faktor = "
   Call DisplayEditLine(Text , mp_faktor , 4 , 0 , 47)

   Text = "MV-Faktor = "
   Call DisplayEditLine(Text , mv_faktor , 5 , 0 , 56)

   Text = "MPL-Faktor= "
   Call DisplayEditLine(Text , mpl_faktor , 6 , 0 , 65)

   Text = "MVL-Faktor= "
   Call DisplayEditLine(Text , mvl_faktor , 7 , 0 , 74)

   Text = "V-Limit (Kmh) = "
   SingDummy = VLimit
   Call DisplayEditLine(Text , SingDummy , 8 , 0 , 83)

   Text = "0=P 1=PI 2=PID= "
   SingDummy = RegelStrategie
   Call DisplayEditLine(Text , SingDummy , 9 , 0 , 92)

   Text = "IntStep*10      "
   Singdummy = Intstep
   Call Displayeditline(text , Singdummy , 9 , 0 , 101)

   If Btn_Shift = 0 Then                                                      'Werte aus Display bernehmen und in EEPROM speichern
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call PutEEpromData
   End If

 Case 5                                                                       'Werte fr Motorcontroller editieren
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   else
     If SD_Tristate = 1 Then Activate_Display_Bus
   End If

   '**************************************************
   Text = "I-Reg P-Fak= "
   SingDummy = StromRegPfaktor
   Call DisplayEditLine(Text , SingDummy , 1 , 0 , 20)

   Text = "I-Reg I-Fak= "
   SingDummy = StromRegIfaktor
   Call DisplayEditLine(Text , SingDummy , 2 , 0 , 29)

   Text = "I-RegGrenze= "
   SingDummy = StromGrenze
   Call DisplayEditLine(Text , SingDummy , 3 , 0 , 38)

   Text = "PWMmax     = "
   SingDummy = PWMmax
   Call DisplayEditLine(Text , SingDummy , 4 , 0 , 47)

   Text = "I-Batt Max = "
   SingDummy = IBattmax
   Call DisplayEditLine(Text , SingDummy , 5 , 0 , 56)

   If Btn_Shift = 0 Then                                                      'Werte aus Display bernehmen und in EEPROM speichern
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call PutEEpromData
   End If

 Case 6                                                                       'Sinuswerte fr Motorcontroller editieren
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   End If
   If SD_Tristate = 1 Then Activate_Display_Bus

   If Btn_Shift = 0 Then                                                      'Werte aus Display bernehmen und in EEPROM speichern
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call PutEEpromData
   End If

   For Idummy = 1 To 12
     Text = "Sinus" + Str(Idummy) + " = "
     L1 = Idummy * 9
     L1 = L1 + 11
     SingDummy = Sinus(Idummy)                                                'Typecast Int ==> Single
     Call DisplayEditLine(Text , SingDummy , IDummy , 0 , L1)
   Next

 Case 7                                                                       'Min/Max Display
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   else
     If SD_Tristate = 1 Then Activate_Display_Bus
   End If

   If Btn_Shift = 0 Then                                                      'Min-Maxwerte nullen
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call Reset_Minmax
   End If

   Singdummy = Umin / 1000
   Text = "Umin= " + Fusing(Singdummy , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 20 , Black , White)
   '**************************************************
   Singdummy = Umax / 1000
   Text = "Umax= " + Fusing(Singdummy , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 29 , Black , White)
   '**************************************************
   Singdummy = Imin / 1000
   Text = "Imin= " + Fusing(Singdummy , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 38 , Black , White)
   '**************************************************
   Singdummy = Imax / 1000
   Text = "Imax= " + Fusing(Singdummy , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 47 , Black , White)
   '**************************************************
   Singdummy = Kmhmin / 10
   Text = "Vmin= " + Fusing(Singdummy , "#.#")
   Text = Text + "km/h"
   Call DisplayLine(Text , 0 , 56 , Black , White)
   '**************************************************
   Singdummy = KmhMax / 10
   Text = "Vmax= " + Fusing(Singdummy , "#.#")
   Text = Text + "km/h"
   Call DisplayLine(Text , 0 , 65 , Black , White)
   '**************************************************
   Text = "PWM_L_Min= " + Str(PWM_Links_Min )
   Call DisplayLine(Text , 0 , 74 , Black , White)
   '**************************************************
   Text = "PWM_L_Max= " + Str(PWM_Links_Max )
   Call DisplayLine(Text , 0 , 83 , Black , White)
   '**************************************************
   Text = "TAmax= " + Str(tamax )
   Call DisplayLine(Text , 0 , 92 , Black , White)
   '**************************************************
   'Text = "FussSchalter= " + Str(FussSchalter)
   'Call DisplayLine(Text , 0 , 101 , Black , White)
   '**************************************************
   'Text = "Fuss.Count= " + Str(FussCount)
   'Call DisplayLine(Text , 0 , 110 , Black , White)

   '**************************************************
   'Call DisplayLine(Text , 0 , 128 , Black , White)

 Case 8                                                                       'Rckdarstellung der Sinusparameter
   For Idummy = 1 To 12
     Text = "R-Sinus" + Str(Idummy) + " = " + Str(RueckSinus(Idummy))
     L1 = Idummy * 9
     L1 = L1 + 11
     Call DisplayLine(Text , 0 , L1 , Black , White)
   Next

 Case 9                                                                       'Rckdarstellung div. Werte
   Text = "Ofs_Nick  = " + Str(RueckOffset_Nick)
   Call DisplayLine(Text , 0 , 20 , Black , White)

   Text = "O_nick_u  = " + Str(Rueck_O_Nick_u)
   Call DisplayLine(Text , 0 , 29 , Black , White)

   Text = "O_nick_o  = " + Str(Rueck_O_Nick_o)
   Call DisplayLine(Text , 0 , 38 , Black , White)

   Text = "O_nick_oo = " + Str(Rueck_O_Nick_oo)
   Call DisplayLine(Text , 0 , 47 , Black , White)

   Text = "Regelstrat= " + Str(RueckRegelstrategie)
   Call DisplayLine(Text , 0 , 56 , Black , White)

   Text = "PWMmax    = " + Str(RueckPWMmax)
   Call DisplayLine(Text , 0 , 65 , Black , White)

   Text = "StromReg-P= " + Str(RueckStromReg_Pfaktor)
   Call DisplayLine(Text , 0 , 74 , Black , White)

   Text = "StromReg-I= " + Str(RueckStromReg_Ifaktor)
   Call DisplayLine(Text , 0 , 83 , Black , White)

   Text = "Stromgrenz= " + Str(RueckStromGrenze)                              '30 = 30A
   Call DisplayLine(Text , 0 , 92 , Black , White)

   Text = "I-Batt Max(A)= " + Str(IBattmax)
   Call DisplayLine(Text , 0 , 101 , Black , White)

   Text = "V-Limit(Kmh)= " + Str(RueckVlimit)
   Call DisplayLine(Text , 0 , 110 , Black , White)

   Text = "Richtung    = " + Str(RueckIstRichtung)                            '0=Vorw. 1=Rckw. 2=Leerlauf
   Call DisplayLine(Text , 0 , 119 , Black , White)

   Text = "Update Ctr  = " + Str(UpdateCtr)
   Call DisplayLine(Text , 0 , 128 , Black , White)

 Case 10                                                                      'SD. List 8.3 filenames of the root directory
   BDummy2 = 20                                                               'Zeilennummer im Display
   DateiName = Dir( "*.log")                                                  'The first call to the DIR() function must contain a file mask
   BDummy = Len(DateiName)
   BDummy1 = 0
   While BDummy > 0                                                           'if file found
     Text = DateiName + " "
     LDummy = Filelen(DateiName)
     SingDummy = LDummy / 1024
     If SingDummy < 0.1 then SingDummy = 0.1                                  'KB
     Text = Text + Fusing(SingDummy , "#.#")
     Text = Text + "KB"
     If BDummy2 >= 157 then
       LCD_Print Str(BDummy1) + " more..." , 0 , BDummy2 , 1 , 1 , 1 , Black , White
       Exit While
     else
       LCD_Print Text , 0 , BDummy2 , 1 , 1 , 1 , Black , White
       BDummy2 = BDummy2 + 9
     End If
     Incr BDummy1
     Dateiname = Dir()                                                        'get next file
     BDummy = Len(DateiName)
   Wend

 Case 11                                                                      'Logging
   If SD_Tristate = 0 Then Activate_SD_Bus
   If Antriebaus = 0 Then                                                     'Motoren laufen --> Werte loggen
     If DateiAktuell = 0 Then                                                 'Keine Datei geffnet
       Lname = 1
       Dateilaenge = 1                                                        'Nchste Schleife einmal erzwingen
       While Dateilaenge > 0                                                  'freien Dateinamen suchen
         Dateiname = Str(lname)
         Dateiname = Dateiname + ".log"
         '0 voranstellen, damit sich die Dateien besser sortieren lassen.
         While Len(Dateiname) < 12
           Dateiname = "0" + Dateiname
         Wend
         Dateilaenge = FileLen(Dateiname)                                     'File exists?
         Incr Lname
       Wend
       If SD_Tristate = 1 Then Activate_Display_Bus
       LCD_Print Dateiname , 25 , 55 , 1 , 1 , 1 , Black , White
       If SD_Tristate = 0 Then Activate_SD_Bus
       DateiAktuell = 1
       Loopcount = 0
       Zeit = "00:00:00"
       Open Dateiname For Append As #2
       Logtext = "Zeit;Loopcount;U;I;Nick;Sollspeed;Timer0Ticks;Rueckausg.Ticks;Kmh;Akku%"
       Print #2 , Logtext
     End If
     If Loopcount <> AloopCount Then
       Logtext = Zeit
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(LoopCount)
       Logtext = Logtext + ";"
       U = UBatt
       U = U / 1000                                                           '1mV Auflsung
       Logtext = Logtext + Fusing(U , "#.&")
       Logtext = Logtext + ";"
       I = IBatt
       I = I / 1000                                                           '1mA Auflsung
       Logtext = Logtext + Fusing(I , "#.&")
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(Mit_Acc_Nick)
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(SollSpeed)
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(ta)
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(RueckAusgabeTicks_L)
       Logtext = Logtext + ";"
       Singdummy = Kmh / 10
       Logtext = Logtext + Fusing(SingDummy , "#.&")
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(Akkustand)
       Print #2 , Logtext
       Aloopcount = Loopcount
       Incr LoopCount
     End If
   Else
     Close #2
     DateiAktuell = 0
     If Loopcount = 0 then
       Kill Dateiname                                                         'Es wurden keine Daten gespeichert
     else
       Call LCD_Print( "File closed" , 0 , 140 , 1 , 1 , 1 , White , Black)
     end if
   End If
 End Select
Loop
end

'***************************************************************************
Sub Datenempfang
  Local n as Byte , nn as Byte , B as Byte

 'Die empfangenen Zeichen im nach links laufenden Umlauf in Empfpuffer(x) geschrieben
 'Dadurch wir sichergestellt, dass das gesendete Endezeichen (CR) als
 'Startzeichen irgendwann im Ep0 steht

 'Zeichen im Puffer nach links schieben
 !LDS R24,{Ep1}                                                               'Load Direct from data space @address xxx
 !STS {Ep0},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep2}                                                               'Load Direct from data space @address xxx
 !STS {Ep1},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep3}                                                               'Load Direct from data space @address xxx
 !STS {Ep2},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep4}                                                               'Load Direct from data space @address xxx
 !STS {Ep3},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep5}                                                               'Load Direct from data space @address xxx
 !STS {Ep4},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep6}                                                               'Load Direct from data space @address xxx
 !STS {Ep5},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep7}                                                               'Load Direct from data space @address xxx
 !STS {Ep6},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep8}                                                               'Load Direct from data space @address xxx
 !STS {Ep7},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep9}                                                               'Load Direct from data space @address xxx
 !STS {Ep8},R24                                                               'Write Rxx to address loaction
 !LDS R24,{Ep10}                                                              'Load Direct from data space @address xxx
 !STS {Ep9},R24                                                               'Write Rxx to address loaction
 'using COM1
 !IN  R24,UDR1                                                                'neues Zeichen einlese
 !STs {Ep10},R24                                                              'Write Rxx to address loaction

 'Message prfen
 If Ep0 = 13 And Ep10 = 13 Then                                               'Message gltig
  'BCC prfen
  !lds R24,{EP1}                                                              'Index
  !LDs R25,{EP2}
  !add R24,R25
  !LDs R25,{EP3}
  !add R24,R25
  !LDs R25,{EP4}
  !add R24,R25
  !LDs R25,{EP5}
  !add R24,R25
  !LDs R25,{EP6}
  !add R24,R25
  !LDs R25,{EP7}
  !add R24,R25
  !LDs R25,{EP8}
  !add R24,R25
  !STS {B_dummy},R24

  If B_dummy = EP9 then                                                       'Die Prfsumme stimmt
   Select Case EP1                                                            'Telegrammnummer
    Case &H65
     Kmh1 = EP2                                                               'in 0,1 Schritten
     Kmh2 = EP3
     Kilometer1 = EP4
     Kilometer2 = EP5
     Meter1 = EP6
     Meter2 = EP7
     '=EP8
    Case &H66
     Halltest = EP2
     ErrorWord1 = EP3
     ErrorWord2 = EP4
     UBatt1 = EP5                                                             '1mV  Auflsung
     UBatt2 = EP6
     UBatt3 = EP7
     UBatt4 = EP8

    Case &H67
     IBatt1 = EP2
     IBatt2 = EP3
     IBatt3 = EP4
     IBatt4 = EP5
     KK_Temp_Links1 = EP6
     KK_Temp_Links2 = EP7
     RueckIstRichtung = EP8

    Case &H68
     RueckLoopCount1 = EP2
     RueckLoopCount2 = EP3
     ADC_Nick1 = EP4
     ADC_Nick2 = EP5
     'Belegt durch High Word von ADC_Nick = EP6
     'Belegt durch High Word von ADC_Nick = EP7
     ' = EP8

    Case &H69
     If Antriebaus = 1 Then
       NullNick1 = EP2                                                        'Nullwert der Neigung vorwrts
       NullNick2 = EP3
       NullNick3 = EP4
       NullNick4 = EP5
       Null_Nick = NullNick
     Else
       Mit_AccNick1 = EP2                                                     'Mittelwert der Neigung vorwrts
       Mit_AccNick2 = EP3
       Mit_AccNick3 = EP4
       Mit_AccNick4 = EP5
       Mit_Acc_Nick = Mit_AccNick
     end if
     RueckAusgabeTicks_L1 = EP6
     RueckAusgabeTicks_L2 = EP7
     ' = EP8

    Case &H6A
     Comerrorsdisplay1 = EP2
     Comerrorsdisplay2 = EP3
     Akkuverbraucht1 = EP4
     Akkuverbraucht2 = EP5
     Comerrorsmotlinks1 = EP6
     Comerrorsmotlinks2 = EP7
     FussCount = EP8

    Case &H6B
     Startup1 = EP2
     Startup2 = EP3
     NotausGrund = EP4
     FussSchalter = EP5                                                       'FussSchalter
     Ta = EP6
     Antriebaus = EP7                                                         ' = EP5
     ' = EP8

    Case &H6C
     RueckSinus(1) = EP2
     RueckSinus(2) = EP3
     RueckSinus(3) = EP4
     RueckSinus(4) = EP5
     RueckSinus(5) = EP6
     RueckSinus(6) = EP7
     Sensor_OK_count = EP8

    Case &H6D
     RueckSinus(7) = EP2
     RueckSinus(8) = EP3
     RueckSinus(9) = EP4
     RueckSinus(10) = EP5
     RueckSinus(11) = EP6
     RueckSinus(12) = EP7
     ' = EP8

    Case &H6E
     RueckStromgrenze = EP2                                                   'in 1A Schritten
     RueckVlimit1 = EP3
     RueckVlimit2 = EP4
     RueckRegelstrategie = EP5
     RueckPWMmax = EP6
     ' = EP7
     ' = EP8

    Case &H6F
     RueckStromReg_Pfaktor1 = EP2
     RueckStromReg_Pfaktor2 = EP3
     RueckStromReg_Pfaktor3 = EP4
     RueckStromReg_Pfaktor4 = EP5
     RueckStromReg_Ifaktor1 = EP6
     RueckStromReg_Ifaktor2 = EP7
     RueckStromReg_Ifaktor3 = EP8
     ' = EP8

    Case &H70
     RueckStromReg_Ifaktor4 = EP2
     '= EP3
     '= EP4
     RueckOffsetNick1 = EP5
     RueckOffsetNick2 = EP6
     RueckOffsetNick3 = EP7
     RueckOffsetNick4 = EP8
     RueckOffset_Nick = RueckOffsetNick

    Case &H71
     Rueck_Onicku1 = EP2
     Rueck_Onicku2 = EP3
     Rueck_Onicku3 = EP4
     Rueck_Onicku4 = EP5
     Rueck_O_nick_u = Rueck_Onicku
     Rueck_Onicko1 = EP6
     Rueck_Onicko2 = EP7
     Rueck_Onicko3 = EP8

    Case &H72
     Rueck_Onicko4 = EP2
     Rueck_O_nick_o = Rueck_Onicko
     Rueck_Onickoo1 = EP3
     Rueck_Onickoo2 = EP4
     Rueck_Onickoo3 = EP5
     Rueck_Onickoo4 = EP6
     Rueck_O_nick_oo = Rueck_Onickoo
     ' = EP7
     ' = EP8

    Case MotorID_L
     Incr Loopcount
     If EP2 < &H04 then                                                       '0..3 ==> Antriebsdaten
      SollRichtung = EP2                                                      'Richtung
      SollSpeed = EP3                                                         'PWM Breite
      ' = EP4
      ' = EP5
      ' = EP6
      ' = EP7
      ' = EP8
     End If

    Case &HFE
     Txdata(1) = 52 + 2                                                         'Anzahl Datenbyte inkl. BCC und CR
     TxData(2) = Sinus(1)
     TxData(3) = Sinus(2)
     TxData(4) = Sinus(3)
     TxData(5) = Sinus(4)
     TxData(6) = Sinus(5)
     TxData(7) = Sinus(6)
     TxData(8) = Sinus(7)
     TxData(9) = Sinus(8)
     TxData(10) = Sinus(9)
     TxData(11) = Sinus(10)
     TxData(12) = Sinus(11)
     TxData(13) = Sinus(12)
     TxData(14) = StromReg_Pfaktor1
     TxData(15) = StromReg_Pfaktor2
     TxData(16) = StromReg_Pfaktor3
     TxData(17) = StromReg_Pfaktor4
     TxData(18) = StromReg_Ifaktor1
     TxData(19) = StromReg_Ifaktor2
     TxData(20) = StromReg_Ifaktor3
     TxData(21) = StromReg_Ifaktor4
     TxData(22) = Regelstrategie
     TxData(23) = PWMmax
     TxData(24) = P_faktor1
     TxData(25) = P_faktor2
     TxData(26) = P_faktor3
     Txdata(27) = P_faktor4
     TxData(28) = I_faktor1
     TxData(29) = I_faktor2
     TxData(30) = I_faktor3
     TxData(31) = I_faktor4
     TxData(32) = D_faktor1
     TxData(33) = D_faktor2
     TxData(34) = D_faktor3
     TxData(35) = D_faktor4
     TxData(36) = Mp_faktor1
     TxData(37) = Mp_faktor2
     TxData(38) = Mp_faktor3
     TxData(39) = Mp_faktor4
     TxData(40) = Mv_faktor1
     TxData(41) = Mv_faktor2
     TxData(42) = Mv_faktor3
     TxData(43) = Mv_faktor4
     Txdata(44) = Intstep1
     Txdata(45) = Intstep2
     Txdata(46) = Strom_grenze
     Txdata(47) = Vlimit1                                                       '223 = 22,3Kmh
     Txdata(48) = Vlimit2
     NickOffset = Nick_Offset
     Txdata(49) = Nickoffset1
     Txdata(50) = Nickoffset2
     Txdata(51) = Nickoffset3
     Txdata(52) = Nickoffset4

     'Send Data to Main Controller
     B_Dummy = 0
     nn = TxData(1) - 2
     For n = 1 to nn
       B = TxData(n)
       B_Dummy = B_Dummy + B                                                  'BCC
       Printbin #1 , B;                                                       'Daten
     Next
     Printbin #1 , B_Dummy ; 13;                                              'BCC und CR

     Incr UpdateCtr
   End Select
  End If                                                                      'BCC ist Ok
 End If                                                                       'Message eingegangen
end sub

'***************************************************************************
Sub Activate_Display_Bus
'(
  Config SPI will not work in Bascom 1.06.x and up, when called a second time
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , _
               Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1

  In SPI mode, speed is not guaranteed by specification, but the minimum supported
  4-bit bus mode clock speed is 12,5 MHz. The maximum SPI speed for AVR 8-bit is
  10MHz, so we set SPI to maximum speed, f osc / 2
')
  Reset Mmc_cs
  Reset SD_Tristate                                                           'Removes SD Card from bus
  Spcr = &B0101_0000
  Set Spsr.spi2x                                                              'doubles speed of SPI output
  SpiInit
End Sub

'***************************************************************************
Sub Activate_SD_Bus
'(
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , _
                  Polarity = High , Phase = 1 , Clockrate = 16 , Noss = 1
  In SPI mode, speed is not guaranteed by specification, but the minimum supported
  4-bit bus mode clock speed is 12,5 MHz. The maximum SPI speed for AVR 8-bit is
  10MHz , so we set SPI to maximum speed , f osc / 2
')
  Set Lcd_port.lcd_cs                                                         'Deactivate Display
  'Reset Portb.1
  'Reset Portb.2
  'Reset Portb.3
  Spcr = &B0101_1101
  Reset Spsr.spi2x
  SpiInit
  Set Mmc_cs                                                                  'activate sd card
  'Set Portb.1
  Set SD_Tristate                                                             'Activate SD Tristate chip
End Sub

'***************************************************************************
Sub DisplayEditLine(byval ConstStr as String * 22 , _Var as Single , _
                    Byval EdtZl as Byte , Byval Xc as Byte , Byval Y as Byte)
 Local TText as String * 22
 Local xx as Byte
 Local Xs as Byte

 If EditState = 1 and EditZeile = EdtZl then
   'Var Name
   Call LCD_Print(ConstStr , Xc , Y , 1 , 1 , 1 , Black , Green)

   'Var start print position
   Xs = len(ConstStr)
   Xs = Xs * 6                                                                'Font size 1 = 7x5
   Xs = Xs + Xc

   'String in front of Highlighted character
   xx = EditSpalte - 1
   If xx > 0 then
     TText = Left(EditStr , xx)
     Call LCD_Print(TText , Xs , Y , 1 , 1 , 1 , Black , Green)
   end if

   'Highlighted character
   xx = xx * 6                                                                'Font size 1 = 7x5
   Xs = Xs + xx
   TText = Mid(EditStr , EditSpalte , 1)
   Call LCD_Print(TText , Xs , Y , 1 , 1 , 1 , Black , Yellow)

   'String behind Highlighted character
   If EditSpalte < len(EditStr) then
     xx = EditSpalte + 1
     Xs = Xs + 6                                                              'Font size 1 = 7x5
     TText = Mid(EditStr , xx , 22)
     Call LCD_Print(TText , Xs , Y , 1 , 1 , 1 , Black , Green)
   end if
 else
   Select Case Modus
    Case 4
      Select Case EdtZl
        Case 1 to 3
         TText = Fusing(_Var , "#.&&&&&")
         TText = Format(TText , "00000000")

        Case 4 to 7
         TText = Fusing(_Var , "#.&&&&&&")

        Case 8                                                                'V-Limit[Kmh]
         xx = Int(_Var)
         TText = Str(xx)
         TText = Format(TText , "00")

        Case 9                                                                'Regelstrategie
         xx = Int(_Var)
         TText = Str(xx)
         TText = Format(TText , "0")
      end select

    Case 5
      Select Case EdtZl
        Case 0

          'invalid
        Case 1 to 2
         TText = Fusing(_Var , "#.&&&&&&")

        Case 3
         xx = Int(_Var)
         TText = Str(xx)
         TText = Format(TText , "00")

        Case 4
         xx = Int(_Var)
         TText = Str(xx)
         TText = Format(TText , "000")

        Case 5
         xx = Int(_Var)
         TText = Str(xx)                                                      'I-Batterie Max in 1A Schritten
         TText = Format(TText , "00")
      end select

    Case 6
      xx = Int(_Var)
      TText = Str(xx)
      TText = Format(TText , "000")
   end select

   TText = ConstStr + TText
   If EditZeile = EdtZl Then
     Call DisplayLine(TText , Xc , Y , Black , Green)
   Else
     Call DisplayLine(TText , Xc , Y , Black , White)
   End If
 end if
end Sub

'***************************************************************************
Sub DisplayLine(Byval Txt As String * 22 , Byval X As Byte , Byval Y As Byte , _
                Byval Txtcolor As Word , Byval Bgrcolor As Word)

 If Len(Txt) > 22 Then
  Txt = Left(Txt , 22)
 Else
  While Len(Txt) < 22
   Txt = Txt + " "                                                            'clear text behind string
  Wend
 End If

 LCD_Print Txt , X , Y , 1 , 1 , 1 , Txtcolor , Bgrcolor
End Sub

'***************************************************************************
Sub DisplayStatusLine(byval Txt As String * 22 , Byval X As Byte , _
                      Byval Y As Byte , Byval Txtcolor As Word , _
                      Byval Bgrcolor As Word)
'Line above base line of main Page display
 Local Text As String * 19

 Text = Txt
 If Len(Text) > 19 Then
  Text = Left(Text , 19)
 Else
  While Len(Text) < 19
   Text = Text + " "
  Wend
 End If
 LCD_Print Text , X , Y , 1 , 1 , 1 , Txtcolor , Bgrcolor
End Sub

'***************************************************************************
Sub Reset_Minmax
 Umin = 0
 Umax = 0
 Imin = 0
 Imax = 0
 Kmhmin = 0
 KmhMax = 0
 PWM_Links_Max = 0
 PWM_Links_Min = 0
 Tamax = 0
End Sub

'***************************************************************************
Sub Drawpagestatics(Byval PageNum as Byte)
 Local X As Byte

 Text = Titel + Str(PageNum)
 Call DisplayLine(Text , 0 , 0 , Yellow , Blue)

 Select Case Modus
  Case 0
   Text = "Start Display"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 1
   LCD_Rect 8 , 84 , 124 , 95 , 0 , Black                                     'Rahmen fr Akku Balken

   LCD_Rect 8 , 100 , 19 , 160 , 0 , Black                                    'Rahmen fr Vertikal Lenker
   LCD_Draw 20 , 130 , 22 , 130 , 0 , Black                                   'Vertikaler Balken, Mitteltick

   LCD_Draw 0 , 167 , 132 , 167 , 0 , Black                                   'Hintergrund der Fuzeile

  Case 2
   Text = "Fehler bzw. Status"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 3
   Text = "Details"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Nick Nullen"
   Call DisplayLine(Text , 0 , 164 , White , Black)

  Case 4
   Text = "Lagereglerparameter"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Save EEPROM"
   Call DisplayLine(Text , 0 , 164 , White , Black)
   EditZeile = 1

  Case 5
   Text = "Mot-Regelparameter"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Save EEPROM"
   Call DisplayLine(Text , 0 , 164 , White , Black)
   EditZeile = 1

  Case 6
   Text = "Sinussollwerte"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Save EEPROM"
   Call DisplayLine(Text , 0 , 164 , White , Black)
   EditZeile = 1

  Case 7
   Text = "Min- / Max- Werte"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Reset"
   Call DisplayLine(Text , 0 , 164 , White , Black)

  Case 8
   Text = "Rckdarst.Sinus"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 9
   Text = "Rckdarst.Gyro"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 10
   Text = "SD-DIR"
   X = Len(Text) * 6                                                          'Font size 1
   X = X / 2                                                                  'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 11
   Call LCD_Print( "LOGGING" , 30 , 20 , 2 , 1 , 2 , Black , White)
   'LCD_Print Dateiname , 25 , 55 ....
   Call LCD_Print( "Close file by dis-" , 0 , 80 , 1 , 1 , 1 , Black , White)
   Call LCD_Print( "abling RUN while on" , 0 , 90 , 1 , 1 , 1 , Black , White)
   Call LCD_Print( "this page" , 0 , 100 , 1 , 1 , 1 , Black , White)
   DateiAktuell = 0
 End Select
End Sub

'***************************************************************************
Sub PutEEpromData()
 Local tempn as Byte

 EStartkilometer = Startkilometer
 ENick_Offset = Null_Nick
 For tempn = 1 to 12
  ESinus(tempn) = Sinus(tempn)
 next
 EIBattMax = IBattMax
 EP_faktor = P_faktor
 EI_faktor = I_faktor
 ED_faktor = D_faktor
 EMp_faktor = Mp_faktor
 EMv_faktor = Mv_faktor
 EMpl_faktor = Mpl_faktor
 EMvl_faktor = Mvl_faktor
 ERegelstrategie = Regelstrategie
 EPWMmax = PWMmax
 EStromReg_Pfaktor = StromReg_Pfaktor
 EStromReg_Ifaktor = StromReg_Ifaktor
 EStrom_Grenze = Strom_Grenze
 EVLimit = VLimit

 Call Lcd_cls
 LCD_Print "Werte in" , 0 , 20 , 2 , 1 , 1 , Black , Red
 LCD_Print "EEPROM" , 0 , 40 , 2 , 1 , 1 , Black , Red
 LCD_Print "gespeichert" , 0 , 60 , 2 , 1 , 1 , Black , Red

 Call GetEEpromData
 Wait 2
 Call LCD_cls
 Call Drawpagestatics(Modus)
End Sub

'***************************************************************************
Sub GetEEpromData()
 Local tempn as Byte

 Startkilometer = EStartkilometer
 Nick_Offset = ENick_Offset
 Null_Nick = Nick_Offset
 For Tempn = 1 to 12
  Sinus(tempn) = ESinus(tempn)
 next
 StromReg_Pfaktor = EStromReg_Pfaktor
 StromReg_Ifaktor = EStromReg_Ifaktor
 Strom_Grenze = EStrom_Grenze
 P_faktor = EP_faktor
 I_faktor = EI_faktor
 D_faktor = ED_faktor
 Mp_faktor = EMp_faktor
 Mv_faktor = EMv_faktor
 Mpl_faktor = EMpl_faktor
 Mvl_faktor = EMvl_faktor
 Regelstrategie = ERegelstrategie
 PWMmax = EPWMmax
 VLimit = EVLimit
 IBattMax = EIBattMax
end sub

'***************************************************************************
$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_display3000.bas"
$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_fonts.bas"

Colortable:
 Data 0