'****************Listrik01 LCD Display Steuerung Version 01a *****************
const DisplayType = "D074x"                                                     'or "D071x"

#if DisplayType = "D071x"
 const F_CPU = 16000000
#endif

#if DisplayType = "D074x"
 const F_CPU = 14745600
#endif

'SourceCPU = "Desk" or "Lap"
Const Sourcecpu = "Desk"

$hwstack = 256
$swstack = 256
$framesize = 128
$regfile = "m2561def.dat"                                                       'ATMEGA2561 CPU
$crystal = F_CPU                                                                'microcontroller crystal frequency

'( Siehe http://eleccelerator.com/fusecalc/fusecalc.php?chip=atmega2561
Fuse Bits:
BODLEVEL = Disabled
OCDEN = Disabled
JTAGEN = Disabled
Spien = Enabled
WDTON = Disabled
EESAVE = Enabled
BOOTSZ = 4096W_1F000
BOOTRST = Disabled
CKDIV8 = Disabled
CKOUT = Disabled
Sut_cksel = Ext.Crystal:Osc_8.0- MHz,Startuptime 16KCK+65ms

Lockbits:
All disabled

LockBit , FuseBitLow , FuseBitHigh , FuseBitExtended
')
'$prog &HFF , &HFF , &HD1 , &HFF

Declare Sub Activate_Display_Bus
Declare Sub Activate_SD_Bus

'***** EEprom *****
Dim Dummy As Eram Byte                                                          'offset &H00
Dim EStartkilometer As Eram Single
Dim Enull_nick As Eram Long
Dim EIBattMax As Eram Byte
Dim Ep_faktor As Eram Single
Dim Ei_faktor As Eram Single
Dim Ed_faktor As Eram Single
Dim EMp_faktor As Eram Single
Dim EMv_faktor As Eram Single
Dim EMpl_faktor As Eram Single
Dim EMvl_faktor As Eram Single
Dim ERegelStrategie as Eram Byte
Dim EPWMmax as Eram Byte
Dim EStromReg_Pfaktor as Eram Single
Dim Estromreg_ifaktor As Eram Single
Dim EStrom_Grenze as Eram Byte                                                  '30 = 30A
Dim EVLimit as Eram Byte                                                        '20 = 20 Kmh
'***** EEprom *****

Dim X As Byte
Dim Dbyte As Byte
Dim Dbyte1 As Byte
Dim SDummy as Single
Dim Ldummy As Long
Dim Bdummy as Byte
Dim Wdummy as Word
Dim Idummy as Integer

Dim Text As String * 22

#if DisplayType = "D071x"
 Ddra = &B00000000                                                              'switch all 8 Ports of Port A to input (0), Pin (PA.0 - PA.7)
 Porta = &B11111111                                                             'All port pins have individually selectable pull-up
                         'resistors. Here we enable these pull-up-resisitors, so these Pins are always at logical 1
                         'You must pull these pins to ground(gnd)

 Ddrb = &B01110110                                                              'DDR = Data direction register
                        'switched to output (1) as needed by the display
                        'B0= not used
                        'B1= Lcd_sck
                        'B2= MOSI
                        'B3= MISO
                        'B4= Lcd_reset
                        'B5= Lcd_cs
                        'B6= Lcd_dc
                        'B7= not used
 Portb = &B10111001                                                             'pull-up-Resistors turned on

 'DDR = Data direction register; Port B1, B2, B4, B5, B6 switched to output

 Ddrc = &B00000000                                                              'switch all Ports of Port C to input
 Portc = &B11111111                                                             'all pull-up-Resistors turned on

 Ddrd = &B00000000                                                              'switchall Ports of Port D to input
 Portd = &B11110011                                                             'almost all pull-up-Resistors turned on

 Ddre = &B00000000                                                              'all Input
 Porte = &B11111111                                                             'all pull-up-Resistors turned on

 Ddrf = &B10100000                                                              'F5 (SD CS) and F7=Output (SD Tristate chip activate), all other Input
 Portf = &B01011111                                                             'all pull-up-Resistors turned on

 Ddrg = &B00000000                                                              'all Ports of Port G to input
 Portg = &B11111111                                                             'all pull-up-Resistors turned on

 Btn_Up Alias Pind.7
 Btn_Dn Alias PIND.4
 Btn_Le Alias PinG.1
 Btn_Rt Alias PinG.1
 Btn_Pu Alias PinG.1
 Btn_F1 Alias PinE.5
 Btn_F2 Alias PinE.7
 Bus_State_Rd Alias Pinf.7
 Bus_State_Wr Alias Portf.7
#endif

#if DisplayType = "D074x"
 Ddrb = &B11110111                                                              'DDR = Data direction register; Port B1, B2, B4, B5, B6 switched to output (1) as needed for display data transfer, B0 must be output for SPI master setting, B7 is for display lighting....
 Portb = &B10001000                                                             'pull-up-Resistors turned on on B.3 and B.7

 Ddra = &B00000000                                                              'switch all 8 Ports of Port A to input (0), Pin (PA.0 - PA.7)
 Porta = &B11111111                                                             'All port pins have individually selectable pull-up resistors. Here we enable these pull-up-resisitors, so these Pins are always at logical 1
                                                                                'You need to pull these Pins against ground (GND)

 Ddrc = &B00000000                                                              'switch all Ports of Port C to input
 Portc = &B11111111                                                             'all pull-up-Resistors turned on

 Ddrd = &B00001011                                                              'D.0 and D.1 to output for IC (needed for communication with Real Time Clock) - if IC is not needed, set to "0"
                                                                                'D.3 is TX1, thus needs to be output. If UART1 is not used, set to "0"
 Portd = &B11111100                                                             'pull-up-Resistors turned on

 Ddre = &B00000010                                                              'E.1 is TX0, thus needs to be output. If UART0 is not used, set to "0"
 Porte = &B11111111                                                             'all pull-up-Resistors turned on

 Ddrf = &B10100000                                                              'F.5 and F.7 are needed as outputs for SD card. If no SD card is used, set to "0"
 Portf = &B01011111                                                             'pull-up-Resistors turned on

 Ddrg = &B00000000                                                              'switch all Ports of Port G to input
 Portg = &B11111111                                                             'all pull-up-Resistors turned on

 Btn_Up Alias PinC.4
 Btn_Dn Alias PINC.3
 Btn_Le Alias PinC.2
 Btn_Rt Alias PinC.5
 Btn_Pu Alias PinC.6
 Btn_F1 Alias PinC.1
 Btn_F2 Alias PinC.0
 Bus_State_Rd Alias Pinf.7
 Bus_State_Wr Alias Portf.7
#endif

#if Sourcecpu = "Desk"
  $include "Y:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Init21_Display3000.bas"
#else
  $include "C:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Init21_Display3000.bas"
#endif

'Activate_display_bus
Waitms 100
Gosub Lcd_init
Waitms 100

Orientation = Portrait180                                                       'landscape mode
Graphics_mode = 65k_uncompressed                                                'select the needed color mode, here 65.536 colors

Const Writ2eeprom = 1

Call Activate_Display_Bus

#if Writ2eeprom = 1
 Text = "Write to EEprom.."
 Call Lcd_print(text , 1 , 10 , 1 , 1 , 1 , Black , White)

 EStartkilometer = 99.123                                                       'Km
 ENull_Nick = 300
 EIBattMax = 30                                                                 '30A
 EP_faktor = 0.0037
 Ei_faktor = 0.0006
 Ed_faktor = 0.08
 EMp_faktor = 0.006
 EMv_faktor = 0
 EMpl_faktor = 0
 EMvl_faktor = 0
 ERegelStrategie = 1                                                            'PI
 EPWMmax = 250
 EStromReg_Pfaktor = 0.01
 EStromReg_Ifaktor = 0.0
 EStrom_Grenze = 30                                                             '30A
 EVlimit = 16                                                                   'Kmh
 Text = "Done write to EEprom"
 Call Lcd_print(text , 1 , 9 , 1 , 1 , 1 , Black , White)
 Waitms 1000
#endif

Lcd_cls
Text = "Read from EEprom.."
Call Lcd_print(text , 1 , 9 , 1 , 1 , 1 , Black , White)

Sdummy = Estartkilometer
Text = "StartKilom.:" + Str(sdummy)
Call Lcd_print(text , 1 , 18 , 1 , 1 , 1 , Black , White)

Ldummy = Enull_nick
Text = "Null_Nick:" + Str(ldummy)
Call Lcd_print(text , 1 , 27 , 1 , 1 , 1 , Black , White)

BDummy = EIBattMax
Text = "IBattMax: " + Str(BDummy)
Call Lcd_print(text , 1 , 36 , 1 , 1 , 1 , Black , White)

BDummy = Estrom_grenze
Text = "IStromGrenze: " + Str(BDummy)
Call Lcd_print(text , 1 , 45 , 1 , 1 , 1 , Black , White)

Sdummy = Ep_faktor
Text = "P-Fakt: " + Str(Sdummy)
Call Lcd_print(text , 1 , 54 , 1 , 1 , 1 , Black , White)

Sdummy = Ei_faktor
Text = "I-Fakt:" + Str(Sdummy)
Call Lcd_print(text , 1 , 63 , 1 , 1 , 1 , Black , White)

Sdummy = Ed_faktor
Text = "D-Fakt: " + Str(sdummy)
Call Lcd_print(text , 1 , 72 , 1 , 1 , 1 , Black , White)

Sdummy = Emp_faktor
Text = "MP-Fakt: " + Str(Sdummy)
Call Lcd_print(text , 1 , 81 , 1 , 1 , 1 , Black , White)

Sdummy = Emv_faktor
Text = "MV-Fakt: " + Str(Sdummy)
Call Lcd_print(text , 1 , 90 , 1 , 1 , 1 , Black , White)

Sdummy = Empl_faktor
Text = "MPL-Fakt: " + Str(Sdummy)
Call Lcd_print(text , 1 , 99 , 1 , 1 , 1 , Black , White)

Sdummy = Emvl_faktor
Text = "MPV-Fakt: " + Str(Sdummy)
Call Lcd_print(text , 1 , 108 , 1 , 1 , 1 , Black , White)

Bdummy = ERegelStrategie
Text = "R-Strategie: " + Str(Bdummy) + "  "
Call Lcd_print(text , 1 , 117 , 1 , 1 , 1 , Black , White)

Bdummy = EPWMMax
Text = "PWMmax: " + Str(Bdummy) + "  "
Call Lcd_print(text , 1 , 126 , 1 , 1 , 1 , Black , White)

Bdummy = EVLimit
Text = "EVLimit: " + Str(Bdummy) + "  "
Call Lcd_print(text , 1 , 135 , 1 , 1 , 1 , Black , White)
End

'***************************************************************************
Sub Activate_Display_Bus
'(
  Config SPI will not work in Bascom 1.06.x and up, when called a second time
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , _
         Clockrate = 4 , Noss = 1
  Set Spsr.spi2x       'hidden parameter: doubles the speed of the SPI output
  Spiinit

   >>>>>>>>>>>> Workaround for Config SPI <<<<<<<<<<<<<<<<<
  *** SPCR SPI CONTROL REGISTER ***
  0 = SPR0: SPI Clock Rate Select 1 and 0
  1 = SPR1
              SPI2X SPR1 SPR0 SCK Frequency
               0     0     0  fosc /4
               0     0     1  fosc /16
               0     1     0  fosc /64
               0     1     1  fosc /128
               1     0     0  fosc /2
               1     0     1  fosc /8
               1     1     0  fosc /32
               1     1     1  fosc /64
  2 = CPHA: Clock Phase 0 or 1
  3 = CPOL: Clock Polarity, 0 = Rising Falling(Low), 1 = Falling Rising(High)
  4 = MSTR: Master/Slave Select  Master SPI mode = 1, Slave SPI mode = 0
  5 = DORD: MSB first = 0, LSB first = 1
  6 = SPE : SPI Enable = 1
  7 = SPIE: SPI Interrupt Enable = 1

 In SPI mode, speed is not guaranteed by specification, but the minimum supported 4-bit bus mode clock speed is
 12,5 MHz. The maximum SPI speed for AVR 8-bit is 10MHz, so we set SPI to maximum speed, f osc / 2
')
 Reset Bus_State_Wr                                                             'Remove SD Card from bus
 Spcr = &B01010000
 Set Spsr.spi2x
 'Don't call Spiinit again
End Sub

Sub Activate_SD_Bus
 Set Lcd_port.lcd_cs                                                            'High ==> Deactivate Display

'(Config SPI will not work in Bascom 2.0.7.6 and up, when called a second time
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , _
         Clockrate = 4 , Noss = 1
  Reset Spsr.spi2x
  Spiinit

 Workaround for Config SPI: See above
')
 Spcr = &B01011100
 Reset Spsr.spi2x
 'Don't call Spiinit again
 Set Bus_State_Wr                                                               'Activate SD Tristate chip
End Sub

#if Sourcecpu = "Desk"
  $include "Y:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_display3000.bas"
  $include "Y:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_fonts.bas"
#else
  $include "C:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_display3000.bas"
  $include "C:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_fonts.bas"
#endif

Colortable:
 Data 0