'****************Listrik01 LCD Display Steuerung Version 03 *****************
$hwstack = 256
$swstack = 256
$framesize = 128
$regfile = "m2561def.dat"                                                       'ATMEGA2561 CPU
const F_CPU = 16000000
$crystal = F_CPU

'( Siehe http://eleccelerator.com/fusecalc/fusecalc.php?chip=atmega2561
Fuse Bits:
BODLEVEL = Disabled
Ocden = Disabled
JTAGEN = Disabled
Spien = Enabled
WDTON = Disabled
EESAVE = Enabled
BOOTSZ = 4096W_1F000
BOOTRST = Disabled
CKDIV8 = Disabled
CKOUT = Disabled
Sut_cksel = Ext.Crystal:Osc_8.0- MHz,Startuptime 16KCK+65ms

Lockbits:
All disabled

LockBit , FuseBitLow , FuseBitHigh , FuseBitExtended
')
'$prog &HFF , &HFF , &HD1 , &HFF
'( ************ Display3000, D074 Modul mit Folientastatur ************
   ---------------------
 |                     |
 |  ----------------   |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |1|    |2|      |  |  1 = Pmotlinks
 |  |---------------|  |  2 = Zyklusdauer
 |                     |
 |          Up         | Taster
 |                     |  Up   : Edit: Zeile Aufwrts bzw. Digit inkrementieren
 |       Le Ent Rt     |  Dn   : Edit: Zeile Abwrts bzw. Digit dekrementieren
 |                     |  Le   : Blttern Rckwrts bzw. zeichen links
 |          Dn         |  Rt   : Blttern Vorwrts bzw. zeichen rechts
 |  Shift         Esc  |  Ent  : Edit : EditState bzw. Werte bernehmen
 |                     |  C    : (Cancel) Editieren abbrechen
 -----------------------  Shift:
                              (Modus = 0) ==> Reset Tageskilometerzhler
                              (Modus = 3) ==> Elektrische Nulllage speichern
                                              Vorher muss der Geber-Null
                                              ungefhr richtig eingestellt sein
                              (Modus = 4) ==> Min-Maxwerte nullen
                              (Modus = 6) ==> Werte in EEPROM schreiben
                              (Modus = 7) ==> Werte in EEPROM schreiben

************ Display3000, D074 Modul mit Folientastatur ************

####################### Lcd -routines ######################################

Definition Of Used Ports And Pull Up Resistors.
We are using Port B for the SPI -communication to the LCD Display.

****** SPCR SPI CONTROL REGISTER ******
Max Frequenz erlaubt : viele MHz
Beispiel: 16MHz / 64 = 128 ==> 125KHz
Bit: 2    1    0
   SPI2X SPR1 SPR0 SCK Frequency
     0    0    0 Fosc /4
     0    0    1 fosc /16
     0    1    0 fosc /64
     0    1    1 fosc /128
     1    0    0 fosc/2   ==> doubles the clock rate
     1    0    1 fosc/8   ==> doubles the clock rate
     1    1    0 fosc/32  ==> doubles the clock rate
     1 1 1 fosc / 64 ==> doubles the clock rate

Bit2 = CPHA  CPHA: Clock Phase
Bit3 = CPOL  CPOL: Clock Polarity ==> 0 Rising Falling 1 Falling Rising

Bit4 = Mstr  Mstr : Master / Slave Select this Bit selects master Spi mode when
                  written to "1" , and slave Spi mode when written "0".
Bit5 = DORD  DORD: Data order when the DORD bit is "1", the LSB of the data word
                 is transmitted first.
Bit6 = SPE  SPE: SPI Enable
Bit7 = SPIE  SPIE: SPI Interrupt Enable

Bit      7654_3210
         |||| |||x Clockrate
         |||| ||x  Clockrate
         |||| |x   Phase = 0
         |||| x    Polarity = 0 Rising Falling (low), 1 Falling Rising(High)
         |||x      Master = Yes ==> 1
         ||x       Data Order ==> 0 Msb first, 1 LSB first
         |x        SPI Enable ==> 1
         x         Interrupt = Off ==> 0

****** SPSR SPI Status Register ******
0 = SPI2X
')

'A.0 = Input not used
'A.1 = Input not used
'A.2 = Input not used
'A.3 = Input not used
'A.4 = Input not used
'A.5 = Input not used
'A.6 = Input not used
'A.7 = Input not used
Ddra = &B0000_0000
Porta = &B1111_1111

'B.0 = CS for SD-Card
'B.1 = Output for SCK
'B.2 = Output for MOSI
'B.3 = Input for MISO
'B.4 = Output for LCD
'B.5 = Output for LCD
'B.6 = Output for LCD
'B.7 is for display lighting....
Ddrb = &B1111_0111
Portb = &B1000_1000

'C.0 = not used
'C.1 = not used
'C.2 = Input for Keypad
'C.3 = Input for Keypad
'C.4 = Input for Keypad
'C.5 = Input for Keypad
'C.6 = Input for Keypad
'C.7 = Input for Keypad
Ddrc = &B0000_0000
Portc = &B1111_1111

'D.0 Output for I2C
'D.1 Output for I2C
'D.2 Input for RX1
'D.3 Output for TX1
'D.4 Input not used
'D.5 Input not used
'D.6 Input not used
'D.7 Input not used
Ddrd = &B0000_1000
Portd = &B1111_0111

'E.0 = Input for RX0
'E.1 = Output for TX0
'E.2 = Input not used
'E.3 = Input not used
'E.4 = Input not used
'E.5 = Input not used
'E.6 = Input not used
'E.7 = Input for Keypad
Ddre = &B0000_0010
Porte = &B1111_1101

'F.0 = Input not used
'F.1 = Input not used
'F.2 = Input not used
'F.3 = Input not used
'F.4 = Input not used
'F.5 = Output for SD-Card
'F.6 = Input not used
'F.7 = Output for SD-Card
Ddrf = &B1010_0000
Portf = &B0101_1111                                                             'all pull-up-Resistors turned on

'G.0 = Input not used
'G.1 = Input not used
'G.2 = Input not used
'G.3 = Input not used
'G.4 = Input not used
'G.5 = Input not used
'G.6 = Input not used
'G.7 = Input not used
Ddrg = &B0000_0000
Portg = &B1111_1111                                                             'all pull-up-Resistors turned on

Btn_Up Alias PinC.3
Btn_Dn Alias PINC.4
Btn_Le Alias PinC.2
Btn_Rt Alias PinC.6
Btn_Ent Alias PinC.5
Btn_Esc Alias PinC.7

Btn_Shift Alias PinE.7
SD_Tristate Alias PORTF.7

'#############################################################################

Declare Sub Activate_Display_Bus
Declare Sub Activate_SD_Bus

Declare Sub Reset_Minmax
declare Sub DrawPageStatics(Byval PageNum as Byte)

Declare Sub DisplayLine(Byval Txt As String * 22 , Byval X As Byte , _
                        Byval Y As Byte , Byval Txtcolor As Word , _
                        Byval Bgrcolor As Word)

Declare Sub DisplayStatusLine(Byval Txt As String * 22 , Byval X As Byte , _
                              Byval Y As Byte , Byval Txtcolor As Word , _
                              Byval Bgrcolor As Word)

Declare Sub DisplayEditLine(Byval ConstStr as String * 22 , _Var as Single , _
                            Byval EdtZl as Byte , Byval Xc as Byte , _
                            Byval Y as Byte)
Declare Sub GetEEpromData
Declare Sub PutEEpromData
Declare Sub Datenempfang save

Const Titel = "Tacho 2.0  Page:"

$include "..\..\Listrik01_Common_Vars.bas"

const KeyboardTest = 0

Const PrefixMode = 0

'**** Empfangspuffer ****
#if PrefixMode = 1
  Dim Rx(17) As Byte
  '( **** Empfangspuffer ****
  'Rx(1)     CR
  'Rx(2..5)  Prefix size (uint32)
  'Rx(6)     Msg-ID
  'Rx(7..15) Data  1..9
  'Rx(16)    BCC
  'Rx(17)    CR
  ')

  '**** Sendepuffer ****
  Dim Tx(65) As Byte
  'Tx(1..4)  Prefix
  'Tx(5)     Msg-ID
  'Tx(6..n)  Data  1..n
  'Tx(n+1)   BCC
  'Tx(n+2)   0xFF
#else
  Dim Rx(14) As Byte
  '( **** Empfangspuffer ****
  'Rx(1)     CR
  'Rx(2)     Data length
  'Rx(3)     Msg-ID
  'Rx(4..12) Data  1..9
  'Rx(13)    BCC
  'Rx(14)    0xFF
  ')

  '**** Sendepuffer ****
  Dim Tx(65) As Byte       '
  'Tx(1)     Data length
  'Tx(2)     Msg-ID
  'Tx(3..n)  Data  1..n
  'Tx(n+1)   BCC
  'Tx(n+2)   0xFF
#endif
'**** Empfangspuffer ****

Dim Mit_Acc_Nick As Long                                                        'Nick
Dim Mit_AccNick As Long

Dim Nick_Offset As Long
Dim NickOffset As Long

Dim Null_Nick As Long
Dim NullNick As Long

Dim ADC_Nick As Long
Dim P_faktor As Single
Dim I_faktor As Single
Dim D_faktor As Single
Dim ErrorWord As Word
Dim ValidMsgCtr as Word

Dim Datenempfang_n as Byte

'Gespiegelte Daten vom Motorcontroller
Dim StromRegPfaktor as Integer
Dim StromRegIfaktor as Integer
Dim StromGrenze as Word

Dim Sensor_OK_count as Byte
Dim AntriebAus as Byte
Dim Mp_faktor As Single
Dim Mv_faktor As Single
Dim Mpl_faktor As Single
Dim Mvl_faktor As Single
Dim Sinus(12) As Byte
Dim RueckSinus(12) As Byte
Dim Akkustand As Byte
Dim Kmh As Integer
Dim Kilometer As Integer
Dim Meter As Integer
Dim Rueck_Onick_u as Long
Dim Rueck_O_nick_o as Long
Dim Rueck_Onick_o as Long
Dim Rueck_O_nick_oo as Long
Dim Rueck_Onick_oo as Long
Dim RueckRegelstrategie as Byte
Dim RueckPWMmax as Byte
Dim RueckOffset_Nick as Long
Dim RueckOffsetNick as Long
Dim RueckIstRichtung as Byte
Dim RueckLoopCount as Word
Dim RueckAusgabeTicks_L as Integer                                              'Anzahl Kommutierungen je 10mS, linker Motor
Dim Rueckp_faktor As Single
Dim Ruecki_faktor As Single
Dim Rueckd_faktor As Single
Dim Gyro_nick As Long
Dim K_sum As Single
Dim K_summax As Single
Dim K_summin As Single
Dim Tii as Integer
Dim Fwdangle As Byte
Dim Revangle As Byte
Dim Rfwdangle As Byte
Dim Rrevangle As Byte
Dim Bdummy As Byte
Dim Bdummy1 As Byte
Dim Bdummy2 As Byte
Dim Bdummy3 As Byte
Dim Bdummy4 As Byte
Dim BCC as Byte                                                                 'nur fr COM In
Dim Singdummy As Single
Dim Ldummy As Long
Dim Idummy As Integer
Dim Idummy1 As Integer
Dim B as Byte
Dim KmhMax As Integer
Dim KmhMin As Integer
'Strommessung/Anzeige
Dim IBatt as Long                                                               'mA
Dim I As Single                                                                 'A
Dim Imax As Long                                                                'mA
Dim Imin As Long                                                                'mA
'Spannungsmessung/Anzeige
Dim UBatt As Long                                                               'mV
Dim Umax As Long                                                                'mV
Dim Umin As Long                                                                'mV
Dim U As Single                                                                 'V
Dim PWM_Links_Max As Integer
Dim PWM_Links_Min As Integer
Dim Pwmmax As Byte
Dim Modus As Byte
Dim EditZeile As Byte
Dim Utext As String * 22 , Itext As String * 22 , Ltext As String * 22
Dim L1 As Byte
Dim L2 As Byte
Dim Text As String * 22
Dim Farbe As Word
Dim X1 As Byte
Dim Y1 As Byte
Dim X2 As Byte
Dim Y2 As Byte
Dim Startkilometer As Single
Dim Ta As Byte
Dim Tamax As Byte
Dim Ya As Byte
Dim Xa As Byte
Dim Lname As Long
Dim Dateiname As String * 12
Dim Dateilaenge As Long
Dim DateiAktuell As Byte
Dim Loopcount As Word
Dim Aloopcount As Word
Dim Logtext As String * 255
Dim Zeit As String * 8
Dim FussSchalter As Byte
Dim FussCount As Byte
Dim Dummybyte As Byte
Dim ErrorStr(17) As String * 22
Dim NotAusStr(8) As String * 22
Dim Errorindex As Byte
Dim KK_Temp_Links as Integer
Dim ComErrMainCtrl As Word
Dim ComErrDisplayCtrl As Word
Dim Akkuverbraucht As Integer
Dim Startup As Word
Dim FirstRun as Byte
Dim MotorPosition as Byte
Dim IactMain as Integer
Dim VLimit as Integer
Dim RueckVLimit as Integer
Dim Regelstrategie as Byte
Dim RueckSollRichtung as Byte
Dim RueckSollSpeed as Byte
Dim NotausGrund As Byte
Dim StartupStr(10) As String * 22
Dim PrefixLen As Dword
Dim Intstep As Word : Intstep = 10                                              '10 = step of 1.0

'***** EEprom *****
Dim Dummy As Eram Byte                                                          'offset &H00
Dim EStartkilometer As Eram Single
Dim ENick_Offset As Eram Long
Dim ESinus(12) As Eram Byte
Dim EIBattMax As Eram Byte                                                      '30 = 30A
Dim EP_faktor As Eram Single
Dim EI_faktor As Eram Single
Dim ED_faktor As Eram Single
Dim EMp_faktor As Eram Single
Dim EMv_faktor As Eram Single
Dim EMpl_faktor As Eram Single
Dim EMvl_faktor As Eram Single
Dim ERegelStrategie as Eram Byte
Dim EPWMmax as Eram Byte
Dim Dummy_1 As Eram Byte
Dim Dummy_2 As Eram Byte
Dim Dummy_3 As Eram Byte
Dim Dummy_4 As Eram Byte
Dim Dummy_5 As Eram Byte
Dim Dummy_6 As Eram Byte
Dim Dummy_7 As Eram Byte
Dim Dummy_8 As Eram Byte
Dim Dummy_9 As Eram Byte                                                        '30 = 30A
Dim Evlimit As Eram Integer
'***** EEprom *****

'***** Edit Number *****
Dim EditStr as String * 22
Dim EditState as Byte                                                           '0 = Select Line , 1 = Sel / Mod Decimal
Dim EditSpalte as Byte
Dim EditChar as String * 1
'***** Edit Number *****

Dim TTempStr as string * 22
Dim OK_Str as String * 19
Dim Error_Str as String * 19

'         0000000001111111111   max 19 Zeichen. Nicht mehr Platz auf Page 0
'         1234567890123456789
OK_Str = "Alles OK"
Error_Str = "Fehler stehen an"

'                 0000000001111111111222   max 22 Zeichen
'                 1234567890123456789012
StartupStr(1)  = "Start-Taste entlastet "                                       'Startup.0
StartupStr(2)  = "Kopplung z. Motorcontr"                                       'Startup.1
StartupStr(3)  = "Futaster entlastet   "                                       'Startup.2
StartupStr(4)  = "Antrieb ist AUS       "                                       'Startup.3
StartupStr(5)  = "Systemspg. in Toleranz"                                       'Startup.4
StartupStr(6)  = "Parameter OK          "                                       'Startup.5
StartupStr(7)  = "Sensoren in Mittellage"                                       'Startup.6
StartupStr(8)  = "Futaster belastet    "                                       'Startup.7
StartupStr(9)  = "Reset-Taste bettigt  "                                       'Startup.8
StartupStr(10) = "Bitte aufsteigen      "                                       'Startup.9
                                                                                'Startup.10..15 not used

ErrorStr(1)    = "Spannung ist < 24V "                                          'Errorword.0
ErrorStr(2)    = "Spannung ist < 36V "                                          'Errorword.1
ErrorStr(3)    = "Spannung ist < 48V "                                          'Errorword.2
ErrorStr(4)    = "Gyrowerte verrausch"                                          'Errorword.3
ErrorStr(5)    = "Fusch.lange entlas"                                          'Errorword.4
ErrorStr(6)    = "---                "                                          'Errorword.5
ErrorStr(7)    = "NOT AUS steht an   "                                          'Errorword.6
ErrorStr(8)    = "Rx Timeout         "                                          'Errorword.7
ErrorStr(9)    = "Hallstecker fehlt  "                                          'Errorword.8
ErrorStr(10)   = "---                "                                          'Errorword.9
ErrorStr(11)   = "Motor berstrom    "                                          'Errorword.10
ErrorStr(12)   = "---                "                                          'Errorword.11
ErrorStr(13)   = "Unfallschreiber    "                                          'Errorword.12
ErrorStr(14)   = "Betriebsschreiber  "                                          'Errorword.13
ErrorStr(15)   = "---                "                                          'Errorword.14
ErrorStr(16)   = "---                "                                          'Errorword.15

NotAusStr(1)   = "Fussch.zu lange frei  "                                       'Notausgrund.0
NotAusStr(2)   = "Ausregelzeit zu lange "                                       'Notausgrund.1
NotAusStr(3)   = "Zuweit n. vorne gekipp"                                       'Notausgrund.2
NotAusStr(4)   = "Zuweit n.hinten gekipp"                                       'Notausgrund.3
NotAusStr(5)   = "Hall Fehler           "                                       'Notausgrund.4
NotAusStr(6)   = "Motor berstrom       "                                       'Notausgrund.5
NotAusStr(7)   = "                      "                                       'Notausgrund.6
NotAusStr(8)   = "                      "                                       'Notausgrund.7

Modus = 255

$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Init21_Display3000.bas"
$Include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Config_mmc.bas"

Orientation = Portrait180
If SD_Tristate = 1 Then Activate_Display_Bus

#If KeyboardTest = 1
  do
    Text = "PinA: "
    Text = Text + Bin(PinA)
    LCD_Print Text , 0 , 20 , 1 , 1 , 1 , Black , White
    Text = "PinB: "
    Text = Text + Bin(Pinb)
    LCD_Print Text , 0 , 29 , 1 , 1 , 1 , Black , White
    Text = "PinC: "
    Text = Text + Bin(Pinc)
    LCD_Print Text , 0 , 38 , 1 , 1 , 1 , Black , White
    Text = "PinD: "
    Text = Text + Bin(Pind)
    LCD_Print Text , 0 , 47 , 1 , 1 , 1 , Black , White
    Text = "PinE: "
    Text = Text + Bin(Pine)
    LCD_Print Text , 0 , 56 , 1 , 1 , 1 , Black , White
    Text = "PinF: "
    Text = Text + Bin(Pinf)
    LCD_Print Text , 0 , 65 , 1 , 1 , 1 , Black , White
    Text = "PinG: "
    Text = Text + Bin(Ping)
    LCD_Print Text , 0 , 74 , 1 , 1 , 1 , Black , White
    waitms 300
  loop
#endif

' #############################################################################
' ### Set up time for PWM control (for display dimming)      ##################
' #############################################################################
'(
Config Timer1 = Pwm , Pwm = 8 , Compare C Pwm = Clear Up , _
                Compare C Pwm = Clear Down , Prescale = 64                      'Prescale of 256 might flicker with 8 Mhz modules
Pwm1c = 255                                                                     'starts with 255 = lights OFF
')

If SD_Tristate = 0 Then Activate_SD_Bus
Gbdriveerror = Driveinit()                                                      'Init MMC/SD Card

'brauchen manchmal mehere Versuche
If Gbdriveerror = 0 Then
 waitms 50
 Gbdriveerror = Driveinit()                                                     'Init MMC/SD Card
end if

If Gbdriveerror = 0 Then
 waitms 50
 Gbdriveerror = Driveinit()                                                     'Init MMC/SD Card
end if

If Gbdriveerror = 0 Then
 waitms 50
 Gbdriveerror = Driveinit()                                                     'Init MMC/SD Card
end if

If Gbdriveerror = 0 Then
  $Include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\CONFIG_AVR-DOS.bas"

  Bdummy = InitFileSystem(1)                                                    'Partition 1

  Ldummy = Disksize() / 1024
  Utext = "Size: " + Str(Ldummy)
  Utext = Utext + "KB"

  Ldummy = Diskfree() / 1024
  Itext = "Free: " + Str(Ldummy)
  Itext = Itext + "KB"
End If

If SD_Tristate = 1 Then Activate_Display_Bus

'Font Size 1 = 5x8 Pixel
'Font Size 2 = 8x14 Pixel

Text = "Listrik01"                                                              'zentriert, gro
L1 = Len(Text) * 9                                                              'Font size 2
L1 = L1 / 2                                                                     'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 16 , 2 , 1 , 2 , Black , White

Text = "Walter Software"                                                        'zentriert, klein
L1 = Len(Text) * 6                                                              'Font size 1
L1 = L1 / 2                                                                     'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 50 , 1 , 1 , 1 , Black , White

Text = "Version 02"                                                             'zentriert, klein
L1 = Len(Text) * 6                                                              'Font size 1
L1 = L1 / 2                                                                     'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 70 , 1 , 1 , 1 , Black , White

If Gbdriveerror = 0 Then
  Call Lcd_print( " SD Card OK " , 1 , 90 , 2 , 1 , 2 , White , Green)
  Call Lcd_print(UText , 7 , 120 , 2 , 1 , 1 , Blue , White)
  Call Lcd_print(IText , 7 , 135 , 2 , 1 , 1 , Blue , White)
else
  UText = " SD Card Error " + Str(Gbdriveerror)
  UText = UText + " "
  Call Lcd_print(UText , 1 , 90 , 1 , 1 , 1 , White , Red)
end if

'Display dimming
'(
Call Lcd_print( "TFT Brightness:" , 0 , 140 , 1 , 1 , 1 , Blue , White)
 Call Lcd_print( "000%" , 50 , 160 , 2 , 1 , 1 , Blue , White)
 Waitms 300
 For Bdummy1 = 255 To 0 Step -5
  Pwm1c = Bdummy1
  Waitms 20
  Singdummy = Bdummy1 * 0.39
  Bdummy2 = Singdummy
  Bdummy2 = 100 - Bdummy2
  Text = Str(Bdummy2)
  Text = Format(Text , "000")
  Text = Text + "%"
  Call Lcd_print(Text , 50 , 160 , 2 , 1 , 1 , Blue , White)
Next
')

Call GetEEpromData

'Einige Werte vorbelegen um fehlerhafte Grafik zu vermeiden, falls keine
'serielle Verbindung besteht
Xa = 74
Ya = 130

$baud1 = 57600
Config Com2 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , _
              Databits = 8 , Clockpol = 0
OPEN "com2:" for binary as #1
On Urxc1 Datenempfang Save
Enable Urxc1

Call Reset_Minmax
Modus = 0

Enable Interrupts
Wait 2                                                                          '2 Seconds for Startup Display
Call Lcd_cls()

Call Drawpagestatics(Modus)
FirstRun = 1

Do
 Select Case EditState
  Case 0
   'normales Navigieren
   If Btn_Up = 0 Then                                                           'Zeile nach oben
     Waitms 3 : While Btn_Up = 0 : Wend
     If EditZeile > 1 Then
       Decr EditZeile
     Else
       Select Case Modus
         Case 4
           EditZeile = 9

         Case 5
           EditZeile = 5

         Case 6
           EditZeile = 12
       end select
     End If
   end if

   If Btn_Dn = 0 Then                                                           'Zeile nach unten
     Waitms 3 : While Btn_Dn = 0 : Wend
     If EditState = 0 then
      Select Case Modus
       Case 4
         If EditZeile < 9 Then
           Incr EditZeile
         Else
           EditZeile = 1
         End If
       Case 5
         If EditZeile < 5 Then
           Incr EditZeile
         Else
           EditZeile = 1
         End If
       Case 6
         If EditZeile < 12 Then
           Incr EditZeile
         Else
           EditZeile = 1
         End If
      end select
     end if
   End If

   If Btn_Ent = 0 Then                                                          'bernehmen
    Waitms 3 : While Btn_Ent = 0 : Wend
    EditSpalte = 1
    Select Case Modus
     Case 4
      Select Case Editzeile
        Case 0
          'invalid
        Case 1
         Utext = Fusing(P_faktor , "#.&&&&&")
         EditStr = Format(Utext , "00000000")

        Case 2
         Utext = Fusing(I_faktor , "#.&&&&&")
         EditStr = Format(Utext , "00000000")

        Case 3
         Utext = Fusing(D_faktor , "#.&&&&&")
         EditStr = Format(Utext , "00000000")

        Case 4
         EditStr = Fusing(Mp_faktor , "#.&&&&&&")

        Case 5
         EditStr = Fusing(Mv_faktor , "#.&&&&&&")

        Case 6
         EditStr = Fusing(Mpl_faktor , "#.&&&&&&")

        Case 7
         EditStr = Fusing(Mvl_faktor , "#.&&&&&&")

        Case 8
         Text = Str(Vlimit)
         EditStr = Format(Text , "000")

        Case 9
         Text = Str(Regelstrategie)
         Editstr = Format(text , "0")

        Case 11
         Text = Str(fwdangle)
         Editstr = Format(text , "0")

        Case 12
         Text = Str(revangle)
         Editstr = Format(text , "0")
      end select

     Case 5
      Select Case Editzeile
        Case 0
          'invalid

        Case 1
         SingDummy = StromRegPfaktor
         EditStr = Fusing(SingDummy , "#.&&&&&&")

        Case 2
         SingDummy = StromRegIfaktor
         EditStr = Fusing(SingDummy , "#.&&&&&&")

        Case 3
         Text = Str(StromGrenze)
         EditStr = Format(Text , "00")

        Case 4
         Text = Str(PWMmax)
         EditStr = Format(Text , "000")
      end select

     Case 6
       Text = Str(Sinus(EditZeile))
       EditStr = Format(text , "000")

    end select
    If Editzeile > 0 then EditState = 1
   end if

   If Btn_Esc = 0 Then                                                          'abbrechen
     Waitms 3 : While Btn_Esc = 0 : Wend
     EditState = 0
     EditStr = ""
   end if

   If Btn_Rt = 0 Then                                                           'Blttern vorwrts
     Waitms 3 : While Btn_Rt = 0 : Wend                                         'Debounce Button
     Incr Modus
     EditZeile = 0
     If Gbdriveerror <> 0 then                                                  'Logging nur wenn Antrieb luft
       If Modus >= 10 Then Modus = 0                                            'Skip modes 10 and 11
     elseif Antriebaus = 1 then
       If Modus >= 11 Then Modus = 0                                            'Skip mode 11
     Else
       If Modus > 11 Then Modus = 0
     End If

     If SD_Tristate = 1 Then Activate_Display_Bus
     Call Lcd_cls
     Call Drawpagestatics(Modus)
   End If

   If Btn_Le = 0 Then                                                           'Blttern rckwrts
     Waitms 3 : While Btn_Le = 0 : Wend                                         'Debounce Button
     If Modus > 0 Then
       Decr Modus
     Elseif Gbdriveerror <> 0 Then                                              'Logging nicht zulassen wenn DriveError
       Modus = 9                                                                'Skip modes 10 and 11
     Elseif Antriebaus = 1 Then
       Modus = 10
     Else
       Modus = 11
     End If
     EditZeile = 0
     If SD_Tristate = 1 Then Activate_Display_Bus
     Call Lcd_cls
     Call Drawpagestatics(Modus)
   End If

   'Min/Max Werte speichern
   If Modus <> 11 Then                                                          'Nur wenn nicht geloggt wird
     If UBatt <> 0 and Ta <> 0 Then                                             'Nur wenn auch schon eine Spannung und ein Ta bertragen wurden
      If UBatt > Umax Then Umax = UBatt
      If UBatt < Umin Then Umin = UBatt

      If IBatt > Imax Then Imax = IBatt
      If IBatt < Imin Then Imin = IBatt

      If Kmh > KmhMax Then KmhMax = Kmh
      If Kmh < KmhMin Then KmhMin = Kmh

      If Ta > Tamax Then Tamax = Ta

      If RueckSollSpeed > PWM_Links_Max Then PWM_Links_Max = RueckSollSpeed
      If RueckSollSpeed < PWM_Links_Min Then PWM_Links_Min = RueckSollSpeed
     End If
   End If

  Case 1
   'Wert editieren
   If Btn_Le = 0 Then                                                           'Zahl dekrementieren
     Waitms 3 : While Btn_Le = 0 : Wend
     If EditSpalte > 1 then Decr EditSpalte
   End If

   If Btn_Rt = 0 Then                                                           'Zahl inkrementieren
     Waitms 3 : While Btn_Rt = 0 : Wend
     If EditSpalte < len(EditStr) then Incr EditSpalte
   End If

   EditChar = Mid(EditStr , EditSpalte , 1)

   If Btn_Up = 0 Then
     Waitms 3 : While Btn_Up = 0 : Wend
     If EditChar = "+" then
       EditChar = "-"
     elseif EditChar = "-" then
       EditChar = "+"
     elseif EditChar = "e" or EditChar = "E" or EditChar = "*" or _
            EditChar = "." or EditChar = "," or EditChar = " " then
       'do nothing
     elseif EditChar < "9" then
      FirstRun = val(EditChar) + 1
      EditChar = Str(FirstRun)
     else
       EditChar = "0"
     end if
   end if

   If Btn_Dn = 0 Then
     Waitms 3 : While Btn_Dn = 0 : Wend
     EditChar = Mid(EditStr , EditSpalte , 1)
     If EditChar = "+" then
       EditChar = "-"
     elseif EditChar = "-" then
       EditChar = "+"
     elseif EditChar = "e" or EditChar = "E" or EditChar = "*" or _
            EditChar = "." or EditChar = "," or EditChar = " " then
       'do nothing
     elseif EditChar > "0" then
      FirstRun = val(EditChar) - 1
      EditChar = Str(FirstRun)
     else
       EditChar = "9"
     end if
   end if

   Mid(EditStr , EditSpalte , 1) = EditChar

   If Btn_Esc = 0 Then                                                          'abbrechen
     Waitms 3 : While Btn_Esc = 0 : Wend
     EditState = 0
   end if

   If Btn_Ent = 0 Then                                                          'bernehmen
     Waitms 3 : While Btn_Ent = 0 : Wend
     Select Case Modus
       Case 0 to 3
         'nothing to edit

       Case 4
         Select Case Editzeile
           Case 1
             P_faktor = val(EditStr)

           Case 2
             I_faktor = val(EditStr)

           Case 3
             D_faktor = val(EditStr)

           Case 4
             Mp_faktor = val(EditStr)

           Case 5
             Mv_faktor = val(EditStr)

           Case 6
             Mpl_faktor = val(EditStr)

           Case 7
             Mvl_faktor = val(EditStr)

           Case 8
             Vlimit = val(EditStr)

           Case 9
             Regelstrategie = Val(editstr)

           Case 11
             Fwdangle = Val(editstr)

           Case 12
             Revangle = Val(editstr)
         End Select

       Case 5
         Select Case Editzeile
           Case 1
             StromRegPfaktor = val(EditStr)

           Case 2
             StromRegIfaktor = val(EditStr)

           Case 3
             StromGrenze = val(EditStr)

           Case 4
             PWMmax = val(EditStr)
         End Select

       Case 6
         Sinus(Editzeile) = val(EditStr)

       Case 7 to 11
         'nothing to edit
     end select
     EditState = 0                                                              'end of edit mode
   end if
 end Select

 Select Case Modus
  Case 0                                                                        'Startup
    Bdummy4 = 0
    For Bdummy2 = 1 To 10
      Text = StartupStr(bdummy2)
      Bdummy1 = Bdummy2 * 9                                                     'Position der Textzeile festlegen
      Bdummy1 = Bdummy1 + 20                                                    'Titelzeile bercksichtigen
      If Startup.Bdummy4 > 0 Then
        Call DisplayLine(Text , 0 , Bdummy1 , Black , Green)
      Else
        Call DisplayLine(Text , 0 , Bdummy1 , Black , White)
      End If
      Incr Bdummy4
    Next

    'alle Bedingungen sind erfllt. Umschalten auf Hauptdisplay
    If FirstRun = 1 and Startup.9 = 1 Then
      Modus = 1
      FirstRun = 0
      Call Lcd_cls
      Call Drawpagestatics(Modus)
    End If

  Case 1                                                                        'Hauptdisplay
    If DateiAktuell = 1 Then
      If SD_Tristate = 0 Then Activate_SD_Bus
      Close #2
      DateiAktuell = 0
    End If
    If SD_Tristate = 1 Then Activate_Display_Bus                                'Standard Anzeige

    If Btn_Shift = 0 Then                                                       'Tageskilomerterzhler nullen
      Waitms 3 : While Btn_Shift = 0 : Wend
      Singdummy = Meter / 1000
      Singdummy = Singdummy + Kilometer
      Startkilometer = Singdummy
      EStartkilometer = Startkilometer
    End If

    'Spannung und Strom
    U = UBatt
    U = U / 1000                                                                '1mV Auflsung
    Utext = Fusing(U , "#.&") + "V"
    Utext = " " + Utext

    I = IBatt
    I = I / 1000                                                                '1mA Auflsung
    Itext = Fusing(I , "#.&") + "A "

    L1 = Len(Utext)
    L2 = Len(Itext)
    L1 = L1 + L2
    L2 = 22 - L1
    Ltext = String(l2 , 32)
    Text = Utext + Ltext
    Text = Text + Itext
    LCD_Print Text , 0 , 75 , 1 , 1 , 1 , Black , White

    'Akku in Prozent
    Singdummy = AkkuStand
    Singdummy = 100 - Singdummy                                                 '%
    Idummy = Singdummy
    Text = Str(Idummy)                                                          '00...100%
    Text = "  " + Text + "%  "
    If Idummy > 66 Then
       Farbe = Green
     Elseif Idummy > 33 Then
       Farbe = Yellow
    Else
       Farbe = Red
    End If
    X2 = Singdummy * 1.14                                                       '124 - 8 - 1 - 1 = 114 / 100% = 1.14
    X2 = X2 + 10                                                                '10 wegen der "100 - Sdummy" weiter oben
    If X2 > 123 Then X2 = 123
    If X2 < 9 Then X2 = 9
    Lcd_box X2 , 85 , 123 , 94 , White                                          'Hintergrund lschen
    Lcd_box 9 , 85 , X2 , 94 , Farbe                                            'Balken zeichnen
    'Text mittig platzieren
    L1 = Len(Text)
    L1 = L1 * 5
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 98 , 1 , 1 , 1 , Black , White                        'unterm Balken

    'Kmh
    Singdummy = Kmh / 10
    Text = Fusing(Singdummy , "#.&") + "Kmh  "
    Text = "  " + Text
    'Text mittig platzieren
    L1 = Len(Text)
    L1 = L1 * 8
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 12 , 2 , 1 , 2 , Black , White

    'Km
    Singdummy = Meter / 1000
    Singdummy = Singdummy + Kilometer
    Text = Fusing(Singdummy , "#.&") + "km  "
    L1 = Len(Text) * 5
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 46 , 1 , 1 , 1 , Black , White

    'Tageskilometerzhler
    Singdummy = Singdummy - Startkilometer
    Text = Fusing(singdummy , "#.###")
    Text = Text + "km  "
    L1 = Len(Text) * 5
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 60 , 1 , 1 , 1 , Black , White

    'Motortemperaturen
    Text = "KK-Temp:" + Str(KK_Temp_Links)
    Text = Text + " Cels"
    LCD_Print Text , 25 , 115 , 1 , 1 , 1 , Black , White

    'Antrieb Status
    Text = "Status: "
    If AntriebAus = 1 Then
      Text = Text + "AUS"
    Else
      Text = Text + "RUN"
    end if
    LCD_Print Text , 25 , 124 , 1 , 1 , 1 , Black , White

    'Gyros in Nullposition
    If AntriebAus = 1 and Errorword.3 > 0 Then
      LCD_Print "Gyros in Nullpos." , 25 , 133 , 1 , 1 , 1 , White , Black
    else
      LCD_Print "" , 25 , 133 , 1 , 1 , 1 , Black , White
    end if

    If ErrorWord > 0 or NotausGrund > 0 then
      Call DisplayStatusLine(Error_Str , 20 , 156 , Black , White)              'OK
    else
      Call DisplayStatusLine(OK_Str , 20 , 156 , Black , White)                 'OK
    end if

    '>>>>>>>>>>>> Fusszeile im Display >>>>>>>>>>>>
    '  00000000001111111111222
    '  01234567890123456789012
    '  xxx       xxx
    '   Ta     SollSpeed
    Text = Str(Ta) + "   "                                                      'Ticks
    LCD_Print Text , 0 , 168 , 1 , 1 , 1 , Black , White

    Text = Str(RueckSollSpeed) + "   "                                               'PWM_Links
    LCD_Print Text , 45 , 168 , 1 , 1 , 1 , Black , White

    '>>>>>>>>>>>> Nick Balken <<<<<<<<<<<<<
    If Antriebaus = 1 Then
      '30 Grad ==> 0...300
      ' 5 Grad ==> 50
      '50 Counts / 29 Pixel = 1.7241 Counts per Pixel ==> gerundet = 2 ==> 5.8 Grad
      Ldummy = Nick_Offset - Null_Nick
      Ldummy = Ldummy \ 2
    Else
      '30 Grad ==> -300...+300
      '10 Grad ==> 100 ==> Full Scale
      'Balkenlnge = 29 Pixel
      '100 Counts / 29 Pixel = 3.4483 Counts per Pixel ==> Gerundet = 4 ==> 11,6 Grad
      Ldummy = Mit_Acc_Nick \ 4
    End If

    If Ldummy > 29 Then
      Ldummy = 29
    elseIf Ldummy < -29 Then
      Ldummy = -29
    end if
    Y1 = Ldummy                                                                 'Type Cast Long ==> Byte
    Y1 = Y1 + 130                                                               'Mittenoffset
    LCD_Draw 9 , Ya , 18 , Ya , 0 , White
    LCD_Draw 9 , Y1 , 18 , Y1 , 0 , Black
    Ya = Y1

  Case 2                                                                        'Fehlermeldungen und Motor Notaus Kriterien
   Bdummy2 = 11                                                                 'Y-Position
   For Idummy = 0 To 15                                                         'Errorword.0 ==> ErrorStr(1)
     If Errorword.Idummy > 0 Then
       IDummy1 = Idummy + 1
       Text = "E" + Str(Idummy) + ":"
       Text = Text + ErrorStr(Idummy1)
       Bdummy2 = Bdummy2 + 9                                                    'Grafikzeile
       If BDummy2 < 130 then Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
     End If
   Next

   For Idummy = 0 To 5
     If NotausGrund.Idummy > 0 Then
       IDummy1 = Idummy + 1
       Text = "N" + Str(Idummy1) + ":"
       Text = Text + NotausStr(Idummy1)
       Bdummy2 = Bdummy2 + 9                                                    'Grafikzeile
       If BDummy2 < 130 then Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
     end if
   Next

   While BDummy2 < 112                                                          'Clear lines
     Text = "                "
     Bdummy2 = Bdummy2 + 9                                                      'Grafikzeile
     Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
   wend

   Text = "ValidMsgCtr:" + Str(ValidMsgCtr)
   Call DisplayLine(Text , 0 , 148 , Black , White)

   Text = "ComErrMainCtrl:" + Str(ComErrMainCtrl)
   Call DisplayLine(Text , 0 , 157 , Black , White)

   Text = "ComErrDisplayCtrl:" + Str(ComErrDisplayCtrl)
   Call DisplayLine(Text , 0 , 166 , Black , White)

  Case 3                                                                       'Detail Display
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   End If

   If SD_Tristate = 1 Then Activate_Display_Bus

   If Btn_Shift = 0 Then                                                        'Neigung Nullen
     Waitms 3 : While Btn_Shift = 0 : Wend
     If Antriebaus = 1 Then
       ENick_Offset = Null_Nick
       Nick_Offset = Null_Nick
     End If
   End If

   U = UBatt
   U = U / 1000                                                                 '1mV Auflsung
   Text = "Spannung= " + Fusing(U , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 20 , Black , White)

   I = IBatt
   I = I / 1000                                                                 '1mA Auflsung
   Text = "    Strom= " + Fusing(I , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 29 , Black , White)

   Singdummy = Kmh / 10
   Text = "   Geschw= " + Fusing(Singdummy , "#.&")
   Text = Text + "km/h"
   Call DisplayLine(Text , 0 , 38 , Black , White)

   Singdummy = Meter / 1000
   Singdummy = Singdummy + Kilometer
   Text = "   Gesamt= " + Fusing(Singdummy , "#.###")
   Text = Text + "km  "
   Call DisplayLine(Text , 0 , 47 , Black , White)

   Text = Str(RueckSollSpeed)                                                   'PWM_Links
   Text = "PWM_Links= " + Text
   Call DisplayLine(Text , 0 , 56 , Black , White)

   Text = "Soll Richtg= " + Str(RueckSollRichtung)                              '0=Vorw. 1=Rckw. 2=Leerlauf
   Call DisplayLine(Text , 0 , 65 , Black , White)

   Text = "Soll Speed= " + Str(RueckSollSpeed)                                  '0=Vorw. 1=Rckw. 2=Leerlauf
   Call DisplayLine(Text , 0 , 74 , Black , White)

   Text = "     Akku= " + Str(Akkustand)
   Text = Text + "%"
   Call DisplayLine(Text , 0 , 83 , Black , White)

   Singdummy = Akkuverbraucht / 10
   Text = "AkkuVerb(mAh)= " + Fusing(singdummy , "#.&")
   Call DisplayLine(Text , 0 , 92 , Black , White)

   Text = "     Nick= " + Str(Mit_Acc_Nick)
   Call DisplayLine(Text , 0 , 101 , Black , White)

   Text = "Null_Nick= " + Str(Null_Nick)
   Call DisplayLine(Text , 0 , 110 , Black , White)

   Text = "AusgabeTicks= " + Str(RueckAusgabeTicks_L)
   Call DisplayLine(Text , 0 , 119 , Black , White)

   Text = "LoopCount= " + Str(RueckLoopCount)
   Call DisplayLine(Text , 0 , 128 , Black , White)

   Text = "ADC_Nick= " + Str(ADC_Nick)
   Call DisplayLine(Text , 0 , 137 , Black , White)

   Text = "Sens OK Count= " + Str(Sensor_OK_count)
   Call DisplayLine(Text , 0 , 146 , Black , White)

   Text = Bin(MotorPosition)
   Text = "Ha xxxxDCBA= " + Text
   Call DisplayLine(Text , 0 , 155 , Black , White)

  Case 4                                                                       'Werte fr Hauptcontroller editieren
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   else
     If SD_Tristate = 1 Then Activate_Display_Bus
   End If

   Text = "P-Faktor  = "
   Call DisplayEditLine(Text , P_faktor , 1 , 0 , 20)

   Text = "I-Faktor  = "
   Call DisplayEditLine(Text , I_faktor , 2 , 0 , 29)

   Text = "D-Faktor  = "
   Call DisplayEditLine(Text , D_faktor , 3 , 0 , 38)

   Text = "MP-Faktor = "
   Call DisplayEditLine(Text , mp_faktor , 4 , 0 , 47)

   Text = "MV-Faktor = "
   Call DisplayEditLine(Text , mv_faktor , 5 , 0 , 56)

   Text = "MPL-Faktor= "
   Call DisplayEditLine(Text , mpl_faktor , 6 , 0 , 65)

   Text = "MVL-Faktor= "
   Call DisplayEditLine(Text , mvl_faktor , 7 , 0 , 74)

   Text = "V-Limit (Kmh) = "
   SingDummy = VLimit
   Call DisplayEditLine(Text , SingDummy , 8 , 0 , 83)

   Text = "0=P 1=PI 2=PID= "
   SingDummy = RegelStrategie
   Call DisplayEditLine(Text , SingDummy , 9 , 0 , 92)

   Text = "Mittelwertzyklen"
   Singdummy = Intstep
   Call Displayeditline(text , Singdummy , 9 , 0 , 101)

   Text = "Fwd Angle       "
   Singdummy = Fwdangle
   Call Displayeditline(text , Singdummy , 9 , 0 , 110)

   Text = "Rev Angle       "
   Singdummy = Revangle
   Call Displayeditline(text , Singdummy , 9 , 0 , 119)

   If Btn_Shift = 0 Then                                                        'Werte aus Display bernehmen und in EEPROM speichern
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call PutEEpromData
   End If

  Case 5                                                                        'Werte fr Motorcontroller editieren
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   else
     If SD_Tristate = 1 Then Activate_Display_Bus
   End If

   '**************************************************
   Text = "I-Reg P-Fak= "
   SingDummy = StromRegPfaktor
   Call DisplayEditLine(Text , SingDummy , 1 , 0 , 20)

   Text = "I-Reg I-Fak= "
   SingDummy = StromRegIfaktor
   Call DisplayEditLine(Text , SingDummy , 2 , 0 , 29)

   Text = "I-RegGrenze= "
   SingDummy = StromGrenze
   Call DisplayEditLine(Text , SingDummy , 3 , 0 , 38)

   Text = "PWMmax     = "
   SingDummy = PWMmax
   Call DisplayEditLine(Text , SingDummy , 4 , 0 , 47)

   Text = "n.n        = "
   Singdummy = 0
   Call DisplayEditLine(Text , SingDummy , 5 , 0 , 56)

   If Btn_shift = 0 Then                                                        'Werte aus Display bernehmen und in EEPROM speichern
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call PutEEpromData
   End If

  Case 6                                                                        'Sinuswerte fr Motorcontroller editieren
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   End If
   If SD_Tristate = 1 Then Activate_Display_Bus

   If Btn_Shift = 0 Then                                                        'Werte aus Display bernehmen und in EEPROM speichern
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call PutEEpromData
   End If

   For Idummy = 1 To 12
     Text = "Sinus" + Str(Idummy) + " = "
     L1 = Idummy * 9
     L1 = L1 + 11
     SingDummy = Sinus(Idummy)                                                  'Typecast Int ==> Single
     Call DisplayEditLine(Text , SingDummy , IDummy , 0 , L1)
   Next

  Case 7                                                                        'Min/Max Display
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     Close #2
     DateiAktuell = 0
   else
     If SD_Tristate = 1 Then Activate_Display_Bus
   End If

   If Btn_Shift = 0 Then                                                        'Min-Maxwerte nullen
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call Reset_Minmax
   End If

   Singdummy = Umin / 1000
   Text = "Umin= " + Fusing(Singdummy , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 20 , Black , White)
   '**************************************************
   Singdummy = Umax / 1000
   Text = "Umax= " + Fusing(Singdummy , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 29 , Black , White)
   '**************************************************
   Singdummy = Imin / 1000
   Text = "Imin= " + Fusing(Singdummy , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 38 , Black , White)
   '**************************************************
   Singdummy = Imax / 1000
   Text = "Imax= " + Fusing(Singdummy , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 47 , Black , White)
   '**************************************************
   Singdummy = Kmhmin / 10
   Text = "Vmin= " + Fusing(Singdummy , "#.#")
   Text = Text + "km/h"
   Call DisplayLine(Text , 0 , 56 , Black , White)
   '**************************************************
   Singdummy = KmhMax / 10
   Text = "Vmax= " + Fusing(Singdummy , "#.#")
   Text = Text + "km/h"
   Call DisplayLine(Text , 0 , 65 , Black , White)
   '**************************************************
   Text = "PWM_L_Min= " + Str(PWM_Links_Min )
   Call DisplayLine(Text , 0 , 74 , Black , White)
   '**************************************************
   Text = "PWM_L_Max= " + Str(PWM_Links_Max )
   Call DisplayLine(Text , 0 , 83 , Black , White)
   '**************************************************
   Text = "TAmax= " + Str(tamax )
   Call DisplayLine(Text , 0 , 92 , Black , White)
   '**************************************************
   'Text = "FussSchalter= " + Str(FussSchalter)
   'Call DisplayLine(Text , 0 , 101 , Black , White)
   '**************************************************
   'Text = "Fuss.Count= " + Str(FussCount)
   'Call DisplayLine(Text , 0 , 110 , Black , White)

   '**************************************************
   'Call DisplayLine(Text , 0 , 128 , Black , White)

  Case 8                                                                        'Rckdarstellung der Sinusparameter
   For Idummy = 1 To 12
     Text = "R-Sinus" + Str(Idummy) + " = " + Str(RueckSinus(Idummy))
     L1 = Idummy * 9
     L1 = L1 + 11
     Call DisplayLine(Text , 0 , L1 , Black , White)
   Next

  Case 9                                                                        'Rckdarstellung div. Werte
   Text = "Ofs_Nick  = " + Str(RueckOffset_Nick)
   Call DisplayLine(Text , 0 , 20 , Black , White)

   Text = "O_nick_u  = " + Str(Rueck_ONick_u)
   Call DisplayLine(Text , 0 , 29 , Black , White)

   Text = "O_nick_o  = " + Str(Rueck_ONick_o)
   Call DisplayLine(Text , 0 , 38 , Black , White)

   Text = "O_nick_oo = " + Str(Rueck_O_Nick_oo)
   Call DisplayLine(Text , 0 , 47 , Black , White)

   Text = "Regelstrat= " + Str(RueckRegelstrategie)
   Call DisplayLine(Text , 0 , 56 , Black , White)

   Text = "PWMmax    = " + Str(RueckPWMmax)
   Call DisplayLine(Text , 0 , 65 , Black , White)

   Text = "Fwd-Angle   " + Str(fwdangle)
   Call Displayline(text , 0 , 74 , Black , White)

   Text = "Rev-Angle   " + Str(revangle)
   Call DisplayLine(Text , 0 , 83 , Black , White)

   Text = "Kp          " + Fusing(RueckP_faktor , "#.&&&&&&&")
   Call DisplayLine(Text , 0 , 92 , Black , White)

   Text = "Ki          " + Fusing(RueckI_faktor , "#.&&&&&&&")
   Call Displayline(text , 0 , 101 , Black , White)

   Text = "V-Limit(Kmh)= " + Str(RueckVlimit)
   Call DisplayLine(Text , 0 , 110 , Black , White)

   Text = "Richtung    = " + Str(RueckIstRichtung)                              '0=Vorw. 1=Rckw. 2=Leerlauf
   Call DisplayLine(Text , 0 , 119 , Black , White)

  Case 10                                                                       'SD. List 8.3 filenames of the root directory
   BDummy2 = 20                                                                 'Zeilennummer im Display
   DateiName = Dir( "*.log")                                                    'The first call to the DIR() function must contain a file mask
   BDummy = Len(DateiName)
   BDummy1 = 0
   While BDummy > 0                                                             'if file found
     Text = DateiName + " "
     LDummy = Filelen(DateiName)
     SingDummy = LDummy / 1024
     If SingDummy < 0.1 then SingDummy = 0.1                                    'KB
     Text = Text + Fusing(SingDummy , "#.#")
     Text = Text + "KB"
     If BDummy2 >= 157 then
       LCD_Print Str(BDummy1) + " more..." , 0 , BDummy2 , 1 , 1 , 1 , Black , White
       Exit While
     else
       LCD_Print Text , 0 , BDummy2 , 1 , 1 , 1 , Black , White
       BDummy2 = BDummy2 + 9
     End If
     Incr BDummy1
     Dateiname = Dir()                                                          'get next file
     BDummy = Len(DateiName)
   Wend

  Case 11                                                                       'Logging
   If SD_Tristate = 0 Then Activate_SD_Bus
   If Antriebaus = 0 Then                                                       'Motoren laufen --> Werte loggen
     If DateiAktuell = 0 Then                                                   'Keine Datei geffnet
       Lname = 1
       Dateilaenge = 1                                                          'Nchste Schleife einmal erzwingen
       While Dateilaenge > 0                                                    'freien Dateinamen suchen
         Dateiname = Str(lname)
         Dateiname = Dateiname + ".log"
         '0 voranstellen, damit sich die Dateien besser sortieren lassen.
         While Len(Dateiname) < 12
           Dateiname = "0" + Dateiname
         Wend
         Dateilaenge = FileLen(Dateiname)                                       'File exists?
         Incr Lname
       Wend
       If SD_Tristate = 1 Then Activate_Display_Bus
       LCD_Print Dateiname , 25 , 55 , 1 , 1 , 1 , Black , White
       If SD_Tristate = 0 Then Activate_SD_Bus
       DateiAktuell = 1
       Loopcount = 0
       Zeit = "00:00:00"
       Open Dateiname For Append As #2
       Logtext = "Zeit;Loopcount;U;I;Nick;Sollspeed;Ta;RueckAusgabeTicks_L;Kmh;Akku%"
       Print #2 , Logtext
     End If
     If Loopcount <> AloopCount Then
       Logtext = Zeit
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(LoopCount)
       Logtext = Logtext + ";"
       U = UBatt
       U = U / 1000                                                             '1mV Auflsung
       Logtext = Logtext + Fusing(U , "#.&")
       Logtext = Logtext + ";"
       I = IBatt
       I = I / 1000                                                             '1mA Auflsung
       Logtext = Logtext + Fusing(I , "#.&")
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(Mit_Acc_Nick)
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(RueckSollSpeed)
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(ta)
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(RueckAusgabeTicks_L)
       Logtext = Logtext + ";"
       Singdummy = Kmh / 10
       Logtext = Logtext + Fusing(SingDummy , "#.&")
       Logtext = Logtext + ";"
       Logtext = Logtext + Str(Akkustand)
       Print #2 , Logtext
       Aloopcount = Loopcount
       Incr LoopCount
     End If
   Else
     Close #2
     DateiAktuell = 0
     If Loopcount = 0 then
       Kill Dateiname                                                           'Es wurden keine Daten gespeichert
     else
       Call LCD_Print( "File closed" , 0 , 140 , 1 , 1 , 1 , White , Black)
     end if
   End If
 End Select
Loop
end

'***************************************************************************
Sub Datenempfang
  Local Ti as Word

  'Die empfangenen Zeichen im nach links laufenden Umlauf in Empfpuffer(x) geschrieben
  'Dadurch wir sichergestellt, dass das gesendete Endezeichen (CR) als
  'Startzeichen irgendwann im Rx(1) steht

  'Um 1 Zeichen im Puffer nach links schieben
  $asm
   'PUSH R24;
   '!IN R24,SREG;
   'PUSH R24;

   LDS R24,{Rx(2)}                                                              'Load Direct from data space @address xxx
   STS {Rx(1)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(3)}                                                              'Load Direct from data space @address xxx
   STS {Rx(2)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(4)}                                                              'Load Direct from data space @address xxx
   STS {Rx(3)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(5)}                                                              'Load Direct from data space @address xxx
   STS {Rx(4)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(6)}                                                              'Load Direct from data space @address xxx
   STS {Rx(5)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(7)}                                                              'Load Direct from data space @address xxx
   STS {Rx(6)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(8)}                                                              'Load Direct from data space @address xxx
   STS {Rx(7)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(9)}                                                              'Load Direct from data space @address xxx
   STS {Rx(8)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(10)}                                                             'Load Direct from data space @address xxx
   STS {Rx(9)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(11)}                                                             'Load Direct from data space @address xxx
   STS {Rx(10)},R24                                                             'Write Rxx to address loaction
   LDS R24,{Rx(12)}                                                             'Load Direct from data space @address xxx
   STS {Rx(11)},R24                                                             'Write Rxx to address loaction

  #if PrefixMode = 1
     LDS R24,{Rx(13)}                                                           'Load Direct from data space @address xxx
     STS {Rx(12)},R24                                                           'Write Rxx to address loaction
     LDS R24,{Rx(14)}                                                           'Load Direct from data space @address xxx
     STS {Rx(13)},R24                                                           'Write Rxx to address loaction
     LDS R24,{Rx(15)}                                                           'Load Direct from data space @address xxx
     STS {Rx(14)},R24                                                           'Write Rxx to address loaction
     LDS R24,{Rx(16)}                                                           'Load Direct from data space @address xxx
     STS {Rx(15)},R24                                                           'Write Rxx to address loaction
     'using COM1
     !IN  R24,UDR1                                                              'neues Zeichen einlese
     STs {Rx(16)},R24                                                           'Write Rxx to address loaction

'     POP R24;
'     !Out Sreg,R24;
'     POP R24;
  $end asm
    If Rx(1) = 13 And Rx(6) > $5F And Rx(16) = 13 Then                          'Message gltig
     'MemCopy doesn't work because source and target may not overlap
     'Shift Buffer left to get rid of Prefix
     $asm
'      PUSH R24;
'      !IN R24,SREG;
'      PUSH R24;

      LDS R24,{Rx(6)}                                                           'Load Direct from data space @address xxx
      STS {Rx(1)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(7)}                                                           'Load Direct from data space @address xxx
      STS {Rx(2)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(8)}                                                           'Load Direct from data space @address xxx
      STS {Rx(3)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(9)}                                                           'Load Direct from data space @address xxx
      STS {Rx(4)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(10)}                                                          'Load Direct from data space @address xxx
      STS {Rx(5)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(11)}                                                          'Load Direct from data space @address xxx
      STS {Rx(6)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(12)}                                                          'Load Direct from data space @address xxx
      STS {Rx(7)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(13)}                                                          'Load Direct from data space @address xxx
      STS {Rx(8)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(14)}                                                          'Load Direct from data space @address xxx
      STS {Rx(9)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(15)}                                                          'Load Direct from data space @address xxx
      STS {Rx(10)},R24                                                          'Write Rxx to address loaction

      POP R24;
      !Out Sreg,R24;
      POP R24;
     $end asm
    else
      Exit Sub
    end if
  #else
    !IN  R24,UDR1                                                               'using COM1. Neues Zeichen einlese
    STs {Rx(12)},R24                                                            'Write Rxx to address loaction

'    POP R24;
'    !Out Sreg,R24;
'    POP R24;
  $end asm
    If Rx(1) = 13 and Rx(2) > $5F And Rx(12) = 13 Then                          'Message gltig
      'Shift Buffer left to get rid of Prefix
      $asm
'        PUSH R24;
'        !IN R24,SREG;
'        PUSH R24;

        LDS R24,{Rx(2)}                                                         'Load Direct from data space @address xxx
        STS {Rx(1)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(3)}                                                         'Load Direct from data space @address xxx
        STS {Rx(2)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(4)}                                                         'Load Direct from data space @address xxx
        STS {Rx(3)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(5)}                                                         'Load Direct from data space @address xxx
        STS {Rx(4)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(6)}                                                         'Load Direct from data space @address xxx
        STS {Rx(5)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(7)}                                                         'Load Direct from data space @address xxx
        STS {Rx(6)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(8)}                                                         'Load Direct from data space @address xxx
        STS {Rx(7)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(9)}                                                         'Load Direct from data space @address xxx
        STS {Rx(8)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(10)}                                                        'Load Direct from data space @address xxx
        STS {Rx(9)},R24                                                         'Write Rxx to address loaction
        LDS R24,{Rx(11)}                                                        'Load Direct from data space @address xxx
        STS {Rx(10)},R24                                                        'Write Rxx to address loaction

'        POP R24;
'        !Out Sreg,R24;
'        POP R24;
      $end asm
    else
      Exit Sub
    end if
  #endif

  'Buffer now:
  'Rx(1)     Msg-Index
  'Rx(2..9)  Data 1..8
  'Rx(10)    BCC
  $asm
'   PUSH R24;
'   !IN R24,SREG;
'   PUSH R24;

   'BCC prfen
   lds R24,{Rx(1)}                                                              'Index
   LDs R25,{Rx(2)}
   add R24,R25
   LDs R25,{Rx(3)}
   add R24,R25
   LDs R25,{Rx(4)}
   add R24,R25
   LDs R25,{Rx(5)}
   add R24,R25
   LDs R25,{Rx(6)}
   add R24,R25
   LDs R25,{Rx(7)}
   add R24,R25
   LDs R25,{Rx(8)}
   add R24,R25
   LDs R25,{Rx(9)}
   add R24,R25
   STS {BCC},R24

'   POP R24;
'   !Out Sreg,R24;
'   POP R24;
  $end asm

  If BCC = Rx(10) then                                                          'Die Prfsumme stimmt
    Select Case Rx(1)
      Case &H65
        Ti = MemCopy(Rx(2), Kmh, 2)
        AkkuStand = Rx(4)
        Ti = MemCopy(Rx(5), Kilometer, 2)
        Ti = MemCopy(Rx(7), Meter, 2)
        MotorPosition = Rx(9)

      Case &H66
        Ti = MemCopy(Rx(2), ErrorWord, 2)
        Ti = MemCopy(Rx(4), UBatt, 4)
        Ti = MemCopy(Rx(8), KK_Temp_Links, 2)

      Case &H67
        Ti = MemCopy(Rx(2), IBatt, 4)
        RueckIstRichtung = Rx(6)
        Ti = MemCopy(Rx(7), RueckLoopCount, 2)
        '= Rx(9)

      Case &H68
        Ti = MemCopy(Rx(2), ADC_Nick, 4)
        Ti = MemCopy(Rx(6), RueckAusgabeTicks_L, 2)
        '= Rx(8)
        '= Rx(9)

      Case &H69
        If Antriebaus = 1 Then
          Ti = MemCopy(Rx(2), NullNick, 4)                                      'Nullwert der Neigung vorwrts
          Null_Nick = NullNick
        Else
          Ti = MemCopy(Rx(2), Mit_AccNick, 4)                                   'Mittelwert der Neigung vorwrts
          Mit_Acc_Nick = Mit_AccNick
        end if
        Ti = MemCopy(Rx(6), Akkuverbraucht, 2)
        Ti = MemCopy(Rx(8), ComErrMainCtrl, 2)

      Case &H6A
        Ti = MemCopy(Rx(2), Startup, 2)
        NotausGrund = Rx(4)
        FussSchalter = Rx(5)                                                    'FussSchalter
        Ta = Rx(6)
        Antriebaus = Rx(7)
        FussCount = Rx(8)
        RueckRegelstrategie = Rx(9)

      Case &H6B
        Ti = MemCopy(Rx(2), RueckSinus(1), 7)
        Sensor_OK_count = Rx(9)

      Case &H6C
        Ti = MemCopy(Rx(2), RueckSinus(8), 5)
        Ti = MemCopy(Rx(7), Rueckvlimit, 2)
        RueckPWMmax = Rx(9)

      Case &H6D
        Ti = MemCopy(Rx(2), RueckOffset_Nick, 4)
        Ti = MemCopy(Rx(2), Rueck_Onick_oo, 4)

      Case &H6E
        Ti = MemCopy(Rx(2), Rueck_Onick_u, 4)
        Ti = MemCopy(Rx(2), Rueck_O_Nick_o, 4)

      Case &H6F
        Ti = MemCopy(Rx(2), Rueckp_Faktor, 4)
        Ti = MemCopy(Rx(2), Ruecki_Faktor, 4)

      Case &H70
        Ti = MemCopy(Rx(2), Rueckd_Faktor, 4)
        Ti = MemCopy(Rx(2), RueckOffsetNick, 4)

      Case &H71
        Rfwdangle = Rx(2)
        Rrevangle = Rx(3)
        ' = Rx(4)
        ' = Rx(5)
        ' = Rx(6)
        ' = Rx(7)
        ' = Rx(8)
        ' = Rx(9)

      Case MotorID_L
        Incr Loopcount
        If Rx(2) < &H04 then                                                    '0..3 ==> Antriebsdaten
          RueckSollRichtung = Rx(2)                                             'Richtung
          RueckSollSpeed = Rx(3)                                                'PWM Breite
          ' = Rx(4)
          ' = Rx(5)
          ' = Rx(6)
          ' = Rx(7)
          ' = Rx(8)
          ' = Rx(9)
        End If

      Case &HFE
        Ti = MemCopy(Sinus(1) , Tx(1), 12)
        Tx(13) = Regelstrategie
        Tx(14) = Pwmmax
        Ti = MemCopy(P_faktor , Tx(15), 4)
        Ti = MemCopy(I_faktor , Tx(19), 4)
        Ti = MemCopy(D_faktor , Tx(23), 4)
        Ti = MemCopy(Mp_faktor , Tx(27), 4)
        Ti = MemCopy(Mv_faktor , Tx(31), 4)
        Ti = MemCopy(Vlimit , Tx(35), 2)
        NickOffset = Nick_Offset
        Ti = MemCopy(Nickoffset , Tx(37), 4)
        Tx(41) = Fwdangle
        Tx(42) = Revangle

        PrefixLen = 42                                                          'Anzahl Datenbyte ohne BCC
        Bdummy3 = 0
        #if PrefixMode = 1
          'MemCopy doesn't work because source and target may not overlap
          for Datenempfang_n = 1 to PrefixLen                                   'make space for Prefix
            Tx(Datenempfang_n + 4) = Tx(Datenempfang_n)
            Bdummy3 = Bdummy3 + Tx(Datenempfang_n)                              'calculate BCC
          next
          PrefixLen = PrefixLen + 2                                             'Datenbyte inkl.BCC und CR
          Ti = MemCopy(PrefixLen, Tx(1), 4)                                     'insert Prefix
          PrefixLen = PrefixLen + 4                                             '+4(Prefix)
          Tx(PrefixLen) = Bdummy3                                               'BCC
          Incr PrefixLen                                                        'Anzahl Datenbyte inkl.CR
          Tx(PrefixLen) = 13

          'Send Data to Main Controller
          For Datenempfang_n = 1 to PrefixLen
            B = Tx(Datenempfang_n)
            Printbin #1 , B                                                     'Data
          Next
        #else
          'Ti = MemCopy(Tx(1), Tx(2), PrefixLen)                                'make space for Prefix
          'doesn't work because source and target may not overlap
          for Datenempfang_n = 1 to PrefixLen
            Tx(Datenempfang_n + 1) = Tx(Datenempfang_n)
            Bdummy3 = Bdummy3 + Tx(Datenempfang_n)                                        'calculate BCC
          next
          PrefixLen = PrefixLen + 2                                             'Datenbyte inkl.BCC und CR
          Tx(1) = PrefixLen                                                     'insert Prefix
          Incr PrefixLen                                                        '+1(Prefix)
          Tx(PrefixLen) = Bdummy3                                                    'BCC
          Incr PrefixLen                                                        'Anzahl Datenbyte inkl.CR
          Tx(PrefixLen) = 13

          'Send Data to Main Controller
          For Datenempfang_n = 1 to PrefixLen
            B = Tx(Datenempfang_n)
            Printbin #1 , B                                                     'Data
          Next
        #endif
    End Select
    Incr ValidMsgCtr
  else
    Incr ComErrDisplayCtrl
  End If
end sub

'***************************************************************************
Sub Activate_Display_Bus
'(
  Config SPI will not work in Bascom 1.06.x and up, when called a second time
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , _
               Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1

  In SPI mode, speed is not guaranteed by specification, but the minimum supported
  4-bit bus mode clock speed is 12,5 MHz. The maximum SPI speed for AVR 8-bit is
  10MHz, so we set SPI to maximum speed, f osc / 2
')
  Reset Mmc_cs
  Reset SD_Tristate                                                             'Removes SD Card from bus
  Spcr = &B0101_0000
  Set Spsr.spi2x                                                                'doubles speed of SPI output
  SpiInit
End Sub

'***************************************************************************
Sub Activate_SD_Bus
'(
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , _
                  Polarity = High , Phase = 1 , Clockrate = 16 , Noss = 1
  In SPI mode, speed is not guaranteed by specification, but the minimum supported
  4-bit bus mode clock speed is 12,5 MHz. The maximum SPI speed for AVR 8-bit is
  10MHz , so we set SPI to maximum speed , f osc / 2
')
  Set Lcd_port.lcd_cs                                                           'Deactivate Display
  'Reset Portb.1
  'Reset Portb.2
  'Reset Portb.3
  Spcr = &B0101_1101
  Reset Spsr.spi2x
  SpiInit
  Set Mmc_cs                                                                    'activate sd card
  'Set Portb.1
  Set SD_Tristate                                                               'Activate SD Tristate chip
End Sub

'***************************************************************************
Sub DisplayEditLine(byval ConstStr as String * 22 , _Var as Single , _
                    Byval EdtZl as Byte , Byval Xc as Byte , Byval Y as Byte)
 Local TText as String * 22
 Local xx as Byte
 Local Xs as Byte

 If EditState = 1 and EditZeile = EdtZl then
   'Var Name
   Call LCD_Print(ConstStr , Xc , Y , 1 , 1 , 1 , Black , Green)

   'Var start print position
   Xs = len(ConstStr)
   Xs = Xs * 6                                                                  'Font size 1 = 7x5
   Xs = Xs + Xc

   'String in front of Highlighted character
   xx = EditSpalte - 1
   If xx > 0 then
     TText = Left(EditStr , xx)
     Call LCD_Print(TText , Xs , Y , 1 , 1 , 1 , Black , Green)
   end if

   'Highlighted character
   xx = xx * 6                                                                  'Font size 1 = 7x5
   Xs = Xs + xx
   TText = Mid(EditStr , EditSpalte , 1)
   Call LCD_Print(TText , Xs , Y , 1 , 1 , 1 , Black , Yellow)

   'String behind Highlighted character
   If EditSpalte < len(EditStr) then
     xx = EditSpalte + 1
     Xs = Xs + 6                                                                'Font size 1 = 7x5
     TText = Mid(EditStr , xx , 22)
     Call LCD_Print(TText , Xs , Y , 1 , 1 , 1 , Black , Green)
   end if
 else
   Select Case Modus
    Case 4
      Select Case EdtZl
        Case 1 to 3
          TText = Fusing(_Var , "#.&&&&&")
          TText = Format(TText , "00000000")

        Case 4 to 7
          TText = Fusing(_Var , "#.&&&&&&")

        Case 8                                                                  'V-Limit[Kmh]
          xx = Int(_Var)
          TText = Str(xx)
          TText = Format(TText , "00")

        Case 9                                                                  'Regelstrategie
          xx = Int(_Var)
          TText = Str(xx)
          TText = Format(TText , "0")
      end select

    Case 5
      Select Case EdtZl
        Case 0

          'invalid
        Case 1 to 2
          TText = Fusing(_Var , "#.&&&&&&")

        Case 3
          xx = Int(_Var)
          TText = Str(xx)
          TText = Format(TText , "00")

        Case 4
          xx = Int(_Var)
          TText = Str(xx)
          TText = Format(TText , "000")

        Case 5
          xx = Int(_Var)
          TText = Str(xx)                                                       'I-Batterie Max in 1A Schritten
          TText = Format(TText , "00")
      end select

    Case 6
      xx = Int(_Var)
      TText = Str(xx)
      TText = Format(TText , "000")
   end select

   TText = ConstStr + TText
   If EditZeile = EdtZl Then
     Call DisplayLine(TText , Xc , Y , Black , Green)
   Else
     Call DisplayLine(TText , Xc , Y , Black , White)
   End If
 end if
end Sub

'***************************************************************************
Sub DisplayLine(Byval Txt As String * 22 , Byval X As Byte , Byval Y As Byte , _
                Byval Txtcolor As Word , Byval Bgrcolor As Word)

 If Len(Txt) > 22 Then
   Txt = Left(Txt , 22)
 Else
   While Len(Txt) < 22
     Txt = Txt + " "                                                            'clear text behind string
   Wend
 End If

 LCD_Print Txt , X , Y , 1 , 1 , 1 , Txtcolor , Bgrcolor
End Sub

'***************************************************************************
Sub DisplayStatusLine(byval Txt As String * 22 , Byval X As Byte , _
                      Byval Y As Byte , Byval Txtcolor As Word , _
                      Byval Bgrcolor As Word)
'Line above base line of main Page display
 Local Text As String * 19

 Text = Txt
 If Len(Text) > 19 Then
   Text = Left(Text , 19)
 Else
   While Len(Text) < 19
     Text = Text + " "
   Wend
 End If
 LCD_Print Text , X , Y , 1 , 1 , 1 , Txtcolor , Bgrcolor
End Sub

'***************************************************************************
Sub Reset_Minmax
  Umin = 0
  Umax = 0
  Imin = 0
  Imax = 0
  Kmhmin = 0
  KmhMax = 0
  PWM_Links_Max = 0
  PWM_Links_Min = 0
  Tamax = 0
End Sub

'***************************************************************************
Sub Drawpagestatics(Byval PageNum as Byte)
 Local X As Byte

 Text = Titel + Str(PageNum)
 Call DisplayLine(Text , 0 , 0 , Yellow , Blue)

 Select Case Modus
  Case 0
   Text = "Start Display"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 1
   LCD_Rect 8 , 84 , 124 , 95 , 0 , Black                                       'Rahmen fr Akku Balken

   LCD_Rect 8 , 100 , 19 , 160 , 0 , Black                                      'Rahmen fr Vertikal Lenker
   LCD_Draw 20 , 130 , 22 , 130 , 0 , Black                                     'Vertikaler Balken, Mitteltick

   LCD_Draw 0 , 167 , 132 , 167 , 0 , Black                                     'Hintergrund der Fuzeile

  Case 2
   Text = "Fehler bzw. Status"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 3
   Text = "Details"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Nick Nullen"
   Call DisplayLine(Text , 0 , 164 , White , Black)

  Case 4
   Text = "Lagereglerparameter"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Save EEPROM"
   Call DisplayLine(Text , 0 , 164 , White , Black)
   EditZeile = 1

  Case 5
   Text = "Mot-Regelparameter"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Save EEPROM"
   Call DisplayLine(Text , 0 , 164 , White , Black)
   EditZeile = 1

  Case 6
   Text = "Sinussollwerte"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Save EEPROM"
   Call DisplayLine(Text , 0 , 164 , White , Black)
   EditZeile = 1

  Case 7
   Text = "Min- / Max- Werte"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Reset"
   Call DisplayLine(Text , 0 , 164 , White , Black)

  Case 8
   Text = "Rckdarst.Sinus"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 9
   Text = "Rckdarst.Gyro"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 10
   Text = "SD-DIR"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 11
   Call LCD_Print( "LOGGING" , 30 , 20 , 2 , 1 , 2 , Black , White)
   'LCD_Print Dateiname , 25 , 55 ....
   Call LCD_Print( "Close file by dis-" , 0 , 80 , 1 , 1 , 1 , Black , White)
   Call LCD_Print( "abling RUN while on" , 0 , 90 , 1 , 1 , 1 , Black , White)
   Call LCD_Print( "this page" , 0 , 100 , 1 , 1 , 1 , Black , White)
   DateiAktuell = 0
 End Select
End Sub

'***************************************************************************
Sub PutEEpromData()
 Local tempn as Byte

 EStartkilometer = Startkilometer
 ENick_Offset = Null_Nick
 For tempn = 1 to 12
  ESinus(tempn) = Sinus(tempn)
 next
 Ep_faktor = P_faktor
 EI_faktor = I_faktor
 ED_faktor = D_faktor
 EMp_faktor = Mp_faktor
 EMv_faktor = Mv_faktor
 EMpl_faktor = Mpl_faktor
 EMvl_faktor = Mvl_faktor
 ERegelstrategie = Regelstrategie
 EPWMmax = PWMmax
 Evlimit = Vlimit

 Call Lcd_cls
 LCD_Print "Werte in" , 0 , 20 , 2 , 1 , 1 , Black , Red
 LCD_Print "EEPROM" , 0 , 40 , 2 , 1 , 1 , Black , Red
 LCD_Print "gespeichert" , 0 , 60 , 2 , 1 , 1 , Black , Red

 Call GetEEpromData
 Wait 2
 Call LCD_cls
 Call Drawpagestatics(Modus)
End Sub

'***************************************************************************
Sub GetEEpromData()
 Local tempn as Byte

 Startkilometer = EStartkilometer
 Nick_Offset = ENick_Offset
 Null_Nick = Nick_Offset
 For Tempn = 1 to 12
  Sinus(tempn) = ESinus(tempn)
 next
 P_faktor = Ep_faktor
 I_faktor = Ei_faktor
 D_faktor = ED_faktor
 Mp_faktor = EMp_faktor
 Mv_faktor = EMv_faktor
 Mpl_faktor = EMpl_faktor
 Mvl_faktor = EMvl_faktor
 Regelstrategie = ERegelstrategie
 PWMmax = EPWMmax
 VLimit = EVLimit
end sub

'***************************************************************************
$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_display3000.bas"
$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_fonts.bas"

Colortable:
 Data 0