'****************Listrik01 LCD Display Steuerung Version 03 *****************
$hwstack = 256
$swstack = 256
$framesize = 128
$regfile = "m2561def.dat"                                                       'ATMEGA2561 CPU
const F_CPU = 16000000
$crystal = F_CPU

'( Siehe http://eleccelerator.com/fusecalc/fusecalc.php?chip=atmega2561
Fuse Bits:
BODLEVEL = Disabled
Ocden = Disabled
JTAGEN = Disabled
Spien = Enabled
WDTON = Disabled
EESAVE = Enabled
BOOTSZ = 4096W_1F000
BOOTRST = Disabled
CKDIV8 = Disabled
CKOUT = Disabled
Sut_cksel = Ext.Crystal:Osc_8.0- MHz,Startuptime 16KCK+65ms

Lockbits:
All disabled

LockBit , FuseBitLow , FuseBitHigh , FuseBitExtended
')
'$prog &HFF , &HFF , &HD1 , &HFF
'( ************ Display3000, D074 Modul mit Folientastatur ************
   ---------------------
 |                     |
 |  ----------------   |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |1|    |2|      |  |  1 = Pmotlinks
 |  |---------------|  |  2 = Zyklusdauer
 |                     |
 |          Up         | Taster
 |                     |  Up   : Edit: Zeile Aufwrts bzw. Digit inkrementieren
 |       Le Ent Rt     |  Dn   : Edit: Zeile Abwrts bzw. Digit dekrementieren
 |                     |  Le   : Blttern Rckwrts bzw. zeichen links
 |          Dn         |  Rt   : Blttern Vorwrts bzw. zeichen rechts
 |  Shift         Esc  |  Ent  : Edit : EditState bzw. Werte bernehmen
 |                     |  C    : (Cancel) Editieren abbrechen
 -----------------------  Shift: wenn...
                              (Page 1)    ==> Reset Tageskilometerzhler
                              (Page 3)    ==> Nulllage der Neigung speichern
                                                Vorher muss der Geber-Null
                                                ungefhr richtig eingestellt sein
                              (Page 4)    ==> Min-Maxwerte nullen
                              (Page 6..7) ==> Werte in EEPROM schreiben

 SD-Karte formatieren:
   FAT (ohne Zusatz) ==> FAT16
   32KB Zuordnungseinheiten

************ Display3000, D074 Modul mit Folientastatur ************

####################### Lcd -routines ######################################

Definition Of Used Ports And Pull Up Resistors.
We are using Port B for the SPI -communication to the LCD Display.

****** SPCR SPI CONTROL REGISTER ******
Max Frequenz erlaubt : viele MHz
Beispiel: 16MHz / 64 = 128 ==> 125KHz
Bit: 2    1    0
   SPI2X SPR1 SPR0 SCK Frequency
     0    0    0 Fosc /4
     0    0    1 fosc /16
     0    1    0 fosc /64
     0    1    1 fosc /128
     1    0    0 fosc/2   ==> doubles the clock rate
     1    0    1 fosc/8   ==> doubles the clock rate
     1    1    0 fosc/32  ==> doubles the clock rate
     1 1 1 fosc / 64 ==> doubles the clock rate

Bit2 = CPHA  CPHA: Clock Phase
Bit3 = CPOL  CPOL: Clock Polarity ==> 0 Rising Falling 1 Falling Rising

Bit4 = Mstr  Mstr : Master / Slave Select this Bit selects master Spi mode when
                  written to "1" , and slave Spi mode when written "0".
Bit5 = DORD  DORD: Data order when the DORD bit is "1", the LSB of the data word
                 is transmitted first.
Bit6 = SPE  SPE: SPI Enable
Bit7 = SPIE  SPIE: SPI Interrupt Enable

Bit      7654_3210
         |||| |||x Clockrate
         |||| ||x  Clockrate
         |||| |x   Phase = 0
         |||| x    Polarity = 0 Rising Falling (low), 1 Falling Rising(High)
         |||x      Master = Yes ==> 1
         ||x       Data Order ==> 0 Msb first, 1 LSB first
         |x        SPI Enable ==> 1
         x         Interrupt = Off ==> 0

****** SPSR SPI Status Register ******
0 = SPI2X
')

'A.0 = Input not used
'A.1 = Input not used
'A.2 = Input not used
'A.3 = Input not used
'A.4 = Input not used
'A.5 = Input not used
'A.6 = Input not used
'A.7 = Input not used
Ddra = &B0000_0000
Porta = &B1111_1111

'B.0 = CS for SD-Card. See "Config_MMC.bas" in program directory
'B.1 = Output for SCK
'B.2 = Output for MOSI
'B.3 = Input for MISO
'B.4 = Output for LCD
'B.5 = Output for LCD
'B.6 = Output for LCD
'B.7 is for display lighting....
Ddrb = &B1111_0111
Portb = &B1000_1000

'C.0 = not used
'C.1 = not used
'C.2 = Input for Keypad
'C.3 = Input for Keypad
'C.4 = Input for Keypad
'C.5 = Input for Keypad
'C.6 = Input for Keypad
'C.7 = Input for Keypad
Ddrc = &B0000_0000
Portc = &B1111_1111

'D.0 Output for I2C
'D.1 Output for I2C
'D.2 Input for RX1
'D.3 Output for TX1
'D.4 Input not used
'D.5 Input not used
'D.6 Input not used
'D.7 Input not used
Ddrd = &B0000_1000
Portd = &B1111_0111

'E.0 = Input for RX0
'E.1 = Output for TX0
'E.2 = Input not used
'E.3 = Input not used
'E.4 = Input not used
'E.5 = Input not used
'E.6 = Input not used
'E.7 = Input for Keypad
Ddre = &B0000_0010
Porte = &B1111_1101

'F.0 = Input not used
'F.1 = Input not used
'F.2 = Input not used
'F.3 = Input not used
'F.4 = Input not used
'F.5 = Output for SD-Card
'F.6 = Input not used
'F.7 = Output for SD-Card
Ddrf = &B1010_0000
Portf = &B0101_1111                                                             'pull-up-Resistors turned on

'G.0 = Input not used
'G.1 = Input not used
'G.2 = Input not used
'G.3 = Input not used
'G.4 = Input not used
'G.5 = Input not used
'G.6 = Input not used
'G.7 = Input not used
Ddrg = &B0000_0000
Portg = &B1111_1111                                                             'all pull-up-Resistors turned on

Btn_Up Alias PinC.3
Btn_Dn Alias PINC.4
Btn_Le Alias PinC.2
Btn_Rt Alias PinC.6
Btn_OK Alias PinC.5
Btn_Esc Alias PinC.7
Btn_Shift Alias PinE.7
SD_Tristate Alias PORTF.7

'############################################################
Declare Sub DisplayBtEditLine(byval ConstStr as String * 22, _Var as Byte , _
                              Byval EdtZl as Byte , Byval Xc as Byte , _
                              Byval Y as Byte)

Declare Sub DisplayFltEditLine(byval ConstStr as String * 22 , _Var as Single , _
                               Byval EdtZl as Byte , Byval Xc as Byte , _
                               Byval Y as Byte)

Declare Sub DisplayIntEditLine(byval ConstStr as String * 22, _Var as Integer , _
                               Byval EdtZl as Byte , Byval Xc as Byte , _
                               Byval Y as Byte)
Declare Sub InitEEpromData
Declare Sub Activate_Display_Bus
Declare Sub Activate_SD_Bus
Declare Sub Reset_Minmax
declare Sub DrawPageStatics(Byval PageNum as Byte)

Declare Sub DisplayLine(Byval Txt As String * 22 , Byval X As Byte , _
                        Byval Y As Byte , Byval Txtcolor As Word , _
                        Byval Bgrcolor As Word)

Declare Sub DisplayStatusLine(Byval Txt As String * 22 , Byval X As Byte , _
                              Byval Y As Byte , Byval Txtcolor As Word , _
                              Byval Bgrcolor As Word)
Declare Sub GetEEpromData
Declare Sub PutEEpromData
Declare Sub Datenempfang
Declare Sub SD_Init
'############################################################

Const Titel = "Tacho 2.0  Page:"

$include "..\..\Listrik01_Common_Vars.bas"

Const KeyboardTest = 0

Const PrefixMode = 0

'***** EEprom *****
Dim Dummy            As Eram Byte                                               'offset &H00
Dim EStartkilometer  As Eram Single
Dim ENick_Offset     As Eram Long                                               'Rohwert des Offset 0..1024
Dim ESinus(12)       As Eram Byte
Dim EIBattMax        As Eram Byte                                               '30 = 30A
Dim EP_faktor        As Eram Single
Dim EI_faktor        As Eram Single
Dim ED_faktor        As Eram Single
Dim EMp_faktor       As Eram Single
Dim EMv_faktor       As Eram Single
Dim ERegelStrategie  As Eram Byte
Dim EPWMmax          As Eram Byte
Dim EVlimit          As Eram Integer                                            '125 = 12,5 Kmh
Dim EFwdAngle        As Eram Byte
Dim ERevAngle        As Eram Byte
Dim EFanSwitchLevel  As Eram Byte
'***** EEprom *****

Dim p as Byte

#if PrefixMode = 0
  Dim Rx(14) As Byte
  '( **** Empfangspuffer ****
  'Rx(1)     0x0D
  'Rx(2)     Prefix
  'Rx(3)     Msg-ID
  'Rx(4..12) Data  1..9
  'Rx(13)    BCC
  'Rx(14)    0x0D
  ')

  '**** Sendepuffer ****
  Dim Tx(57) As Byte       '
  'Tx(1)     Data length
  'Tx(2)     Msg-ID
  'Tx(3..55) Data  1..n
  'Tx(56)    BCC
  'Tx(57)    0x0D
  p=1
#else
   Dim Rx(17) As Byte
  '( **** Empfangspuffer ****
  'Rx(1)     CR
  'Rx(2..5)  Prefix size (uint32)
  'Rx(6)     Msg-ID
  'Rx(7..15) Data  1..9
  'Rx(16)    BCC
  'Rx(17)    CR
  ')

  '**** Sendepuffer ****
  Dim Tx(60) As Byte
  'Tx(1..4)  Prefix
  'Tx(5)     Msg-ID
  'Tx(6..58) Data  1..n
  'Tx(59)    BCC
  'Tx(60)    0x0D
  p=4
#endif
'**** Empfangspuffer ****

Dim Mit_Acc_Nick As Long
Dim Mit_AccNick As Long
Dim Nick_Offset As Long                                                         'Rohwert des Offset 0..1024
Dim Null_Nick As Long                                                           'Act Nick (0..1024) whrend Antrieb AUS
Dim P_faktor As Single
Dim I_faktor As Single
Dim D_faktor As Single
Dim ErrorWord As Word
Dim n as Byte
Dim IBattMax as Byte
Dim Sensor_OK_count as Byte
Dim AntriebAus as Byte
Dim Mp_faktor As Single                                                         'Lastabhngige Regelungsverstrkung
Dim Mv_faktor As Single                                                         'Geschwindigkeitsabhngige Regelungsverstrkung
Dim Sinus(12) As Byte
Dim RueckSinus(12) As Byte
Dim Akkustand As Byte
Dim Kmh As Integer
Dim Kilometer As Integer
Dim Meter As Integer
Dim FanSwitchLevel as Byte

Dim Rueck_O_nick_u as Long
Dim Rueck_O_nick_o as Long
Dim Rueck_O_nick_oo as Long
Dim RueckRegelstrategie as Byte
Dim RueckPWMmax as Byte
Dim MainCtrLoopCount as Word
Dim RueckAusgabeTicks_L as Integer                                              'Anzahl Kommutierungen je 10mS, linker Motor
Dim Rueckp_faktor As Single
Dim Ruecki_faktor As Single
Dim Rueckd_faktor As Single
Dim RueckVlimit as Integer
Dim RueckIBattMax as Byte
Dim Rueck_Istrichtung as Byte
Dim RueckSollRichtung as Byte
Dim RueckSollSpeed as Byte

Dim Gyro_nick As Long
Dim K_sum As Single
Dim K_summax As Single
Dim K_summin As Single
Dim Tii as Integer
Dim Fwdangle As Byte
Dim Revangle As Byte
Dim Rfwdangle As Byte
Dim Rrevangle As Byte
Dim Bdummy As Byte
Dim Bdummy1 As Byte
Dim Bdummy2 As Byte
Dim Bdummy3 As Byte
Dim Bdummy4 As Byte
Dim BCC as Byte                                                                 'nur fr COM In
Dim Singdummy As Single
Dim Ldummy As Long
Dim Idummy As Integer
Dim Idummy1 As Integer
Dim ResetGesamtKm as Byte
Dim B as Byte
Dim KmhMax As Integer
Dim KmhMin As Integer
Dim IBatt as Integer                                                            'mA
Dim I As Single                                                                 'A
Dim Imax As Integer                                                             'mA
Dim Imin As Integer                                                             'mA
Dim UBatt As Long                                                               'mV
Dim Umax As Integer                                                             'mV
Dim Umin As Integer                                                             'mV
Dim U As Single                                                                 'V
Dim PWM_Max As Integer
Dim PWM_Min As Integer
Dim PWMmax As Byte
Dim P_Anteil as Integer
Dim I_Anteil as Integer
Dim D_Anteil as Integer
Dim Go as Byte
Dim Page As Byte
Dim EditZeile As Byte
Dim Utext As String * 22
Dim Itext As String * 22
Dim Ltext As String * 22
Dim L1 As Byte
Dim L2 As Byte
Dim Text As String * 22
Dim Farbe As Word
Dim X1 As Byte
Dim Y1 As Byte
Dim X2 As Byte
Dim Y2 As Byte
Dim Startkilometer As Single
Dim Ta As Integer
Dim Tamax As Integer
Dim Ya As Byte
Dim Xa As Byte
Dim Lname As Long
Dim Dateiname As String * 12
Dim Dateilaenge As Long
Dim DateiAktuell As Byte
Dim Loopcount As Word
Dim Aloopcount As Word
Dim Logtext As String * 255
Dim Zeit As String * 8
Dim FussSchalter As Byte
Dim FussCount As Byte
Dim Dummybyte As Byte
Dim ErrorStr(17) As String * 22
Dim NotAusStr(8) As String * 22
Dim Errorindex As Byte
Dim KK_Temperatur as Integer
Dim Motor_Temperatur as Integer
Dim ComErrMainCtrl As Word
Dim Akkuverbraucht As Integer
Dim Startup As Word
Dim FirstRun as Byte
Dim MotorPosition as Byte
Dim IactMain as Integer
Dim VLimit as Integer                                                           '125 = 12,5 Kmh
Dim Regelstrategie as Byte
Dim NotausGrund As Byte
Dim StartupStr(10) As String * 22
Dim PrefixLen As Dword
Dim EditStr as String * 22
Dim EditState as Byte                                                           '0 = Select Line , 1 = Sel / Mod Decimal
Dim EditSpalte as Byte

Dim Txt As String * 22

Dim LL1, LL2, LL3 As Byte

Dim EditChar as String * 1
Dim TTempStr as string * 22
Dim OK_Str as String * 19
Dim Error_Str as String * 19
'            0000000001111111111   max 19 Zeichen. Nicht mehr Platz auf Page 0
'            1234567890123456789
OK_Str =    "Alles OK"
Error_Str = "Fehler vorh."

'                 0000000001111111111222   max 22 Zeichen
'                 1234567890123456789012
StartupStr(1)  = "Start-Taste entlastet "                                       'Startup.0
StartupStr(2)  = "Kopplung z. Motorcontr"                                       'Startup.1
StartupStr(3)  = "Futaster entlastet   "                                       'Startup.2
StartupStr(4)  = "Antrieb ist AUS       "                                       'Startup.3
StartupStr(5)  = "Systemspg. in Toleranz"                                       'Startup.4
StartupStr(6)  = "Parameter OK          "                                       'Startup.5
StartupStr(7)  = "Sensoren in Mittellage"                                       'Startup.6
StartupStr(8)  = "Futaster belastet    "                                       'Startup.7
StartupStr(9)  = "Reset-Taste bettigt  "                                       'Startup.8
StartupStr(10) = "Es geht los...        "                                       'Startup.9
                                                                                'Startup.10..15 not used
'                 0000000001111111111222   max 22 Zeichen
'                 1234567890123456789012
ErrorStr(1)    = "Spannung ist < 24V "                                          'Errorword.0
ErrorStr(2)    = "Spannung ist < 36V "                                          'Errorword.1
ErrorStr(3)    = "Spannung ist < 48V "                                          'Errorword.2
ErrorStr(4)    = "Gyrowerte verrausch"                                          'Errorword.3
ErrorStr(5)    = "Fusch.lange entlas"                                          'Errorword.4
ErrorStr(6)    = "---                "                                          'Errorword.5
ErrorStr(7)    = "NOT AUS steht an   "                                          'Errorword.6
ErrorStr(8)    = "Rx Timeout         "                                          'Errorword.7
ErrorStr(9)    = "Hallstecker fehlt  "                                          'Errorword.8
ErrorStr(10)   = "---                "                                          'Errorword.9
ErrorStr(11)   = "Motor berstrom    "                                          'Errorword.10
ErrorStr(12)   = "---                "                                          'Errorword.11
ErrorStr(13)   = "Unfallschreiber    "                                          'Errorword.12
ErrorStr(14)   = "Betriebsschreiber  "                                          'Errorword.13
ErrorStr(15)   = "---                "                                          'Errorword.14
ErrorStr(16)   = "---                "                                          'Errorword.15

'                 0000000001111111111222   max 22 Zeichen
'                 1234567890123456789012
NotAusStr(1)   = "Fussch.zu lange frei  "                                       'Notausgrund.0
NotAusStr(2)   = "Ausregelzeit zu lange "                                       'Notausgrund.1
NotAusStr(3)   = "Zuweit n. vorne gekipp"                                       'Notausgrund.2
NotAusStr(4)   = "Zuweit n.hinten gekipp"                                       'Notausgrund.3
NotAusStr(5)   = "Hall Fehler           "                                       'Notausgrund.4
NotAusStr(6)   = "Motor berstrom       "                                       'Notausgrund.5
NotAusStr(7)   = "                      "                                       'Notausgrund.6
NotAusStr(8)   = "                      "                                       'Notausgrund.7

$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Init21_Display3000.bas"
$Include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Config_mmc.bas"
'+++++++++++++++++++ Main Program starts here +++++++++++++++++++
Page = 255
Orientation = Portrait180
If SD_Tristate = 1 Then Activate_Display_Bus

#If KeyboardTest = 1
  do
    Text = "PinA: "
    Text = Text + Bin(PinA)
    LCD_Print Text , 0 , 20 , 1 , 1 , 1 , Black , White
    Text = "PinB: "
    Text = Text + Bin(Pinb)
    LCD_Print Text , 0 , 29 , 1 , 1 , 1 , Black , White
    Text = "PinC: "
    Text = Text + Bin(Pinc)
    LCD_Print Text , 0 , 38 , 1 , 1 , 1 , Black , White
    Text = "PinD: "
    Text = Text + Bin(Pind)
    LCD_Print Text , 0 , 47 , 1 , 1 , 1 , Black , White
    Text = "PinE: "
    Text = Text + Bin(Pine)
    LCD_Print Text , 0 , 56 , 1 , 1 , 1 , Black , White
    Text = "PinF: "
    Text = Text + Bin(Pinf)
    LCD_Print Text , 0 , 65 , 1 , 1 , 1 , Black , White
    Text = "PinG: "
    Text = Text + Bin(Ping)
    LCD_Print Text , 0 , 74 , 1 , 1 , 1 , Black , White
    waitms 300
  loop
#endif

'#########################################################
'### Set up time for PWM control (for display dimming) ###
'#########################################################
'(
Config Timer1 = Pwm , Pwm = 8 , Compare C Pwm = Clear Up , _
                Compare C Pwm = Clear Down , Prescale = 64                      'Prescale of 256 might flicker with 8 Mhz modules
Pwm1c = 255                                                                     'starts with 255 = lights OFF
')

Call Lcd_Cls

'Font Size 1 = 5x8 Pixel
'Font Size 2 = 8x14 Pixel

Text = "Listrik01"                                                              'zentriert, gro
L1 = Len(Text) * 9                                                              'Font size 2
L1 = L1 / 2                                                                     'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 16 , 2 , 1 , 2 , Black , White

Text = "Walter Software"                                                        'zentriert, klein
L1 = Len(Text) * 6                                                              'Font size 1
L1 = L1 / 2                                                                     'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 50 , 1 , 1 , 1 , Black , White

Text = "Version 04"                                                             'zentriert, klein
L1 = Len(Text) * 6                                                              'Font size 1
L1 = L1 / 2                                                                     'Mittig
X1 = 66 - L1
LCD_Print Text , X1 , 70 , 1 , 1 , 1 , Black , White

Text = "Start SD Card Test"
Call DisplayLine(Text , 10 , 99 , White , Red)
Text = "No SD Card ?"
Call DisplayLine(Text , 10 , 110 , White , Red)

for n = 1 to 3                                                                  'brauchen manchmal mehere Versuche
  SD_Init
  if Gbdriveerror = 0 Then
    Ldummy = DiskSize() / 1024
    Utext = "Size: " + Str(Ldummy)
    Utext = Utext + "KB"

    Ldummy = DiskFree() / 1024
    Itext = "Free: " + Str(Ldummy)
    Itext = Itext + "KB"

    If SD_Tristate = 1 Then Activate_Display_Bus
    Text = "SD Card OK"
    Call DisplayLine(Text , 10 , 99 , White , Green)
    Call DisplayLine(Utext , 10 , 110 , Blue , White)
    Call DisplayLine(Itext , 10 , 130 , Blue , White)
    Exit for
  else
    If SD_Tristate = 1 Then Activate_Display_Bus
    Text = ".............."
    Call DisplayLine(Text , 10 , 99 , Blue , White)
    Waitms 500
    Text = "SD Card Retry "
    Call DisplayLine(Text , 10 , 99 , Blue , White)
  end if
Next

If Gbdriveerror > 0 Then
  Text = "No SD Card !"
  Call DisplayLine(Text , 10 , 110 , White , Red)
  Text = "GbDriveError:" + Str(Gbdriveerror)
  Call DisplayLine(Text , 10 , 130 , Black , White)
end if

Wait 2                                                                          '2 Seconds for Startup Display

'Display dimming
'(
Lcd_print "TFT Brightness:" , 0 , 140 , 1 , 1 , 1 , Blue , White
Lcd_print "000%" , 50 , 160 , 2 , 1 , 1 , Blue , White
Waitms 300
For Bdummy1 = 255 To 0 Step -5
  Pwm1c = Bdummy1
  Waitms 20
  Singdummy = Bdummy1 * 0.39
  Bdummy2 = Singdummy
  Bdummy2 = 100 - Bdummy2
  Text = Str(Bdummy2)
  Text = Format(Text , "000")
  Text = Text + "%"
  Lcd_print Text , 50 , 160 , 2 , 1 , 1 , Blue , White
Next
')

'Call InitEEpromData()   'Nur bei Bedarf einmal ausfhren!

Call GetEEpromData

'Einige Werte vorbelegen um fehlerhafte Grafik zu vermeiden, falls keine
'serielle Verbindung besteht
Xa = 74
Ya = 130

Config COM2 = 115200 , Synchrone = 0 , Parity = None , Stopbits = 1 , _
              Databits = 8 , Clockpol = 0
OPEN "COM2:" for binary as #1
On URXC1 Datenempfang saveall
Enable URXC1

Call Reset_Minmax

Enable Interrupts
Call Lcd_cls

Page = 0
Call Drawpagestatics(Page)
FirstRun = 1

Do
 Select Case EditState
  Case 0    'normales Navigieren
   If Btn_Esc = 0 Then                                                          'abbrechen
     Waitms 3 : While Btn_Esc = 0 : Wend
     EditState = 0
     EditStr = ""
   end if

   If Btn_Up = 0 Then                                                           'Zeile nach oben
     Waitms 3 : While Btn_Up = 0 : Wend
     If EditZeile > 1 Then
       Decr EditZeile
     Else
       Select Case Page
         Case 5
           EditZeile = 12

         Case 6
           EditZeile = 6
       end select
     End If
   end if

   If Btn_Dn = 0 Then                                                           'Zeile nach unten
     Waitms 3 : While Btn_Dn = 0 : Wend
     Select Case Page
       Case 5
         If EditZeile < 12 Then
           Incr EditZeile
         Else
           EditZeile = 1
         End If

       Case 6
         If EditZeile < 6 Then
           Incr EditZeile
         Else
           EditZeile = 1
         End If
     end select
   End If

   If Btn_Rt = 0 Then                                                           'Blttern vorwrts
     Waitms 3 : While Btn_Rt = 0 : Wend                                         'Debounce Button
     Incr Page
     EditZeile = 0
     if Antriebaus = 1 then
       If Page > 9 Then Page = 0                                                'Skip page
     Else
       If Page > 10 Then Page = 0
     End If

     If SD_Tristate = 1 Then Activate_Display_Bus
     Call Lcd_cls
     Call Drawpagestatics(Page)
   End If

   If Btn_Le = 0 Then                                                           'Blttern rckwrts
     Waitms 3 : While Btn_Le = 0 : Wend                                         'Debounce Button
     If Page > 0 Then
       Decr Page
     Elseif Antriebaus = 1 Then
       Page = 9
     Else
       Page = 10
     End If
     EditZeile = 0
     If SD_Tristate = 1 Then Activate_Display_Bus
     Call Lcd_cls
     Call Drawpagestatics(Page)
   End If

   If Btn_OK = 0 Then                                                           'bernehmen
     Waitms 3 : While Btn_OK = 0 : Wend
     EditSpalte = 1
     Select Case Page
       Case 5
         Select Case Editzeile
           Case 1
             Text = Fusing(P_faktor, "#.&&&&&")
             EditStr = Format(Text , "0000000")

           Case 2
             Text = Fusing(I_faktor,"#.&&&&&")
             EditStr = Format(Text ,"0000000")

           Case 3
             Text = Fusing(D_faktor,"#.&&&&&")
             EditStr = Format(Text ,"0000000")

           Case 4
             Text = Fusing(Mp_Faktor,"#.&&&&&")
             EditStr = Format(Text , "0000000")

           Case 5
             Text = Fusing(Mv_Faktor, "#.&&&&&")
             EditStr = Format(Text ,  "0000000")

           Case 6
             Text = Str(Vlimit)                                                 '125 = 12,5 Kmh
             Editstr = Format(Text , "000")

           Case 7
             Text = Str(Regelstrategie)
             Editstr = Format(Text , "0")

           Case 8
             Text = Str(FwdAngle)
             Editstr = Format(Text , "0")

           Case 9
             Text = Str(RevAngle)
             Editstr = Format(Text , "0")

           Case 10
             Text = Str(Ibattmax)
             Editstr = Format(Text , "00")

           Case 11
             Text = Str(PWMmax)
             Editstr = Format(Text , "000")

           Case 12
             Text = Str(FanSwitchLevel)
             Editstr = Format(Text , "00")
         end select

       Case 6
         Text = Str(Sinus(EditZeile))
         EditStr = Format(Text , "000")
     end select
     If Editzeile > 0 then EditState = 1
   end if

   'Min/Max Werte speichern
   If Page <> 11 Then                                                           'Nur wenn nicht geloggt wird
     If UBatt <> 0 and Ta <> 0 Then                                             'Nur wenn auch schon eine Spannung und ein Ta bertragen wurden
      If UBatt > Umax Then Umax = UBatt
      If UBatt < Umin Then Umin = UBatt

      If IBatt > Imax Then Imax = IBatt
      If IBatt < Imin Then Imin = IBatt

      If Kmh > KmhMax Then KmhMax = Kmh
      If Kmh < KmhMin Then KmhMin = Kmh

      If Ta > Tamax Then Tamax = Ta

      If RueckSollSpeed > PWM_Max Then PWM_Max = RueckSollSpeed
      If RueckSollSpeed < PWM_Min Then PWM_Min = RueckSollSpeed
     End If
   End If

  Case 1
   'Wert editieren
   If Btn_Le = 0 Then                                                           'Zahl dekrementieren
     Waitms 3 : While Btn_Le = 0 : Wend
     If EditSpalte > 1 then Decr EditSpalte
   End If

   If Btn_Rt = 0 Then                                                           'Zahl inkrementieren
     Waitms 3 : While Btn_Rt = 0 : Wend
     If EditSpalte < len(EditStr) then Incr EditSpalte
   End If

   EditChar = Mid(EditStr , EditSpalte , 1)

   If Btn_Up = 0 Then
     Waitms 3 : While Btn_Up = 0 : Wend
     If EditChar = "+" then
       EditChar = "-"
     elseif EditChar = "-" then
       EditChar = "+"
     elseif EditChar = "e" or EditChar = "E" or EditChar = "*" or _
            EditChar = "." or EditChar = "," or EditChar = " " then
       'do nothing
     elseif EditChar < "9" then
      FirstRun = val(EditChar) + 1
      EditChar = Str(FirstRun)
     else
       EditChar = "0"
     end if
   end if

   If Btn_Dn = 0 Then
     Waitms 3 : While Btn_Dn = 0 : Wend
     EditChar = Mid(EditStr , EditSpalte , 1)
     If EditChar = "+" then
       EditChar = "-"
     elseif EditChar = "-" then
       EditChar = "+"
     elseif EditChar = "e" or EditChar = "E" or EditChar = "*" or _
            EditChar = "." or EditChar = "," or EditChar = " " then
       'do nothing
     elseif EditChar > "0" then
      FirstRun = val(EditChar) - 1
      EditChar = Str(FirstRun)
     else
       EditChar = "9"
     end if
   end if

   Mid(EditStr , EditSpalte , 1) = EditChar

   If Btn_Esc = 0 Then                                                          'abbrechen
     Waitms 3 : While Btn_Esc = 0 : Wend
     EditState = 0
   end if

   If Btn_OK = 0 Then                                                           'bernehmen
     Waitms 3 : While Btn_OK = 0 : Wend
     Select Case Page
       Case 5
         Select Case Editzeile
           Case 1
             P_faktor = val(EditStr)

           Case 2
             I_faktor = val(EditStr)

           Case 3
             D_faktor = val(EditStr)

           Case 4
             Mp_faktor = val(EditStr)

           Case 5
             Mv_faktor = val(EditStr)

           Case 6
             Vlimit = val(EditStr)

           Case 7
             Regelstrategie = Val(EditStr)

           Case 8
             FwdAngle = Val(EditStr)

           Case 9
             RevAngle = Val(EditStr)

           Case 10
             Ibattmax = Val(EditStr)

           Case 11
             PWMmax = Val(EditStr)

           Case 12
             FanSwitchLevel = Val(EditStr)
         End Select

       Case 6
         Sinus(Editzeile) = val(EditStr)
     end select
     EditState = 0                                                              'end of edit mode
   end if
 end Select

 Select Case Page
  Case 0                                                                        'Startup
    Bdummy4 = 0
    For Bdummy2 = 1 To 10
      Bdummy1 = Bdummy2 * 9                                                     'Position der Textzeile festlegen
      Bdummy1 = Bdummy1 + 20                                                    'Titelzeile bercksichtigen
      Text = StartupStr(bdummy2)
      If Startup.Bdummy4 > 0 Then
        Call DisplayLine(Text , 0 , Bdummy1 , Black , Green)
      Else
        Call DisplayLine(Text , 0 , Bdummy1 , Black , White)
      End If
      incr Bdummy4
    Next

    'alle Bedingungen sind erfllt. Umschalten auf Hauptdisplay
    If FirstRun = 1 and Startup.9 = 1 Then
      Page = 1
      FirstRun = 0
      Call Lcd_cls
      Call Drawpagestatics(Page)
    End If

  Case 1                                                                        'Hauptdisplay
    If DateiAktuell = 1 Then
      If SD_Tristate = 0 Then Activate_SD_Bus
      if Gbdriveerror = 0 Then Close #2
      DateiAktuell = 0
    End If
    If SD_Tristate = 1 Then Activate_Display_Bus                                'Standard Anzeige

    If Btn_Shift = 0 Then                                                       'Tageskilomerterzhler nullen
      Waitms 3 : While Btn_Shift = 0 : Wend
      Singdummy = Meter / 1000
      Singdummy = Singdummy + Kilometer
      Startkilometer = Singdummy
      EStartkilometer = Startkilometer
    End If

    'Spannung und Strom
    Utext = " " + Fusing(U , "#.&") + "V"
    Itext = Fusing(I , "#.&") + "A "

    L1 = Len(Utext)
    L2 = Len(Itext)
    L1 = L1 + L2
    L2 = 22 - L1
    Ltext = String(l2 , 32)
    Text = Utext + Ltext
    Text = Text + Itext
    LCD_Print Text , 0 , 75 , 1 , 1 , 1 , Black , White

    'Akkubalken in %
    Text = "  " + Str(AkkuStand) + "%  "                                        '0...100%
    If AkkuStand > 66 Then
       Farbe = Green
     Elseif AkkuStand > 33 Then
       Farbe = Yellow
    Else
       Farbe = Red
    End If
    Singdummy = AkkuStand
    X2 = Singdummy * 1.14                                                       '124 - 8 - 1 - 1 = 114 / 100% = 1.14
    X2 = X2 + 10                                                                '10 wegen der "100 - Sdummy" weiter oben
    If X2 > 123 Then X2 = 123
    If X2 < 9 Then X2 = 9
    Lcd_box X2 , 85 , 123 , 94 , White                                          'Hintergrund lschen
    Lcd_box 9 , 85 , X2 , 94 , Farbe                                            'Balken zeichnen
    'Text mittig platzieren
    L1 = Len(Text)
    L1 = L1 * 5
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 98 , 1 , 1 , 1 , Black , White                        'unterm Balken

    'Kmh
    Singdummy = Kmh / 10
    Text = "  " + Fusing(Singdummy , "#.&") + "Kmh  "
    'Text mittig platzieren
    L1 = Len(Text)
    L1 = L1 * 8
    L1 = L1 / 2
    X1 = 66 - L1
    LCD_Print Text , X1 , 12 , 2 , 1 , 2 , Black , White

    'Gesamt Km. Text mittig, max 22 Character
    Singdummy = Meter / 1000
    Singdummy = Singdummy + Kilometer
    Text = Fusing(Singdummy , "#.&") + "Km  "
    L1 = Len(Text) / 2
    Text = Space(11 - L1) + Text
    DisplayLine Text, 0, 46, Black , White

    'Tageskilometerzhler. Text mittig, max 22 Character
    Singdummy = Singdummy - Startkilometer
    Text = Fusing(singdummy , "#.&") + "Km"
    L1 = Len(Text) / 2
    Text = Space(11 - L1) + Text
    DisplayLine Text, 0, 60, Black , White

    'Khlkrpertemperatur
    Text = "KK-Temp:" + Str(KK_Temperatur) + " Cels"
    LCD_Print Text , 25 , 115 , 1 , 1 , 1 , Black , White

    'Motortemperatur
    Text = "Mot-Temp:" + Str(Motor_Temperatur) + " Cels   "
    LCD_Print Text , 25 , 124 , 1 , 1 , 1 , Black , White

    'Antrieb Status
    Text = "Status: "
    If AntriebAus = 1 Then
      Text = Text + "AUS"
    Else
      Text = Text + "RUN"
    end if
    LCD_Print Text , 25 , 133 , 1 , 1 , 1 , Black , White

    'Gyros in Nullposition
    'If AntriebAus = 1 and Errorword.3 > 0 Then
    '  LCD_Print "Gyrowerte unruhig" , 25 , 142 , 1 , 1 , 1 , White , Black
    'else
    '  LCD_Print "" , 25 , 142 , 1 , 1 , 1 , Black , White
    'end if

    If ErrorWord > 0 or NotausGrund > 0 then
      Call DisplayStatusLine(Error_Str , 25 , 156 , Black , White)              'Fehler stehen an
    else
      Call DisplayStatusLine(OK_Str , 25 , 156 , Black , White)                 'OK
    end if

    '>>>>>>>>>>>> Nick Balken <<<<<<<<<<<<<
    If Antriebaus = 1 Then
      '30 Grad ==> 0...300
      ' 5 Grad ==> 50
      '50 Counts / 29 Pixel = 1.7241 Counts per Pixel ==> gerundet = 2 ==> 5.8 Grad
      Ldummy = Null_Nick - Nick_Offset
      Ldummy = Ldummy \ 2
    Else
      '30 Grad ==> -300...+300
      '10 Grad ==> 100 ==> Full Scale
      'Balkenlnge = 29 Pixel
      '100 Counts / 29 Pixel = 3.4483 Counts per Pixel ==> Gerundet = 4 ==> 11,6 Grad
      Ldummy = Mit_Acc_Nick \ 4
    End If

    If Ldummy > 29 Then
      Ldummy = 29
    elseIf Ldummy < -29 Then
      Ldummy = -29
    end if
    Y1 = Ldummy                                                                 'Type Cast Long ==> Byte
    Y1 = Y1 + 130                                                               'Mittenoffset
    LCD_Draw 9 , Ya , 18 , Ya , 0 , White
    LCD_Draw 9 , Y1 , 18 , Y1 , 0 , Black
    Ya = Y1

    '>>>>>>>>>>>> Fusszeile im Display >>>>>>>>>>>>
    '  00000000001111111111222
    '  01234567890123456789012
    '  Ta:123     PWM:123"
    'Textbreit = 5
    Text = Str(Ta)                                                              'Ticks
    Text = Format(Text, "+000")
    LCD_Print Text , 15 , 168 , 1 , 1 , 1 , Black , White

    Text = Str(RueckSollSpeed)                                                  'PWM
    Text = Format(Text, "000")
    LCD_Print Text , 70 , 168 , 1 , 1 , 1 , Black , White

  Case 2                                                                        'Fehlermeldungen und Motor Notaus Kriterien
   Bdummy2 = 11                                                                 'Y-Position
   For Idummy = 0 To 15                                                         'Errorword.0 ==> ErrorStr(1)
     If Errorword.Idummy > 0 Then
       IDummy1 = Idummy + 1
       Text = "E" + Str(Idummy) + ":"
       Text = Text + ErrorStr(Idummy1)
       Bdummy2 = Bdummy2 + 9                                                    'Grafikzeile
       If BDummy2 < 130 then Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
     End If
   Next

   For Idummy = 0 To 5
     If NotausGrund.Idummy > 0 Then
       IDummy1 = Idummy + 1
       Text = "N" + Str(Idummy1) + ":"
       Text = Text + NotausStr(Idummy1)
       Bdummy2 = Bdummy2 + 9                                                    'Grafikzeile
       If BDummy2 < 130 then Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
     end if
   Next

   While BDummy2 < 112                                                          'Clear lines
     Text = "                "
     Bdummy2 = Bdummy2 + 9                                                      'Grafikzeile
     Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
   wend

   Text = "ComErrMainCtrl:" + Str(ComErrMainCtrl)
   Call DisplayLine(Text , 0 , 166 , Black , White)

  Case 3                                                                        'Detail Display
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     if Gbdriveerror = 0 Then Close #2
     DateiAktuell = 0
   End If

   If SD_Tristate = 1 Then Activate_Display_Bus

   If Antriebaus = 1 Then
     If Btn_Shift = 0 Then                                                      'Neigung Nullen
       Waitms 3 : While Btn_Shift = 0 : Wend
       Nick_Offset = Null_Nick
       ENick_Offset = Nick_Offset
     End If

     If Btn_Esc = 0 Then                                                        'Gesamt Kilometer nullen
       Waitms 3 : While Btn_Esc = 0 : Wend
       ResetGesamtKm = 1
     End If
   End If

   Text = "Spannung = " + Fusing(U , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 20 , Black , White)

   Text = "Strom    = " + Fusing(I , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 29 , Black , White)

   Singdummy = Kmh / 10
   Text = "Geschw   = " + Fusing(Singdummy , "#.&")
   Text = Text + "Kmh"
   Call DisplayLine(Text , 0 , 38 , Black , White)

   Singdummy = Meter / 1000
   Singdummy = Singdummy + Kilometer
   Text = "Gesamt   = " + Fusing(Singdummy , "#.&&&")
   Text = Text + "Km  "
   Call DisplayLine(Text , 0 , 47 , Black , White)

   Text = Str(RueckSollSpeed)                                                   'PWM
   Text = "PWM      = " + Text
   Call DisplayLine(Text , 0 , 56 , Black , White)

   Text = "Akkustand(%) = " + Str(Akkustand)
   Call DisplayLine(Text , 0 , 65 , Black , White)

   Singdummy = Akkuverbraucht / 10
   Text = "AkkuVerb(mAh)= " + Fusing(Singdummy , "#.&")
   Call DisplayLine(Text , 0 , 74 , Black , White)

   If AntriebAUS = 1 then
     Text = "Nick_Offset  = " + Str(Nick_Offset)
     Call DisplayLine(Text , 0 , 83 , Black , White)
   else
     Text = "Nick         = " + Str(Mit_Acc_Nick)
     Call DisplayLine(Text , 0 , 83 , Black , White)
   end if

   Text = "AusgabeTicks = " + Str(RueckAusgabeTicks_L)
   Call DisplayLine(Text , 0 , 92 , Black , White)

   Text = "LoopCount    = " + Str(MainCtrLoopCount)
   Call DisplayLine(Text , 0 , 101 , Black , White)

   If AntriebAUS = 1 then
     Text = "ADC_Nick(Roh)= " + Str(Null_Nick)
   else
     Text = "ADC_Nick(Roh)= n.a."
   end if
   Call DisplayLine(Text , 0 , 110 , Black , White)

   Text = "Sens OK Count= " + Str(Sensor_OK_count)
   Call DisplayLine(Text , 0 , 119 , Black , White)

   Text = Bin(MotorPosition)
   Text = "Motor Pos = " + Text
   Call DisplayLine(Text , 0 , 128 , Black , White)

  Case 4                                                                        'Min/Max Display
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     if Gbdriveerror = 0 Then Close #2
     DateiAktuell = 0
   else
     If SD_Tristate = 1 Then Activate_Display_Bus
   End If

   If Btn_Shift = 0 Then                                                        'Min-Maxwerte nullen
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call Reset_Minmax
   End If

   Singdummy = Umin / 1000
   Text = "Umin= " + Fusing(Singdummy , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 20 , Black , White)
   '**************************************************
   Singdummy = Umax / 100                                                       '0,01V Auflsung
   Text = "Umax= " + Fusing(Singdummy , "#.&")
   Text = Text + "V"
   Call DisplayLine(Text , 0 , 29 , Black , White)
   '**************************************************
   Singdummy = Imin / 1000
   Text = "Imin= " + Fusing(Singdummy , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 38 , Black , White)
   '**************************************************
   Singdummy = Imax / 1000
   Text = "Imax= " + Fusing(Singdummy , "#.&")
   Text = Text + "A"
   Call DisplayLine(Text , 0 , 47 , Black , White)
   '**************************************************
   Singdummy = Kmhmin / 10
   Text = "Vmin= " + Fusing(Singdummy , "#.#")
   Text = Text + "km/h"
   Call DisplayLine(Text , 0 , 56 , Black , White)
   '**************************************************
   Singdummy = KmhMax / 10
   Text = "Vmax= " + Fusing(Singdummy , "#.#")
   Text = Text + "km/h"
   Call DisplayLine(Text , 0 , 65 , Black , White)
   '**************************************************
   Text = "PWM_Min= " + Str(PWM_Min )
   Call DisplayLine(Text , 0 , 74 , Black , White)
   '**************************************************
   Text = "PWM_Max= " + Str(PWM_Max )
   Call DisplayLine(Text , 0 , 83 , Black , White)
   '**************************************************
   Text = "TAmax= " + Str(tamax )
   Call DisplayLine(Text , 0 , 92 , Black , White)
   '**************************************************
   Text = "FussSchalter= " + Str(FussSchalter)
   Call DisplayLine(Text , 0 , 101 , Black , White)
   '**************************************************
   Text = "Fuss.Count= " + Str(FussCount)
   Call DisplayLine(Text , 0 , 110 , Black , White)

  Case 5                                                                        'Haupt-/Motorcontroller editieren
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     if Gbdriveerror = 0 Then Close #2
     DateiAktuell = 0
   else
     If SD_Tristate = 1 Then Activate_Display_Bus
   End If

   Text = "P-Faktor  = "
   Call DisplayFltEditLine(Text , P_faktor , 1 , 0 , 20)

   Text = "I-Faktor  = "
   Call DisplayFltEditLine(Text , I_faktor , 2 , 0 , 29)

   Text = "D-Faktor  = "
   Call DisplayFltEditLine(Text , D_faktor , 3 , 0 , 38)

   Text = "MP-Faktor = "
   Call DisplayFltEditLine(Text , Mp_faktor , 4 , 0 , 47)

   Text = "MV-Faktor = "
   Call DisplayFltEditLine(Text , Mv_faktor , 5 , 0 , 56)

   Text = "V-Limit(Kmh*10)= "
   Call DisplayBtEditLine(Text , VLimit , 6 , 0 , 65)

   Text = "0=P 1=PI 2=PID = "
   Call DisplayBtEditLine(Text , RegelStrategie , 7 , 0 , 74)

   Text = "Fwd Angle      = "
   Call DisplayBtEditLine(Text , FwdAngle , 8 , 0 , 83)

   Text = "Rev Angle      = "
   Call DisplayBtEditLine(Text , RevAngle , 9 , 0 , 92)

   Text = "I-Batt Max (A) = "
   Call DisplayBtEditLine(Text , IBattmax , 10 , 0 , 101)

   Text = "PWMmax         = "
   Call DisplayBtEditLine(Text , PWMmax , 11 , 0 , 110)

   Text = "FanON lvl(Cels)= "
   Call DisplayBtEditLine(Text , FanSwitchLevel , 12 , 0 , 119)

   If Btn_Shift = 0 Then                                                        'Werte aus Display bernehmen und in EEPROM speichern
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call PutEEpromData
   End If

  Case 6                                                                        'Sinuswerte fr Motorcontroller editieren
   If DateiAktuell = 1 Then
     If SD_Tristate = 0 Then Activate_SD_Bus
     if Gbdriveerror = 0 Then Close #2
     DateiAktuell = 0
   End If
   If SD_Tristate = 1 Then Activate_Display_Bus

   If Btn_Shift = 0 Then                                                        'Werte aus Display bernehmen und in EEPROM speichern
     Waitms 3 : While Btn_Shift = 0 : Wend
     Call PutEEpromData
   End If

   For Idummy = 1 To 6
     Text = "Sinus" + Str(Idummy) + " = "
     L1 = Idummy * 9
     L1 = L1 + 11
     Call DisplayBtEditLine(Text , Sinus(Idummy) , IDummy , 0 , L1)
   Next

  Case 7                                                                        'Rckdarstellung der Sinusparameter
   For Idummy = 1 To 6
     Text = "R-Sinus" + Str(Idummy) + " = " + Str(RueckSinus(Idummy))
     L1 = Idummy * 9
     L1 = L1 + 11
     Call DisplayLine(Text , 0 , L1 , Black , White)
   Next
   '(
   For Idummy = 7 To 12
     Text = "R-Sinus" + Str(Idummy) + " = "
     L1 = Idummy * 9
     L1 = L1 + 11
     Call DisplayLine(Text , 0 , L1 , Black , White)
   Next
   ')
   Text = "P-Anteil       = " + Str(P_Anteil)
   Call DisplayLine(Text , 0 , 90 , Black , White)

   Text = "I-Anteil       = " + Str(I_Anteil)
   Call DisplayLine(Text , 0 , 99 , Black , White)

   Text = "D-Anteil       = " + Str(D_Anteil)
   Call DisplayLine(Text , 0 , 108 , Black , White)

  Case 8
    If AntriebAus = 0 Then
      LCD_Print "Anzeige nur" , 0 , 20 , 2 , 1 , 1 , Black , Red
      LCD_Print "wenn" , 0 , 40 , 2 , 1 , 1 , Black , Red
      LCD_Print "Antrieb AUS" , 0 , 60 , 2 , 1 , 1 , Black , Red
    else                                                                        'Rckdarstellung
      Text = "Nick Offset = " + Str(Nick_Offset)
      Call DisplayLine(Text , 0 , 20 , Black , White)

      Text = "O_nick_u    = " + Str(Rueck_O_Nick_u)
      Call DisplayLine(Text , 0 , 29 , Black , White)

      Text = "O_nick_o    = " + Str(Rueck_O_Nick_o)
      Call DisplayLine(Text , 0 , 38 , Black , White)

      Text = "O_nick_oo   = " + Str(Rueck_O_Nick_oo)
      Call DisplayLine(Text , 0 , 47 , Black , White)

      Text = "Regelstrateg= " + Str(RueckRegelstrategie)
      Call DisplayLine(Text , 0 , 56 , Black , White)

      Text = "PWM-Max     = " + Str(RueckPWMmax)
      Call DisplayLine(Text , 0 , 65 , Black , White)

      Text = "Soll Richtg.= " + Str(RueckSollRichtung)                          '0=Vorw. 1=Rckw. 2=Leerlauf
      Call DisplayLine(Text , 0 , 74 , Black , White)

      Text = "Soll Speed  = " + Str(RueckSollSpeed)                             '0=Vorw. 1=Rckw. 2=Leerlauf
      Call DisplayLine(Text , 0 , 83 , Black , White)

      Text = "Fwd-Angle   = " + Str(fwdangle)
      Call Displayline(text , 0 , 92 , Black , White)

      Text = "Rev-Angle   = " + Str(revangle)
      Call DisplayLine(Text , 0 , 101 , Black , White)

      Text = "Kp          = " + Fusing(RueckP_faktor , "#.&&&&&")
      Call DisplayLine(Text , 0 , 110 , Black , White)

      Text = "Ki          = " + Fusing(RueckI_faktor , "#.&&&&&")
      Call Displayline(text , 0 , 119 , Black , White)

      Text = "Kd          = " + Fusing(RueckD_faktor , "#.&&&&&")
      Call Displayline(text , 0 , 128 , Black , White)

      SingDummy = RueckVlimit
      SingDummy = SingDummy / 10
      Text = "V-Limit(Kmh)= " + Fusing(SingDummy , "#.&")
      Call DisplayLine(Text , 0 , 137 , Black , White)

      Text = "Richtung    = " + Str(Rueck_IstRichtung)                          '0=Vorw. 1=Rckw. 2=Leerlauf
      Call DisplayLine(Text , 0 , 146 , Black , White)

      Text = "I-Bat max(A)= " + Str(RueckIBattMax)
      Call DisplayLine(Text , 0 , 155 , Black , White)
    end if

  Case 9                                                                        'SD. List 8.3 filenames of the root directory
   BDummy2 = 20                                                                 'Zeilennummer im Display
   if GbDriveError = 0 then
     DateiName = Dir( "*.log")                                                  'The first call to the DIR() function must contain a file mask
     BDummy = Len(DateiName)
     BDummy1 = 0
     While BDummy > 0                                                           'if file found
       Text = DateiName + " "
       LDummy = Filelen(DateiName)
       SingDummy = LDummy / 1024
       If SingDummy < 0.1 then SingDummy = 0.1                                  'KB
       Text = Text + Fusing(SingDummy , "#.#")
       Text = Text + "KB"
       If BDummy2 >= 157 then
         LCD_Print Str(BDummy1) + " more..." , 0 , BDummy2 , 1 , 1 , 1 , Black , White
         Exit While
       else
         LCD_Print Text , 0 , BDummy2 , 1 , 1 , 1 , Black , White
         BDummy2 = BDummy2 + 9
       End If
       Incr BDummy1
       Dateiname = Dir()                                                        'get next file
       BDummy = Len(DateiName)
     Wend
   else
     SD_Init                                                                    'Try again
     Text = "Drive Error: " + Str(GbDriveError)
     LCD_Print Text , 0 , 20 , 1 , 1 , 1 , Black , White
   endif

  Case 10                                                                       'Logging
   If SD_Tristate = 0 Then Activate_SD_Bus
   If Antriebaus = 0 Then                                                       'Motoren laufen --> Werte loggen
     If Gbdriveerror = 0 Then
       If DateiAktuell = 0 Then                                                   'Keine Datei geffnet
         Lname = 1
         Dateilaenge = 1                                                          'Nchste Schleife einmal erzwingen
         While Dateilaenge > 0                                                    'freien Dateinamen suchen
           Dateiname = Str(lname)
           Dateiname = Dateiname + ".log"
           '0 voranstellen, damit sich die Dateien besser sortieren lassen.
           While Len(Dateiname) < 12
             Dateiname = "0" + Dateiname
           Wend
           Dateilaenge = FileLen(Dateiname)                                       'File exists?
           Incr Lname
         Wend
         If SD_Tristate = 1 Then Activate_Display_Bus
         LCD_Print Dateiname , 25 , 55 , 1 , 1 , 1 , Black , White
         If SD_Tristate = 0 Then Activate_SD_Bus
         DateiAktuell = 1
         Loopcount = 0
         Zeit = "00:00:00"
         Open Dateiname For Append As #2
         Logtext = "Zeit;Loopcount;U;I;Nick;Sollspeed;Ta;RueckAusgabeTicks_L;Kmh;Akku%"
         Print #2 , Logtext
       End If
       If Loopcount <> AloopCount Then
         Logtext = Zeit
         Logtext = Logtext + ";"
         Logtext = Logtext + Str(LoopCount)
         Logtext = Logtext + ";"
         Logtext = Logtext + Fusing(U , "#.&")
         Logtext = Logtext + ";"
         Logtext = Logtext + Fusing(I , "#.&")
         Logtext = Logtext + ";"
         Logtext = Logtext + Str(Mit_Acc_Nick)
         Logtext = Logtext + ";"
         Logtext = Logtext + Str(RueckSollSpeed)
         Logtext = Logtext + ";"
         Logtext = Logtext + Str(ta)
         Logtext = Logtext + ";"
         Logtext = Logtext + Str(RueckAusgabeTicks_L)
         Logtext = Logtext + ";"
         Singdummy = Kmh / 10
         Logtext = Logtext + Fusing(SingDummy , "#.&")
         Logtext = Logtext + ";"
         Logtext = Logtext + Str(Akkustand)
         Print #2 , Logtext
         Aloopcount = Loopcount
         Incr LoopCount
       End If
     End if
   Else
     If Gbdriveerror = 0 Then
       Close #2
       DateiAktuell = 0
       If Loopcount = 0 then
         Kill Dateiname                                                           'Es wurden keine Daten gespeichert
       else
         LCD_Print "File closed" , 0 , 140 , 1 , 1 , 1 , White , Black
       end if
     End if
   End If
 End Select
Loop

'***************************************************************************
Sub Datenempfang
  'Die empfangenen Zeichen im nach links laufenden Umlauf in Empfpuffer(x) geschrieben
  'Dadurch wird sichergestellt, dass das gesendete Endezeichen (CR) als
  'Startzeichen irgendwann im Rx(1) steht

  'Den Puffer um 1 Zeichen nach links schieben
  $asm
   PUSH R24;
   IN R24,SREG;
   PUSH R24;

   LDS R24,{Rx(2)}                                                              'Load Direct from data space @address xxx
   STS {Rx(1)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(3)}                                                              'Load Direct from data space @address xxx
   STS {Rx(2)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(4)}                                                              'Load Direct from data space @address xxx
   STS {Rx(3)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(5)}                                                              'Load Direct from data space @address xxx
   STS {Rx(4)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(6)}                                                              'Load Direct from data space @address xxx
   STS {Rx(5)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(7)}                                                              'Load Direct from data space @address xxx
   STS {Rx(6)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(8)}                                                              'Load Direct from data space @address xxx
   STS {Rx(7)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(9)}                                                              'Load Direct from data space @address xxx
   STS {Rx(8)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(10)}                                                             'Load Direct from data space @address xxx
   STS {Rx(9)},R24                                                              'Write Rxx to address loaction
   LDS R24,{Rx(11)}                                                             'Load Direct from data space @address xxx
   STS {Rx(10)},R24                                                             'Write Rxx to address loaction
   LDS R24,{Rx(12)}                                                             'Load Direct from data space @address xxx
   STS {Rx(11)},R24                                                             'Write Rxx to address loaction
   LDS R24,{Rx(13)}                                                             'Load Direct from data space @address xxx
   STS {Rx(12)},R24                                                             'Write Rxx to address loaction
   LDS R24,{Rx(14)}                                                             'Load Direct from data space @address xxx
   STS {Rx(13)},R24                                                             'Write Rxx to address loaction
   #if PrefixMode = 0
     !IN  R24,UDR1                                                              'using COM1. Neues Zeichen einlese
     STs {Rx(14)},R24                                                           'Write Rxx to address loaction
   #else
     LDS R24,{Rx(15)}                                                           'Load Direct from data space @address xxx
     STS {Rx(14)},R24                                                           'Write Rxx to address loaction
     LDS R24,{Rx(16)}                                                           'Load Direct from data space @address xxx
     STS {Rx(15)},R24                                                           'Write Rxx to address loaction
     LDS R24,{Rx(17)}                                                           'Load Direct from data space @address xxx
     STS {Rx(16)},R24                                                           'Write Rxx to address loaction
     'using COM1
     !IN  R24,UDR1                                                              'neues Zeichen einlese
     STs {Rx(17)},R24                                                           'Write Rxx to address loaction
   #endif

   POP R24;
   Out Sreg,R24;
   POP R24;
 $end asm

 '------ Check Message ---------
 #if PrefixMode = 0
   'RxBuffer before Shift Left
    'Rx(1)     0x0D
    'Rx(2)     Prefix
    'Rx(3)     Msg-ID
    'Rx(4..12) Data  1..9
    'Rx(13)    BCC
    'Rx(14)    0x0D

   If Rx(1) = &H0D and Rx(3) > &H5F And Rx(14) = &H0D Then                      'Message gltig
     'Shift Buffer left to get rid of leading CR and Prefix
     $asm
      LDS R24,{Rx(3)}                                                           'Load Direct from data space @address xxx
      STS {Rx(1)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(4)}                                                           'Load Direct from data space @address xxx
      STS {Rx(2)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(5)}                                                           'Load Direct from data space @address xxx
      STS {Rx(3)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(6)}                                                           'Load Direct from data space @address xxx
      STS {Rx(4)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(7)}                                                           'Load Direct from data space @address xxx
      STS {Rx(5)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(8)}                                                           'Load Direct from data space @address xxx
      STS {Rx(6)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(9)}                                                           'Load Direct from data space @address xxx
      STS {Rx(7)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(10)}                                                          'Load Direct from data space @address xxx
      STS {Rx(8)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(11)}                                                          'Load Direct from data space @address xxx
      STS {Rx(9)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(12)}                                                          'Load Direct from data space @address xxx
      STS {Rx(10)},R24                                                          'Write Rxx to address loaction
      LDS R24,{Rx(13)}                                                          'Load Direct from data space @address xxx
      STS {Rx(11)},R24                                                          'Write Rxx to address loaction
     $end asm
     Go = 1
   else
     Go = 0
   end if
 #else
   'RxBuffer before Shift Left
     'Rx(1)     &H0D
     'Rx(2..5)  Prefix size (uint32)
     'Rx(6)     Msg-ID
     'Rx(7..15) Data  1..9
     'Rx(16)    BCC
     'Rx(17)    &H0D
   If Rx(1) = &H0D And Rx(6) > &H5F And Rx(17) = &H0D Then                      'Message gltig
     'Shift Buffer left to get rid of leading &H0D and Prefix
     $asm
      LDS R24,{Rx(6)}                                                           'Load Direct from data space @address xxx
      STS {Rx(1)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(7)}                                                           'Load Direct from data space @address xxx
      STS {Rx(2)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(8)}                                                           'Load Direct from data space @address xxx
      STS {Rx(3)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(9)}                                                           'Load Direct from data space @address xxx
      STS {Rx(4)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(10)}                                                          'Load Direct from data space @address xxx
      STS {Rx(5)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(11)}                                                          'Load Direct from data space @address xxx
      STS {Rx(6)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(12)}                                                          'Load Direct from data space @address xxx
      STS {Rx(7)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(13)}                                                          'Load Direct from data space @address xxx
      STS {Rx(8)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(14)}                                                          'Load Direct from data space @address xxx
      STS {Rx(9)},R24                                                           'Write Rxx to address loaction
      LDS R24,{Rx(15)}                                                          'Load Direct from data space @address xxx
      STS {Rx(10)},R24                                                          'Write Rxx to address loaction
      LDS R24,{Rx(16)}                                                          'Load Direct from data space @address xxx
      STS {Rx(11)},R24                                                          'Write Rxx to address loaction
     $end asm
     Go = 1
   else
     Go = 0
   end if
 #endif

 If Go = 1 then
   'Buffer after shift left:
   'Rx(1)     Msg-ID
   'Rx(2..10) Data 1..9
   'Rx(11)    BCC
   $asm
     'calculate BCC
     lds R24,{Rx(1)}                                                            'Index
     LDs R25,{Rx(2)}
     add R24,R25
     LDs R25,{Rx(3)}
     add R24,R25
     LDs R25,{Rx(4)}
     add R24,R25
     LDs R25,{Rx(5)}
     add R24,R25
     LDs R25,{Rx(6)}
     add R24,R25
     LDs R25,{Rx(7)}
     add R24,R25
     LDs R25,{Rx(8)}
     add R24,R25
     LDs R25,{Rx(9)}
     add R24,R25
     LDs R25,{Rx(10)}
     add R24,R25
     STS {BCC},R24
   $end asm

   If BCC = Rx(11) then                                                         'Die Prfsumme stimmt
    Select Case Rx(1)
     Case &H65
       Tii = MemCopy(Rx(2), Kmh, 2)
       AkkuStand = Rx(4)
       Tii = MemCopy(Rx(5), Kilometer, 2)
       Tii = MemCopy(Rx(7), Meter, 2)
       MotorPosition = Rx(9)
       '= Rx(10)

     Case &H66
       Tii = MemCopy(Rx(2), ErrorWord, 2)
       Tii = MemCopy(Rx(4), UBatt, 2)                                           '0,01V Auflsung
       U = UBatt
       U = U /100                                                               'V Auflsung
       Tii = MemCopy(Rx(6), KK_Temperatur, 2)
       Tii = MemCopy(Rx(8), Motor_Temperatur, 2)
       Motor_Temperatur = Motor_Temperatur / 10                                 'get rid of decimal
       '= Rx(10)

     Case &H67
       Tii = MemCopy(Rx(2), IBatt, 2)                                           'in 0,1A Auflsung
       I = IBatt
       I = I / 10                                                               'A Auflsung
       Tii = MemCopy(Rx(4), P_Anteil, 2)
       Tii = MemCopy(Rx(6), I_Anteil, 2)
       Tii = MemCopy(Rx(8), D_Anteil, 2)
       '= Rx(10)

     Case &H68
       If Antriebaus = 1 Then
         Tii = MemCopy(Rx(2), Null_Nick, 4)                                     'Rohwert der Neigung 0..1024
       Else
         ResetGesamtKm = 0                                                      'Befehl lschen
         Tii = MemCopy(Rx(2), Mit_AccNick, 4)                                   'Mittelwert der Neigung
         Mit_Acc_Nick = Mit_AccNick
       end if
       Tii = MemCopy(Rx(6), Akkuverbraucht, 2)
       Tii = MemCopy(Rx(8), ComErrMainCtrl, 2)
       RueckSollSpeed = Rx(10)

     Case &H69
       Tii = MemCopy(Rx(2), Startup, 2)
       NotausGrund = Rx(4)
       FussSchalter = Rx(5)                                                     'FussSchalter
       Tii = MemCopy(Rx(6), Ta, 2)
       Antriebaus = Rx(8)
       FussCount = Rx(9)
       RueckRegelstrategie= Rx(10)

     Case &H6A
       Rfwdangle = Rx(2)
       Rrevangle = Rx(3)
       Sensor_OK_count = Rx(4)
       RueckIBattMax = Rx(5)
       Tii = MemCopy(Rx(6), RueckVlimit, 2)
       RueckPWMmax = Rx(8)
       RueckSinus(1) = Rx(9)
       RueckSinus(2) = Rx(10)

     Case &H6B
       Tii = MemCopy(Rx(2), Rueck_O_nick_oo, 4)
       RueckSinus(3) = Rx(6)
       '= Rx(7)
       '= Rx(8)
       '= Rx(9)
       '= Rx(10)

     Case &H6C
       Tii = MemCopy(Rx(2), Rueck_O_nick_u, 4)
       Tii = MemCopy(Rx(6), Rueck_O_Nick_o, 4)
       RueckSinus(4) = Rx(10)

     Case &H6D
       Tii = MemCopy(Rx(2), Rueckp_Faktor, 4)
       Tii = MemCopy(Rx(6), Ruecki_Faktor, 4)
       RueckSinus(5) = Rx(10)

     Case &H6E
       Tii = MemCopy(Rx(2), Rueckd_Faktor, 4)
       Rueck_Istrichtung = Rx(6)
       Tii = MemCopy(Rx(7), MainCtrLoopCount, 2)
       '= Rx(9)
       RueckSinus(6) = Rx(10)

     Case &HFE
       'Num of Byte excluding Prefix
       #if PrefixMode = 0
         Tx(1) = 56
       #else
         Tx(1) = 59                                                             'Prefix 0
         Tx(2) = 0                                                              'Prefix 1
         Tx(3) = 0                                                              'Prefix 2
         Tx(4) = 0                                                              'Prefix 3
       #endif
       '             p=1     p=4
       'Tx(1)         1       4   Data length
       'Tx(p+1)       2       5   Index
       'Tx(p+2..p+54) 3       8   Data  1..n
       'Tx(p+55)     56      59   BCC
       'Tx(p+56)     57      60   &H0D

       Tx(p+1) = &HFE                                                           'Index
       Tii = MemCopy(Sinus(1) , Tx(p+2), 12)
       Tx(p+14) = Regelstrategie
       Tx(p+15) = Pwmmax
       Tii = MemCopy(P_faktor , Tx(p+16), 4)
       Tii = MemCopy(I_faktor , Tx(p+20), 4)
       Tii = MemCopy(D_faktor , Tx(p+24), 4)
       Tii = MemCopy(Mp_faktor , Tx(p+28), 4)
       Tii = MemCopy(Mv_faktor , Tx(p+32), 4)
       Tii = MemCopy(Vlimit , Tx(p+36), 2)
       Tii = MemCopy(Nick_offset , Tx(p+38), 4)
       Tx(p+42) = Fwdangle
       Tx(p+43) = Revangle
       Tx(p+44) = IBattmax
       Tx(p+45) = FanSwitchLevel
       'Tx(p+46) =
       Tx(p+47) = ResetGesamtKm
       Tx(p+48) = 0                                                               'unbenutzt
       Tx(p+49) = 0                                                               'unbenutzt
       Tx(p+50) = 0                                                               'unbenutzt
       Tx(p+51) = 0                                                               'unbenutzt
       Tx(p+52) = 0                                                               'unbenutzt
       Tx(p+53) = 0                                                               'unbenutzt
       Tx(p+54) = 0                                                               'unbenutzt

       LL1=p+2
       LL2=p+54
       LL3=p+55

       'calculate BCC without Prefix
       Tx(LL3) = Tx(p+1)
       for n = LL1 to LL2
         Tx(LL3) = Tx(LL3) + Tx(n)
       next

       Tx(p+56) = &H0D

       Printbin #1 , Tx(1)                                                      'Send Data to Main Controller
    End Select
   End If
   Rx(1) = 0
 end if
end sub

'***************************************************************************
Sub Activate_Display_Bus
'(
  Config SPI will not work in Bascom 1.06.x and up, when called a second time
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , _
               Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1

  In SPI mode, speed is not guaranteed by specification, but the minimum supported
  4-bit bus mode clock speed is 12,5 MHz. The maximum SPI speed for AVR 8-bit is
  10MHz, so we set SPI to maximum speed, f osc / 2
')
  Reset Mmc_cs
  Reset SD_Tristate                                                             'F.7 Removes SD Card from bus
  Spcr = &B0101_0000
  Set Spsr.spi2x                                                                'doubles speed of SPI output
  SpiInit
End Sub

'***************************************************************************
Sub Activate_SD_Bus
'(
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , _
                  Polarity = High , Phase = 1 , Clockrate = 16 , Noss = 1
  In SPI mode, speed is not guaranteed by specification, but the minimum supported
  4-bit bus mode clock speed is 12,5 MHz. The maximum SPI speed for AVR 8-bit is
  10MHz , so we set SPI to maximum speed , f osc / 2
')
  Set Lcd_port.lcd_cs                                                           'Deactivate Display
  '(
  'Reset Portb.1
  'Reset Portb.2
  'Reset Portb.3
  Spcr = &B0101_1101
  Reset Spsr.spi2x
  SpiInit
  Set Mmc_cs                                                                    'activate sd card
  Set SD_Tristate                                                               'F.7 Activate SD Tristate chip
  ')
'End Sub


  Reset Portb.1
  Reset Portb.2
  Reset Portb.3
  Spcr = &B0101_1101
  Reset Spsr.spi2x
  SPIINIT
  Set Mmc_cs                                                                   'activate sd card
  Set Portb.1
  Set Portf.7                                                                  'connects SD Card to bus
end sub

'***************************************************************************
Sub DisplayFltEditLine(byval ConstStr as String*22 , _Var as Single , _
                       Byval EdtZl as Byte , Byval Xc as Byte , Byval Y as Byte)
 Local TText as String * 22
 Local xx as Byte
 Local Xs as Byte

 If EditState = 1 and EditZeile = EdtZl then
   'Var Name
   LCD_Print ConstStr , Xc , Y , 1 , 1 , 1 , Black , Green

   'Var start print position
   Xs = len(ConstStr)
   Xs = Xs * 6                                                                  'Font size 1 = 7x5
   Xs = Xs + Xc

   'String in front of Highlighted character
   xx = EditSpalte - 1
   If xx > 0 then
     TText = Left(EditStr , xx)
     LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Green
   end if

   'Highlighted character
   xx = xx * 6                                                                  'Font size 1 = 7x5
   Xs = Xs + xx
   TText = Mid(EditStr , EditSpalte , 1)
   LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Yellow

   'String behind Highlighted character
   If EditSpalte < len(EditStr) then
     xx = EditSpalte + 1
     Xs = Xs + 6                                                                'Font size 1 = 7x5
     TText = Mid(EditStr , xx , 22)
     LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Green
   end if
 else
   Select Case Page
    Case 5
      Select Case EdtZl
        Case 1 to 5
          TText = Fusing(_Var ,  "#.&&&&&")
          TText = Format(TText , "0000000")
      end select
   end select

   TText = ConstStr + TText
   If EditZeile = EdtZl Then
     Call DisplayLine(TText , Xc , Y , Black , Green)
   Else
     Call DisplayLine(TText , Xc , Y , Black , White)
   End If
 end if
end Sub

Sub DisplayIntEditLine(byval ConstStr as String*22, _Var as Integer , _
                       Byval EdtZl as Byte , Byval Xc as Byte , Byval Y as Byte)
 Local TText as String * 22
 Local xx as Byte
 Local Xs as Byte

 If EditState = 1 and EditZeile = EdtZl then
   'Var Name
   LCD_Print ConstStr , Xc , Y , 1 , 1 , 1 , Black , Green

   'Var start print position
   Xs = len(ConstStr)
   Xs = Xs * 6                                                                  'Font size 1 = 7x5
   Xs = Xs + Xc

   'String in front of highlighted character
   xx = EditSpalte - 1
   If xx > 0 then
     TText = Left(EditStr , xx)
     LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Green
   end if

   'Highlighted character
   xx = xx * 6                                                                  'Font size 1 = 7x5
   Xs = Xs + xx
   TText = Mid(EditStr , EditSpalte , 1)
   LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Yellow

   'String behind highlighted character
   If EditSpalte < len(EditStr) then
     xx = EditSpalte + 1
     Xs = Xs + 6                                                                'Font size 1 = 7x5
     TText = Mid(EditStr , xx , 22)
     LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Green
   end if
 else
   Select Case Page
    Case 5
      Select Case EdtZl
        Case 6                                                                  'V-Limit[Kmh]
          TText = Str(_Var)
          TText = Format(TText , "00")

        Case 7 to 9                                                             'Regelstrategie and Angle
          TText = Str(_Var)
          TText = Format(TText , "0")

        Case 10                                                                 'I-Batterie Max in 1A Schritten
          TText = Str(_Var)
          TText = Format(TText , "00")

        Case 11                                                                 'PWMmax
          TText = Str(_Var)
          TText = Format(TText , "000")

        Case 12                                                                 'Fan switch level
          TText = Str(_Var)
          TText = Format(TText , "00")
      end select

    Case 6
      TText = Str(_Var)
      TText = Format(TText , "000")
   end select

   TText = ConstStr + TText
   If EditZeile = EdtZl Then
     Call DisplayLine(TText , Xc , Y , Black , Green)
   Else
     Call DisplayLine(TText , Xc , Y , Black , White)
   End If
 end if
end Sub

Sub DisplayBtEditLine(byval ConstStr as String*22, _Var as Byte , _
                      Byval EdtZl as Byte , Byval Xc as Byte , Byval Y as Byte)
 Local TText as String * 22
 Local xx as Byte
 Local Xs as Byte

 If EditState = 1 and EditZeile = EdtZl then
   'Var Name
   LCD_Print ConstStr , Xc , Y , 1 , 1 , 1 , Black , Green

   'Var start print position
   Xs = len(ConstStr)
   Xs = Xs * 6                                                                  'Font size 1 = 7x5
   Xs = Xs + Xc

   'String in front of highlighted character
   xx = EditSpalte - 1
   If xx > 0 then
     TText = Left(EditStr , xx)
     LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Green
   end if

   'Highlighted character
   xx = xx * 6                                                                  'Font size 1 = 7x5
   Xs = Xs + xx
   TText = Mid(EditStr , EditSpalte , 1)
   LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Yellow

   'String behind highlighted character
   If EditSpalte < len(EditStr) then
     xx = EditSpalte + 1
     Xs = Xs + 6                                                                'Font size 1 = 7x5
     TText = Mid(EditStr , xx , 22)
     LCD_Print TText , Xs , Y , 1 , 1 , 1 , Black , Green
   end if
 else
   Select Case Page
    Case 5
      Select Case EdtZl
        Case 6                                                                  'V-Limit[Kmh]
          TText = Str(_Var)
          TText = Format(TText , "00")

        Case 7 to 9                                                             'Regelstrategie and Angle
          TText = Str(_Var)
          TText = Format(TText , "0")

        Case 10                                                                 'I-Batterie Max in 1A Schritten
          TText = Str(_Var)
          TText = Format(TText , "00")

        Case 11                                                                 'PWMmax
          TText = Str(_Var)
          TText = Format(TText , "000")

        Case 12                                                                 'Fan switch level
          TText = Str(_Var)
          TText = Format(TText , "00")
      end select

    Case 6
      TText = Str(_Var)
      TText = Format(TText , "000")
   end select

   TText = ConstStr + TText
   If EditZeile = EdtZl Then
     Call DisplayLine(TText , Xc , Y , Black , Green)
   Else
     Call DisplayLine(TText , Xc , Y , Black , White)
   End If
 end if
end Sub

'***************************************************************************
Sub DisplayLine(Byval Txt As String*22, Byval X As Byte , Byval Y As Byte , _
                Byval Txtcolor As Word , Byval Bgrcolor As Word)

 If Len(Txt) > 22 Then
   Txt = Left(Txt , 22)
 Else
   While Len(Txt) < 22
     Txt = Txt + " "                                                            'clear text behind string
   Wend
 End If

 LCD_Print Txt , X , Y , 1 , 1 , 1 , Txtcolor , Bgrcolor
End Sub

'***************************************************************************
Sub DisplayStatusLine(byval Txt As String*22, Byval X As Byte , _
                      Byval Y As Byte , Byval Txtcolor As Word , _
                      Byval Bgrcolor As Word)
'Line above base line of main Page display
 Local Text As String * 19

 Text = Txt
 If Len(Text) > 19 Then
   Text = Left(Text , 19)
 Else
   While Len(Text) < 19
     Text = Text + " "
   Wend
 End If
 LCD_Print Text , X , Y , 1 , 1 , 1 , Txtcolor , Bgrcolor
End Sub

'***************************************************************************
Sub Reset_Minmax
  Umin = 0
  Umax = 0
  Imin = 0
  Imax = 0
  Kmhmin = 0
  KmhMax = 0
  PWM_Max = 0
  PWM_Min = 0
  Tamax = 0
End Sub

'***************************************************************************
Sub Drawpagestatics(Byval PageNum as Byte)
 Local X As Byte

 Text = Titel + Str(PageNum)
 Call DisplayLine(Text , 0 , 0 , Yellow , Blue)

 Select Case Page
  Case 0
   Text = "Start Display"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 1
   LCD_Rect 8 , 84 , 124 , 95 , 0 , Black                                       'Rahmen fr Akku Balken

   LCD_Rect 8 , 100 , 19 , 160 , 0 , Black                                      'Rahmen fr Vertikal Lenker
   LCD_Draw 20 , 130 , 22 , 130 , 0 , Black                                     'Vertikaler Balken, Mitteltick

   LCD_Draw 0 , 167 , 132 , 167 , 0 , Black                                     'Hintergrund der Fuzeile
   Text = "Ta:     PWM:"
   LCD_Print Text , 0 , 168 , 1 , 1 , 1 , Black , White

  Case 2
   Text = "Fehler bzw. Status"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 3
   Text = "Details"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

    Text = "C = Reset Ges.Km"
   Call DisplayLine(Text , 0 , 150 , Green , Black)

   Text = "SHIFT = Nick Nullen"
   Call DisplayLine(Text , 0 , 164 , White , Black)

  Case 4
   Text = "Min- / Max- Werte"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Reset"
   Call DisplayLine(Text , 0 , 164 , White , Black)

  Case 5
   Text = "Controller-Parameter"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Save EEPROM"
   Call DisplayLine(Text , 0 , 164 , White , Black)
   EditZeile = 1

  Case 6
   Text = "Sinussollwerte"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow
   Text = "SHIFT = Save EEPROM"
   Call DisplayLine(Text , 0 , 164 , White , Black)
   EditZeile = 1

  Case 7
   Text = "Rckdarst.Sinus"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 8
   Text = "Rckdarst.Main/Mot"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 9
   Text = "SD-DIR"
   X = Len(Text) * 6                                                            'Font size 1
   X = X / 2                                                                    'Mittig
   X = 66 - X
   LCD_Print Text , X , 9 , 1 , 1 , 1 , Black , Yellow

  Case 10
   LCD_Print "LOGGING" , 30 , 20 , 2 , 1 , 2 , Black , White
   LCD_Print "Close file by dis-" , 0 , 80 , 1 , 1 , 1 , Black , White
   LCD_Print "abling RUN while on" , 0 , 90 , 1 , 1 , 1 , Black , White
   LCD_Print "this page" , 0 , 100 , 1 , 1 , 1 , Black , White
   DateiAktuell = 0
 End Select
End Sub

'***************************************************************************
Sub PutEEpromData()
  Local n as Byte

  EStartkilometer = Startkilometer
  ENick_Offset = Nick_Offset
  For n = 1 to 12
    ESinus(n) = Sinus(n)
  Next
  EIBattMax = IBattMax
  Ep_faktor = P_faktor
  EI_faktor = I_faktor
  ED_faktor = D_faktor
  EMp_faktor = Mp_faktor
  EMv_faktor = Mv_faktor
  ERegelstrategie = Regelstrategie
  EPWMmax = PWMmax
  EVlimit = Vlimit
  EFwdAngle = FwdAngle
  ERevAngle = RevAngle
  EFanSwitchLevel = FanSwitchLevel
  Call Lcd_cls
  LCD_Print "Werte in" , 0 , 20 , 2 , 1 , 1 , Black , Red
  LCD_Print "EEPROM" , 0 , 40 , 2 , 1 , 1 , Black , Red
  LCD_Print "gespeichert" , 0 , 60 , 2 , 1 , 1 , Black , Red
  Wait 2
  Call GetEEpromData
  Call LCD_cls
  Call Drawpagestatics(Page)
End Sub

'***************************************************************************
Sub GetEEpromData()
  Local n as Byte

  Startkilometer = EStartkilometer
  Nick_Offset = ENick_Offset
  For n = 1 to 12
    Sinus(n) = ESinus(n)
  next
  IBattMax = EIBattMax
  P_faktor = EP_faktor
  I_faktor = EI_faktor
  D_faktor = ED_faktor
  Mp_faktor = EMp_faktor
  Mv_faktor = EMv_faktor
  Regelstrategie = ERegelstrategie
  PWMmax = EPWMmax
  VLimit = EVLimit
  FwdAngle = EFwdAngle
  RevAngle = ERevAngle
  FanSwitchLevel = EFanSwitchLevel
end sub

Sub InitEEpromData()
  Local NumHall As Byte
  Local SDummy as Single

  NumHall = 3
  Select Case NumHall
   Case 3
     ESinus(1) = 0
     ESinus(2) = 50
     ESinus(3) = 100
     ESinus(4) = 100
     ESinus(5) = 50
     ESinus(6) = 0
   Case 4
     ESinus(1) = 0
     ESinus(2) = 12
     ESinus(3) = 33
     ESinus(4) = 66
     ESinus(5) = 82
     ESinus(6) = 100
     ESinus(7) = 100
     ESinus(8) = 82
     ESinus(9) = 66
     ESinus(10) = 33
     ESinus(11) = 12
     ESinus(12) = 0
  End Select

  EIBattMax = 30               'A
  EP_faktor = 0.00123
  EI_faktor = 0.00456
  ED_faktor = 0.00789
  EMp_faktor = 0.00000
  EMv_faktor = 0.00000
  ERegelStrategie = 0
  EPWMmax = 245
  EVlimit = 125                '12,5 Kmh
  EFwdAngle = 4
  ERevAngle = 1
  EFanSwitchLevel = 55         '55 Celsius

  Call LCD_cls

  Text = "Read from EEprom.."
  Call DisplayLine(Text , 0 , 0 , Yellow , Blue)

  Sdummy = Estartkilometer
  Text = "StartKm " + Str(SDummy) + "  "
  Call DisplayLine(text , 0 , 10 , Black , White)

  Ldummy = ENick_Offset
  Text = "Nick_Offset " + Str(Ldummy)
  Call DisplayLine(text , 0 , 19 ,Black , White)

  Bdummy = ESinus(1)
  Text = "Sin " + Str(Bdummy) + "  "
  Bdummy = ESinus(2)
  Text = Text + Str(Bdummy) + "  "
  Bdummy = ESinus(3)
  Text = Text + Str(Bdummy) + "  "
  Bdummy = ESinus(4)
  Text = Text + Str(Bdummy)
  Call DisplayLine(text , 0 , 28 , Black , White)

  Bdummy = ESinus(5)
  Text = "Sin " + Str(Bdummy) + "  "
  Bdummy = ESinus(6)
  Text = Text + Str(Bdummy)
  Call DisplayLine(text , 0 , 37 ,Black , White)

  BDummy = EIBattMax
  Text = "IBattMax: " + Str(BDummy)
  Call DisplayLine(text , 0 , 46 ,Black , White)

  Sdummy = Ep_faktor
  Text = "P-Fakt: " + Str(Sdummy)
  Call DisplayLine(text , 0 , 55 ,Black , White)

  Sdummy = Ei_faktor
  Text = "I-Fakt: " + Str(Sdummy)
  Call DisplayLine(text , 0 , 64 ,Black , White)

  Sdummy = Ed_faktor
  Text = "D-Fakt: " + Str(Sdummy)
  Call DisplayLine(text , 0 , 73 ,Black , White)

  Sdummy = Emp_faktor
  Text = "MP-Fakt: " + Str(Sdummy)
  Call DisplayLine(text , 0 , 82 ,Black , White)

  Sdummy = Emv_faktor
  Text = "MV-Fakt: " + Str(Sdummy)
  Call DisplayLine(text , 0 , 91 ,Black , White)

  Bdummy = ERegelStrategie
  Text = "R-Strategie: " + Str(Bdummy) + "  "
  Call DisplayLine(text , 0 , 100 ,Black , White)

  Bdummy = EPWMMax
  Text = "PWMmax: " + Str(Bdummy) + "  "
  Call DisplayLine(text , 0 , 119 ,Black , White)

  Bdummy = EVLimit
  Text = "EVLimit: " + Str(Bdummy) + "  "
  Call DisplayLine(Text , 0 , 128 ,Black , White)

  Bdummy = EFwdAngle
  Text = "FwdAngle: " + Str(Bdummy) + "  "
  Call DisplayLine(Text , 0 , 137 ,Black , White)

  Bdummy = ERevAngle
  Text = "ERevAngle: " + Str(Bdummy) + "  "
  Call DisplayLine(Text , 0 , 146 ,Black , White)

  Bdummy = EFanSwitchLevel
  Text = "EFanSwLvl: " + Str(Bdummy) + "  "
  Call DisplayLine(Text , 0 , 155 ,Black , White)

  Text = "Weiter mit "Cancel""
  Call DisplayLine(Text , 0 , 165 ,Black , White)

  While Btn_Esc = 1: Wend
end sub

Sub SD_Init()
 If SD_Tristate = 0 Then Activate_SD_Bus
 Gbdriveerror = DriveInit()                                                     'Init MMC/SD Card

 if Gbdriveerror = 0 Then
   $Include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\CONFIG_AVR-DOS.bas"
   Bdummy = InitFileSystem(1)                                                   'Partition 1
 End If
end sub

'***************************************************************************
$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_display3000.bas"
$include "C:\Program Files (x86)\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_fonts.bas"

Colortable:
 Data 0