'****************Listrik01 LCD Display Steuerung Version 03 *****************
$hwstack = 256
$swstack = 256
$framesize = 128
$regfile = "m2561def.dat"                                                       'ATMEGA2561 CPU
const F_CPU = 16000000
$crystal = F_CPU

'( Siehe http://eleccelerator.com/fusecalc/fusecalc.php?chip=atmega2561
Fuse Bits:
BODLEVEL = Disabled
Ocden = Disabled
JTAGEN = Disabled
Spien = Enabled
WDTON = Disabled
EESAVE = Enabled
BOOTSZ = 4096W_1F000
BOOTRST = Disabled
CKDIV8 = Disabled
CKOUT = Disabled
Sut_cksel = Ext.Crystal:Osc_8.0- MHz,Startuptime 16KCK+65ms

Lockbits:
All disabled

LockBit , FuseBitLow , FuseBitHigh , FuseBitExtended
')
'$prog &HFF , &HFF , &HD1 , &HFF
'( ************ Display3000, D074 Modul mit Folientastatur ************
   ---------------------
 |                     |
 |  ----------------   |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |1|    |2|      |  |  1 = Pmotlinks
 |  |---------------|  |  2 = Zyklusdauer
 |                     |
 |          Up         | Taster
 |                     |  Up   : Edit: Zeile Aufwrts bzw. Digit inkrementieren
 |       Le Ent Rt     |  Dn   : Edit: Zeile Abwrts bzw. Digit dekrementieren
 |                     |  Le   : Blttern Rckwrts bzw. zeichen links
 |          Dn         |  Rt   : Blttern Vorwrts bzw. zeichen rechts
 |  Shift         Esc  |  Ent  : Edit : EditState bzw. Werte bernehmen
 |                     |  C    : (Cancel) Editieren abbrechen
 -----------------------  Shift: wenn...
                              (Page 1)    ==> Reset Tageskilometerzhler
                              (Page 3)    ==> Nulllage der Neigung speichern
                                                Vorher muss der Geber-Null
                                                ungefhr richtig eingestellt sein
                              (Page 4)    ==> Min-Maxwerte nullen
                              (Page 6..7) ==> Werte in EEPROM schreiben

 SD-Karte formatieren:
   FAT (ohne Zusatz) ==> FAT16
   32KB Zuordnungseinheiten

************ Display3000, D074 Modul mit Folientastatur ************

####################### Lcd -routines ######################################

Definition Of Used Ports And Pull Up Resistors.
We are using Port B for the SPI -communication to the LCD Display.

****** SPCR SPI CONTROL REGISTER ******
Max Frequenz erlaubt : viele MHz
Beispiel: 16MHz / 64 = 128 ==> 125KHz
Bit: 2    1    0
   SPI2X SPR1 SPR0 SCK Frequency
     0    0    0 Fosc /4
     0    0    1 fosc /16
     0    1    0 fosc /64
     0    1    1 fosc /128
     1    0    0 fosc/2   ==> doubles the clock rate
     1    0    1 fosc/8   ==> doubles the clock rate
     1    1    0 fosc/32  ==> doubles the clock rate
     1 1 1 fosc / 64 ==> doubles the clock rate

Bit2 = CPHA  CPHA: Clock Phase
Bit3 = CPOL  CPOL: Clock Polarity ==> 0 Rising Falling 1 Falling Rising

Bit4 = Mstr  Mstr : Master / Slave Select this Bit selects master Spi mode when
                  written to "1" , and slave Spi mode when written "0".
Bit5 = DORD  DORD: Data order when the DORD bit is "1", the LSB of the data word
                 is transmitted first.
Bit6 = SPE  SPE: SPI Enable
Bit7 = SPIE  SPIE: SPI Interrupt Enable

Bit      7654_3210
         |||| |||x Clockrate
         |||| ||x  Clockrate
         |||| |x   Phase = 0
         |||| x    Polarity = 0 Rising Falling (low), 1 Falling Rising(High)
         |||x      Master = Yes ==> 1
         ||x       Data Order ==> 0 Msb first, 1 LSB first
         |x        SPI Enable ==> 1
         x         Interrupt = Off ==> 0

****** SPSR SPI Status Register ******
0 = SPI2X
')

'A.0 = Input not used
'A.1 = Input not used
'A.2 = Input not used
'A.3 = Input not used
'A.4 = Input not used
'A.5 = Input not used
'A.6 = Input not used
'A.7 = Input not used
Ddra = &B0000_0000
Porta = &B1111_1111

'B.0 = CS for SD-Card. See "Config_MMC.bas" in program directory
'B.1 = Output for SCK
'B.2 = Output for MOSI
'B.3 = Input for MISO
'B.4 = Output for LCD
'B.5 = Output for LCD
'B.6 = Output for LCD
'B.7 is for display lighting....
Ddrb = &B1111_0111
Portb = &B1000_1000

'C.0 = not used
'C.1 = not used
'C.2 = Input for Keypad
'C.3 = Input for Keypad
'C.4 = Input for Keypad
'C.5 = Input for Keypad
'C.6 = Input for Keypad
'C.7 = Input for Keypad
Ddrc = &B0000_0000
Portc = &B1111_1111

'D.0 Output for I2C
'D.1 Output for I2C
'D.2 Input for RX1
'D.3 Output for TX1
'D.4 Input not used
'D.5 Input not used
'D.6 Input not used
'D.7 Input not used
Ddrd = &B0000_1000
Portd = &B1111_0111

'E.0 = Input for RX0
'E.1 = Output for TX0
'E.2 = Input not used
'E.3 = Input not used
'E.4 = Input not used
'E.5 = Input not used
'E.6 = Input not used
'E.7 = Input for Keypad
Ddre = &B0000_0010
Porte = &B1111_1101

'F.0 = Input not used
'F.1 = Input not used
'F.2 = Input not used
'F.3 = Input not used
'F.4 = Input not used
'F.5 = Output for SD-Card
'F.6 = Input not used
'F.7 = Output for SD-Card
Ddrf = &B1010_0000
Portf = &B0101_1111                                                             'all pull-up-Resistors turned on

'G.0 = Input not used
'G.1 = Input not used
'G.2 = Input not used
'G.3 = Input not used
'G.4 = Input not used
'G.5 = Input not used
'G.6 = Input not used
'G.7 = Input not used
Ddrg = &B0000_0000
Portg = &B1111_1111                                                             'all pull-up-Resistors turned on

'############################################################


Dim Mit_Acc_Nick As Long                                                        'Nick
Dim Mit_AccNick As Long
Dim Nick_Offset As Long
Dim Null_Nick As Long
Dim ADC_Nick As Long
Dim P_faktor As Single
Dim I_faktor As Single
Dim D_faktor As Single
Dim ErrorWord As Word
Dim ValidMsgCtr as Word
Dim n as Byte
Dim IBattMax as Byte
Dim Sensor_OK_count as Byte
Dim AntriebAus as Byte
Dim Mp_faktor As Single                                                         'Lastabhngige Regelungsverstrkung
Dim Mv_faktor As Single                                                         'Geschwindigkeitsabhngige Regelungsverstrkung
Dim Sinus(12) As Byte
Dim RueckSinus(12) As Byte
Dim Akkustand As Byte
Dim Kmh As Integer
Dim Kilometer As Integer
Dim Meter As Integer
Dim FanSwitchLevel as Byte

Dim Gyro_nick As Long
Dim K_sum As Single
Dim K_summax As Single
Dim K_summin As Single
Dim Tii as Integer
Dim Fwdangle As Byte
Dim Revangle As Byte
Dim Rfwdangle As Byte
Dim Rrevangle As Byte
Dim Bdummy As Byte
Dim Bdummy1 As Byte
Dim Bdummy2 As Byte
Dim Bdummy3 As Byte
Dim Bdummy4 As Byte
Dim BCC as Byte                                                                 'nur fr COM In
Dim Singdummy As Single
Dim Ldummy As Long
Dim Idummy As Integer
Dim Idummy1 As Integer
Dim B as Byte
Dim KmhMax As Integer
Dim KmhMin As Integer
Dim IBatt as Integer                                                            'mA
Dim I As Single                                                                 'A
Dim Imax As Integer                                                             'mA
Dim Imin As Integer                                                             'mA
Dim UBatt As Long                                                               'mV
Dim Umax As Integer                                                             'mV
Dim Umin As Integer                                                             'mV
Dim U As Single                                                                 'V
Dim PWM_Max As Integer
Dim PWM_Min As Integer
Dim PWMmax As Byte
Dim Go as Byte
Dim Page As Byte
Dim EditZeile As Byte
Dim Utext As String * 22
Dim Itext As String * 22
Dim Ltext As String * 22
Dim L1 As Byte
Dim L2 As Byte
Dim Text As String * 22
Dim Farbe As Word
Dim X1 As Byte
Dim Y1 As Byte
Dim X2 As Byte
Dim Y2 As Byte
Dim Startkilometer As Single
Dim Ta As Integer
Dim Tamax As Integer
Dim Ya As Byte
Dim Xa As Byte
Dim Lname As Long
Dim Dateiname As String * 12
Dim Dateilaenge As Long
Dim DateiAktuell As Byte
Dim Loopcount As Word
Dim Aloopcount As Word
Dim Logtext As String * 255
Dim Zeit As String * 8
Dim FussSchalter As Byte
Dim FussCount As Byte
Dim Dummybyte As Byte
Dim ErrorStr(17) As String * 22
Dim NotAusStr(8) As String * 22
Dim Errorindex As Byte
Dim KK_Temperatur as Integer
Dim ComErrMainCtrl As Word
Dim ComErrDisplayCtrl As Word
Dim Akkuverbraucht As Integer
Dim Startup As Word
Dim FirstRun as Byte
Dim MotorPosition as Byte
Dim IactMain as Integer
Dim VLimit as Integer
Dim Regelstrategie as Byte
Dim RueckSollRichtung as Byte
Dim RueckSollSpeed as Byte
Dim NotausGrund As Byte
Dim StartupStr(10) As String * 22
Dim PrefixLen As Dword
Dim EditStr as String * 22
Dim EditState as Byte                                                           '0 = Select Line , 1 = Sel / Mod Decimal
Dim EditSpalte as Byte
Dim EditChar as String * 1
Dim TTempStr as string * 22
Dim OK_Str as String * 19
Dim Error_Str as String * 19

Config Com2 = 57600 , Synchrone = 0 , Parity = None , Stopbits = 1 , _
              Databits = 8 , Clockpol = 0
OPEN "com2:" for binary as #1

Enable Interrupts

do
  Printbin #1 , 22; 1
Loop
